/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 28 "parser.y"


#define YYDEBUG 0

#define PARSER_VERSION_STRING "parser_version_3"

#include <stdlib.h>
#include <termios.h>
#include <sys/types.h>
#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <sys/stat.h>                    /* structure stat       */
#include <unistd.h>                      /* prototype for stat() */
#include <sys/wait.h>
#include <signal.h>
#include <stdarg.h>
#include <pwd.h>
#include <syslog.h>
#include <string.h>
#include <errno.h>
#include <assert.h>
#ifdef __linux__
#include <mntent.h>
#endif

#include "dosemu_config.h"
#include "emu.h"
#ifdef X86_EMULATOR
#include "cpu-emu.h"
#endif
#include "disks.h"
#include "port.h"
#define allow_io	port_allow_io
#include "mmio_tracing.h"
#include "lpt.h"
#include "video.h"
#include "vc.h"
#include "mouse.h"
#include "serial.h"
#include "timers.h"
#include "keyboard/keymaps.h"
#include "keyboard/keyb_server.h"
#include "translate/dosemu_charset.h"
#include "memory.h"
#include "mapping.h"
#include "utilities.h"
#include "aspi.h"
#include "int.h"
#include "pktdrvr.h"
#include "redirect.h"
#include "iodev.h" /* for TM_BIOS / TM_PIT / TM_LINUX */

#define USERVAR_PREF	"dosemu_"

static serial_t *sptr;
static serial_t nullser;
static mouse_t *mptr = &config.mouse;
static int c_ser = 0;

static struct disk *dptr;
static struct disk nulldisk;
#define c_hdisks config.hdisks
#define c_fdisks config.fdisks
static int skipped_disks;

static struct printer nullprt;
static struct printer *pptr = &nullprt;
static int c_printers = 0;

static int ports_permission = IO_RDWR;
static unsigned int ports_ormask = 0;
static unsigned int ports_andmask = 0xFFFF;
static unsigned int portspeed = 0;
static char dev_name[255]= "";

static int errors = 0;
static int warnings = 0;
static int priv_lvl = 0;


static char *file_being_parsed;

			/* this to ensure we are parsing a new style */
static int parser_version_3_style_used = 0;
#define CONFNAME_V3USED "version_3_style_used"

	/* local procedures */

static void start_ports(void);
static void start_mouse(void);
static void stop_mouse(void);
static void start_debug(void);
static void start_video(void);
static void stop_video(void);
static void set_vesamodes(int width, int height, int color_bits);
static int detect_vbios_seg(void);
static int detect_vbios_size(void);
static void stop_ttylocks(void);
static void start_serial(void);
static void stop_serial(void);
static void start_printer(void);
static void stop_printer(void);
static void start_keyboard(void);
static void keytable_start(char *layout);
static void keytable_stop(void);
static void keyb_layout(char *layout);
static void dump_keytables_to_file(char *name);
static void stop_terminal(void);
static void start_disk(void);
static void do_part(char *);
static void start_floppy(void);
static void stop_disk(int token);
static void start_vnet(char *);
static FILE* open_file(const char* filename);
static void close_file(FILE* file);
static void set_irq_value(int bits, int i1);
static void set_irq_range(int bits, int i1, int i2);
static int undefine_config_variable(const char *name);
static void check_user_var(char *name);
static char *run_shell(char *command);
static int for_each_handling(int loopid, char *varname, char *delim, char *list);
static void handle_features(int which, int value);
static void set_joy_device(char *devstring);
static int parse_timemode(const char *);
static void set_hdimage(struct disk *dptr, char *name);
static void set_drive_c(void);
static void set_default_drives(void);
static void set_dosemu_drive(void);
static void set_hostfs_drives(char *drivespec);

#define TOF(x) ( x.type == TYPE_REAL ? x.value.r : x.value.i )
#define V_VAL(x,y,z) \
do { x.type = y.type; if (x.type == TYPE_REAL) x.value.r = (z); \
      else x.value.i = (z); } \
while (0)

	/* variables in lexer.l */




	/* for unicode keyboard plugin */
static void keyb_mod(int wich, t_keysym keynum, int unicode);
static void dump_keytable_part(FILE *f, t_keysym *map, int size);

enum {
	TYPE_NONE,
	TYPE_INTEGER,
	TYPE_BOOLEAN,
	TYPE_REAL
} _type;


#line 227 "parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_INTEGER = 3,                    /* INTEGER  */
  YYSYMBOL_L_OFF = 4,                      /* L_OFF  */
  YYSYMBOL_L_ON = 5,                       /* L_ON  */
  YYSYMBOL_L_AUTO = 6,                     /* L_AUTO  */
  YYSYMBOL_L_YES = 7,                      /* L_YES  */
  YYSYMBOL_L_NO = 8,                       /* L_NO  */
  YYSYMBOL_CHIPSET_TYPE = 9,               /* CHIPSET_TYPE  */
  YYSYMBOL_REAL = 10,                      /* REAL  */
  YYSYMBOL_STRING = 11,                    /* STRING  */
  YYSYMBOL_VARIABLE = 12,                  /* VARIABLE  */
  YYSYMBOL_EXPRTEST = 13,                  /* EXPRTEST  */
  YYSYMBOL_INTCAST = 14,                   /* INTCAST  */
  YYSYMBOL_REALCAST = 15,                  /* REALCAST  */
  YYSYMBOL_AND_OP = 16,                    /* AND_OP  */
  YYSYMBOL_OR_OP = 17,                     /* OR_OP  */
  YYSYMBOL_XOR_OP = 18,                    /* XOR_OP  */
  YYSYMBOL_SHR_OP = 19,                    /* SHR_OP  */
  YYSYMBOL_SHL_OP = 20,                    /* SHL_OP  */
  YYSYMBOL_NOT_OP = 21,                    /* NOT_OP  */
  YYSYMBOL_EQ_OP = 22,                     /* EQ_OP  */
  YYSYMBOL_GE_OP = 23,                     /* GE_OP  */
  YYSYMBOL_LE_OP = 24,                     /* LE_OP  */
  YYSYMBOL_25_ = 25,                       /* '='  */
  YYSYMBOL_26_ = 26,                       /* '<'  */
  YYSYMBOL_27_ = 27,                       /* '>'  */
  YYSYMBOL_NEQ_OP = 28,                    /* NEQ_OP  */
  YYSYMBOL_STR_EQ_OP = 29,                 /* STR_EQ_OP  */
  YYSYMBOL_STR_NEQ_OP = 30,                /* STR_NEQ_OP  */
  YYSYMBOL_L_AND_OP = 31,                  /* L_AND_OP  */
  YYSYMBOL_L_OR_OP = 32,                   /* L_OR_OP  */
  YYSYMBOL_33_ = 33,                       /* '+'  */
  YYSYMBOL_34_ = 34,                       /* '-'  */
  YYSYMBOL_35_ = 35,                       /* '*'  */
  YYSYMBOL_36_ = 36,                       /* '/'  */
  YYSYMBOL_UMINUS = 37,                    /* UMINUS  */
  YYSYMBOL_UPLUS = 38,                     /* UPLUS  */
  YYSYMBOL_BIT_NOT_OP = 39,                /* BIT_NOT_OP  */
  YYSYMBOL_STRLEN = 40,                    /* STRLEN  */
  YYSYMBOL_STRTOL = 41,                    /* STRTOL  */
  YYSYMBOL_STRNCMP = 42,                   /* STRNCMP  */
  YYSYMBOL_STRCAT = 43,                    /* STRCAT  */
  YYSYMBOL_STRPBRK = 44,                   /* STRPBRK  */
  YYSYMBOL_STRSPLIT = 45,                  /* STRSPLIT  */
  YYSYMBOL_STRCHR = 46,                    /* STRCHR  */
  YYSYMBOL_STRRCHR = 47,                   /* STRRCHR  */
  YYSYMBOL_STRSTR = 48,                    /* STRSTR  */
  YYSYMBOL_STRDEL = 49,                    /* STRDEL  */
  YYSYMBOL_STRSPN = 50,                    /* STRSPN  */
  YYSYMBOL_STRCSPN = 51,                   /* STRCSPN  */
  YYSYMBOL_SHELL = 52,                     /* SHELL  */
  YYSYMBOL_DEFINED = 53,                   /* DEFINED  */
  YYSYMBOL_DEFINE = 54,                    /* DEFINE  */
  YYSYMBOL_UNDEF = 55,                     /* UNDEF  */
  YYSYMBOL_IFSTATEMENT = 56,               /* IFSTATEMENT  */
  YYSYMBOL_WHILESTATEMENT = 57,            /* WHILESTATEMENT  */
  YYSYMBOL_FOREACHSTATEMENT = 58,          /* FOREACHSTATEMENT  */
  YYSYMBOL_CHECKUSERVAR = 59,              /* CHECKUSERVAR  */
  YYSYMBOL_FASTFLOPPY = 60,                /* FASTFLOPPY  */
  YYSYMBOL_HOGTHRESH = 61,                 /* HOGTHRESH  */
  YYSYMBOL_SPEAKER = 62,                   /* SPEAKER  */
  YYSYMBOL_IPXSUPPORT = 63,                /* IPXSUPPORT  */
  YYSYMBOL_IPXNETWORK = 64,                /* IPXNETWORK  */
  YYSYMBOL_NOVELLHACK = 65,                /* NOVELLHACK  */
  YYSYMBOL_ETHDEV = 66,                    /* ETHDEV  */
  YYSYMBOL_TAPDEV = 67,                    /* TAPDEV  */
  YYSYMBOL_VDESWITCH = 68,                 /* VDESWITCH  */
  YYSYMBOL_SLIRPARGS = 69,                 /* SLIRPARGS  */
  YYSYMBOL_VNET = 70,                      /* VNET  */
  YYSYMBOL_DEBUG = 71,                     /* DEBUG  */
  YYSYMBOL_MOUSE = 72,                     /* MOUSE  */
  YYSYMBOL_SERIAL = 73,                    /* SERIAL  */
  YYSYMBOL_COM = 74,                       /* COM  */
  YYSYMBOL_KEYBOARD = 75,                  /* KEYBOARD  */
  YYSYMBOL_TERMINAL = 76,                  /* TERMINAL  */
  YYSYMBOL_VIDEO = 77,                     /* VIDEO  */
  YYSYMBOL_EMURETRACE = 78,                /* EMURETRACE  */
  YYSYMBOL_TIMER = 79,                     /* TIMER  */
  YYSYMBOL_MATHCO = 80,                    /* MATHCO  */
  YYSYMBOL_CPU = 81,                       /* CPU  */
  YYSYMBOL_CPUSPEED = 82,                  /* CPUSPEED  */
  YYSYMBOL_RDTSC = 83,                     /* RDTSC  */
  YYSYMBOL_BOOTDRIVE = 84,                 /* BOOTDRIVE  */
  YYSYMBOL_SWAP_BOOTDRIVE = 85,            /* SWAP_BOOTDRIVE  */
  YYSYMBOL_L_XMS = 86,                     /* L_XMS  */
  YYSYMBOL_L_DPMI = 87,                    /* L_DPMI  */
  YYSYMBOL_DPMI_LIN_RSV_BASE = 88,         /* DPMI_LIN_RSV_BASE  */
  YYSYMBOL_DPMI_LIN_RSV_SIZE = 89,         /* DPMI_LIN_RSV_SIZE  */
  YYSYMBOL_PM_DOS_API = 90,                /* PM_DOS_API  */
  YYSYMBOL_NO_NULL_CHECKS = 91,            /* NO_NULL_CHECKS  */
  YYSYMBOL_PORTS = 92,                     /* PORTS  */
  YYSYMBOL_DISK = 93,                      /* DISK  */
  YYSYMBOL_DOSMEM = 94,                    /* DOSMEM  */
  YYSYMBOL_EXT_MEM = 95,                   /* EXT_MEM  */
  YYSYMBOL_L_EMS = 96,                     /* L_EMS  */
  YYSYMBOL_UMB_A0 = 97,                    /* UMB_A0  */
  YYSYMBOL_UMB_B0 = 98,                    /* UMB_B0  */
  YYSYMBOL_UMB_F0 = 99,                    /* UMB_F0  */
  YYSYMBOL_EMS_SIZE = 100,                 /* EMS_SIZE  */
  YYSYMBOL_EMS_FRAME = 101,                /* EMS_FRAME  */
  YYSYMBOL_EMS_UMA_PAGES = 102,            /* EMS_UMA_PAGES  */
  YYSYMBOL_EMS_CONV_PAGES = 103,           /* EMS_CONV_PAGES  */
  YYSYMBOL_TTYLOCKS = 104,                 /* TTYLOCKS  */
  YYSYMBOL_L_SOUND = 105,                  /* L_SOUND  */
  YYSYMBOL_L_SND_OSS = 106,                /* L_SND_OSS  */
  YYSYMBOL_L_JOYSTICK = 107,               /* L_JOYSTICK  */
  YYSYMBOL_FILE_LOCK_LIMIT = 108,          /* FILE_LOCK_LIMIT  */
  YYSYMBOL_ABORT = 109,                    /* ABORT  */
  YYSYMBOL_WARN = 110,                     /* WARN  */
  YYSYMBOL_ERROR = 111,                    /* ERROR  */
  YYSYMBOL_L_FLOPPY = 112,                 /* L_FLOPPY  */
  YYSYMBOL_EMUSYS = 113,                   /* EMUSYS  */
  YYSYMBOL_L_X = 114,                      /* L_X  */
  YYSYMBOL_L_SDL = 115,                    /* L_SDL  */
  YYSYMBOL_DOSEMUMAP = 116,                /* DOSEMUMAP  */
  YYSYMBOL_LOGBUFSIZE = 117,               /* LOGBUFSIZE  */
  YYSYMBOL_LOGFILESIZE = 118,              /* LOGFILESIZE  */
  YYSYMBOL_MAPPINGDRIVER = 119,            /* MAPPINGDRIVER  */
  YYSYMBOL_LFN_SUPPORT = 120,              /* LFN_SUPPORT  */
  YYSYMBOL_FFS_REDIR = 121,                /* FFS_REDIR  */
  YYSYMBOL_SET_INT_HOOKS = 122,            /* SET_INT_HOOKS  */
  YYSYMBOL_TRACE_IRETS = 123,              /* TRACE_IRETS  */
  YYSYMBOL_FINT_REVECT = 124,              /* FINT_REVECT  */
  YYSYMBOL_EMULATED = 125,                 /* EMULATED  */
  YYSYMBOL_NATIVE = 126,                   /* NATIVE  */
  YYSYMBOL_CPUEMU = 127,                   /* CPUEMU  */
  YYSYMBOL_CPU_VM = 128,                   /* CPU_VM  */
  YYSYMBOL_CPU_VM_DPMI = 129,              /* CPU_VM_DPMI  */
  YYSYMBOL_VM86 = 130,                     /* VM86  */
  YYSYMBOL_KVM = 131,                      /* KVM  */
  YYSYMBOL_RAWKEYBOARD = 132,              /* RAWKEYBOARD  */
  YYSYMBOL_PRESTROKE = 133,                /* PRESTROKE  */
  YYSYMBOL_KEYTABLE = 134,                 /* KEYTABLE  */
  YYSYMBOL_SHIFT_MAP = 135,                /* SHIFT_MAP  */
  YYSYMBOL_ALT_MAP = 136,                  /* ALT_MAP  */
  YYSYMBOL_NUMPAD_MAP = 137,               /* NUMPAD_MAP  */
  YYSYMBOL_DUMP = 138,                     /* DUMP  */
  YYSYMBOL_LAYOUT = 139,                   /* LAYOUT  */
  YYSYMBOL_DGRAVE = 140,                   /* DGRAVE  */
  YYSYMBOL_DACUTE = 141,                   /* DACUTE  */
  YYSYMBOL_DCIRCUM = 142,                  /* DCIRCUM  */
  YYSYMBOL_DTILDE = 143,                   /* DTILDE  */
  YYSYMBOL_DBREVE = 144,                   /* DBREVE  */
  YYSYMBOL_DABOVED = 145,                  /* DABOVED  */
  YYSYMBOL_DDIARES = 146,                  /* DDIARES  */
  YYSYMBOL_DABOVER = 147,                  /* DABOVER  */
  YYSYMBOL_DDACUTE = 148,                  /* DDACUTE  */
  YYSYMBOL_DCEDILLA = 149,                 /* DCEDILLA  */
  YYSYMBOL_DIOTA = 150,                    /* DIOTA  */
  YYSYMBOL_DOGONEK = 151,                  /* DOGONEK  */
  YYSYMBOL_DCARON = 152,                   /* DCARON  */
  YYSYMBOL_NETWORK = 153,                  /* NETWORK  */
  YYSYMBOL_PKTDRIVER = 154,                /* PKTDRIVER  */
  YYSYMBOL_NE2K = 155,                     /* NE2K  */
  YYSYMBOL_DIRECTORY = 156,                /* DIRECTORY  */
  YYSYMBOL_NAMESTUB = 157,                 /* NAMESTUB  */
  YYSYMBOL_BINARY = 158,                   /* BINARY  */
  YYSYMBOL_BASE = 159,                     /* BASE  */
  YYSYMBOL_IRQ = 160,                      /* IRQ  */
  YYSYMBOL_DEVICE = 161,                   /* DEVICE  */
  YYSYMBOL_CHARSET = 162,                  /* CHARSET  */
  YYSYMBOL_BAUDRATE = 163,                 /* BAUDRATE  */
  YYSYMBOL_VIRTUAL = 164,                  /* VIRTUAL  */
  YYSYMBOL_VMODEM = 165,                   /* VMODEM  */
  YYSYMBOL_PSEUDO = 166,                   /* PSEUDO  */
  YYSYMBOL_RTSCTS = 167,                   /* RTSCTS  */
  YYSYMBOL_LOWLAT = 168,                   /* LOWLAT  */
  YYSYMBOL_PCCOM = 169,                    /* PCCOM  */
  YYSYMBOL_MICROSOFT = 170,                /* MICROSOFT  */
  YYSYMBOL_MS3BUTTON = 171,                /* MS3BUTTON  */
  YYSYMBOL_LOGITECH = 172,                 /* LOGITECH  */
  YYSYMBOL_MMSERIES = 173,                 /* MMSERIES  */
  YYSYMBOL_MOUSEMAN = 174,                 /* MOUSEMAN  */
  YYSYMBOL_HITACHI = 175,                  /* HITACHI  */
  YYSYMBOL_MOUSESYSTEMS = 176,             /* MOUSESYSTEMS  */
  YYSYMBOL_BUSMOUSE = 177,                 /* BUSMOUSE  */
  YYSYMBOL_PS2 = 178,                      /* PS2  */
  YYSYMBOL_IMPS2 = 179,                    /* IMPS2  */
  YYSYMBOL_INTERNALDRIVER = 180,           /* INTERNALDRIVER  */
  YYSYMBOL_EMULATE3BUTTONS = 181,          /* EMULATE3BUTTONS  */
  YYSYMBOL_CLEARDTR = 182,                 /* CLEARDTR  */
  YYSYMBOL_L_DISPLAY = 183,                /* L_DISPLAY  */
  YYSYMBOL_L_TITLE = 184,                  /* L_TITLE  */
  YYSYMBOL_X_TITLE_SHOW_APPNAME = 185,     /* X_TITLE_SHOW_APPNAME  */
  YYSYMBOL_ICON_NAME = 186,                /* ICON_NAME  */
  YYSYMBOL_X_BLINKRATE = 187,              /* X_BLINKRATE  */
  YYSYMBOL_X_SHARECMAP = 188,              /* X_SHARECMAP  */
  YYSYMBOL_X_MITSHM = 189,                 /* X_MITSHM  */
  YYSYMBOL_X_FONT = 190,                   /* X_FONT  */
  YYSYMBOL_X_FIXED_ASPECT = 191,           /* X_FIXED_ASPECT  */
  YYSYMBOL_X_ASPECT_43 = 192,              /* X_ASPECT_43  */
  YYSYMBOL_X_LIN_FILT = 193,               /* X_LIN_FILT  */
  YYSYMBOL_X_BILIN_FILT = 194,             /* X_BILIN_FILT  */
  YYSYMBOL_X_MODE13FACT = 195,             /* X_MODE13FACT  */
  YYSYMBOL_X_WINSIZE = 196,                /* X_WINSIZE  */
  YYSYMBOL_X_GAMMA = 197,                  /* X_GAMMA  */
  YYSYMBOL_X_FULLSCREEN = 198,             /* X_FULLSCREEN  */
  YYSYMBOL_VGAEMU_MEMSIZE = 199,           /* VGAEMU_MEMSIZE  */
  YYSYMBOL_VESAMODE = 200,                 /* VESAMODE  */
  YYSYMBOL_X_LFB = 201,                    /* X_LFB  */
  YYSYMBOL_X_PM_INTERFACE = 202,           /* X_PM_INTERFACE  */
  YYSYMBOL_X_MGRAB_KEY = 203,              /* X_MGRAB_KEY  */
  YYSYMBOL_X_BACKGROUND_PAUSE = 204,       /* X_BACKGROUND_PAUSE  */
  YYSYMBOL_SDL_HWREND = 205,               /* SDL_HWREND  */
  YYSYMBOL_SDL_FONTS = 206,                /* SDL_FONTS  */
  YYSYMBOL_VGA = 207,                      /* VGA  */
  YYSYMBOL_MGA = 208,                      /* MGA  */
  YYSYMBOL_CGA = 209,                      /* CGA  */
  YYSYMBOL_EGA = 210,                      /* EGA  */
  YYSYMBOL_NONE = 211,                     /* NONE  */
  YYSYMBOL_CONSOLE = 212,                  /* CONSOLE  */
  YYSYMBOL_GRAPHICS = 213,                 /* GRAPHICS  */
  YYSYMBOL_CHIPSET = 214,                  /* CHIPSET  */
  YYSYMBOL_FULLREST = 215,                 /* FULLREST  */
  YYSYMBOL_PARTREST = 216,                 /* PARTREST  */
  YYSYMBOL_MEMSIZE = 217,                  /* MEMSIZE  */
  YYSYMBOL_VBIOS_SIZE_TOK = 218,           /* VBIOS_SIZE_TOK  */
  YYSYMBOL_VBIOS_SEG = 219,                /* VBIOS_SEG  */
  YYSYMBOL_VGAEMUBIOS_FILE = 220,          /* VGAEMUBIOS_FILE  */
  YYSYMBOL_VBIOS_FILE = 221,               /* VBIOS_FILE  */
  YYSYMBOL_VBIOS_COPY = 222,               /* VBIOS_COPY  */
  YYSYMBOL_VBIOS_MMAP = 223,               /* VBIOS_MMAP  */
  YYSYMBOL_DUALMON = 224,                  /* DUALMON  */
  YYSYMBOL_VBIOS_POST = 225,               /* VBIOS_POST  */
  YYSYMBOL_VGA_FONTS = 226,                /* VGA_FONTS  */
  YYSYMBOL_FORCE_VT_SWITCH = 227,          /* FORCE_VT_SWITCH  */
  YYSYMBOL_PCI = 228,                      /* PCI  */
  YYSYMBOL_COLOR = 229,                    /* COLOR  */
  YYSYMBOL_ESCCHAR = 230,                  /* ESCCHAR  */
  YYSYMBOL_XTERM_TITLE = 231,              /* XTERM_TITLE  */
  YYSYMBOL_SIZE = 232,                     /* SIZE  */
  YYSYMBOL_IO = 233,                       /* IO  */
  YYSYMBOL_PORT = 234,                     /* PORT  */
  YYSYMBOL_CONFIG = 235,                   /* CONFIG  */
  YYSYMBOL_READ = 236,                     /* READ  */
  YYSYMBOL_WRITE = 237,                    /* WRITE  */
  YYSYMBOL_KEYB = 238,                     /* KEYB  */
  YYSYMBOL_PRINTER = 239,                  /* PRINTER  */
  YYSYMBOL_WARNING = 240,                  /* WARNING  */
  YYSYMBOL_GENERAL = 241,                  /* GENERAL  */
  YYSYMBOL_HARDWARE = 242,                 /* HARDWARE  */
  YYSYMBOL_L_IPC = 243,                    /* L_IPC  */
  YYSYMBOL_SOUND = 244,                    /* SOUND  */
  YYSYMBOL_TRACE = 245,                    /* TRACE  */
  YYSYMBOL_CLEAR = 246,                    /* CLEAR  */
  YYSYMBOL_TRACE_MMIO = 247,               /* TRACE_MMIO  */
  YYSYMBOL_UEXEC = 248,                    /* UEXEC  */
  YYSYMBOL_LPATHS = 249,                   /* LPATHS  */
  YYSYMBOL_HDRIVES = 250,                  /* HDRIVES  */
  YYSYMBOL_LPT = 251,                      /* LPT  */
  YYSYMBOL_COMMAND = 252,                  /* COMMAND  */
  YYSYMBOL_TIMEOUT = 253,                  /* TIMEOUT  */
  YYSYMBOL_L_FILE = 254,                   /* L_FILE  */
  YYSYMBOL_L_PARTITION = 255,              /* L_PARTITION  */
  YYSYMBOL_WHOLEDISK = 256,                /* WHOLEDISK  */
  YYSYMBOL_SECTORS = 257,                  /* SECTORS  */
  YYSYMBOL_CYLINDERS = 258,                /* CYLINDERS  */
  YYSYMBOL_TRACKS = 259,                   /* TRACKS  */
  YYSYMBOL_HEADS = 260,                    /* HEADS  */
  YYSYMBOL_OFFSET = 261,                   /* OFFSET  */
  YYSYMBOL_HDIMAGE = 262,                  /* HDIMAGE  */
  YYSYMBOL_HDTYPE1 = 263,                  /* HDTYPE1  */
  YYSYMBOL_HDTYPE2 = 264,                  /* HDTYPE2  */
  YYSYMBOL_HDTYPE9 = 265,                  /* HDTYPE9  */
  YYSYMBOL_DISKCYL4096 = 266,              /* DISKCYL4096  */
  YYSYMBOL_THREEINCH = 267,                /* THREEINCH  */
  YYSYMBOL_THREEINCH_720 = 268,            /* THREEINCH_720  */
  YYSYMBOL_THREEINCH_2880 = 269,           /* THREEINCH_2880  */
  YYSYMBOL_FIVEINCH = 270,                 /* FIVEINCH  */
  YYSYMBOL_FIVEINCH_360 = 271,             /* FIVEINCH_360  */
  YYSYMBOL_READONLY = 272,                 /* READONLY  */
  YYSYMBOL_BOOT = 273,                     /* BOOT  */
  YYSYMBOL_DEFAULT_DRIVES = 274,           /* DEFAULT_DRIVES  */
  YYSYMBOL_SKIP_DRIVES = 275,              /* SKIP_DRIVES  */
  YYSYMBOL_RDONLY = 276,                   /* RDONLY  */
  YYSYMBOL_WRONLY = 277,                   /* WRONLY  */
  YYSYMBOL_RDWR = 278,                     /* RDWR  */
  YYSYMBOL_ORMASK = 279,                   /* ORMASK  */
  YYSYMBOL_ANDMASK = 280,                  /* ANDMASK  */
  YYSYMBOL_RANGE = 281,                    /* RANGE  */
  YYSYMBOL_FAST = 282,                     /* FAST  */
  YYSYMBOL_SLOW = 283,                     /* SLOW  */
  YYSYMBOL_SILLYINT = 284,                 /* SILLYINT  */
  YYSYMBOL_USE_SIGIO = 285,                /* USE_SIGIO  */
  YYSYMBOL_HARDWARE_RAM = 286,             /* HARDWARE_RAM  */
  YYSYMBOL_SB_BASE = 287,                  /* SB_BASE  */
  YYSYMBOL_SB_IRQ = 288,                   /* SB_IRQ  */
  YYSYMBOL_SB_DMA = 289,                   /* SB_DMA  */
  YYSYMBOL_SB_HDMA = 290,                  /* SB_HDMA  */
  YYSYMBOL_MPU_BASE = 291,                 /* MPU_BASE  */
  YYSYMBOL_MPU_IRQ = 292,                  /* MPU_IRQ  */
  YYSYMBOL_MPU_IRQ_MT32 = 293,             /* MPU_IRQ_MT32  */
  YYSYMBOL_MIDI_SYNTH = 294,               /* MIDI_SYNTH  */
  YYSYMBOL_SOUND_DRIVER = 295,             /* SOUND_DRIVER  */
  YYSYMBOL_MIDI_DRIVER = 296,              /* MIDI_DRIVER  */
  YYSYMBOL_MUNT_ROMS = 297,                /* MUNT_ROMS  */
  YYSYMBOL_OPL2LPT_DEV = 298,              /* OPL2LPT_DEV  */
  YYSYMBOL_OPL2LPT_TYPE = 299,             /* OPL2LPT_TYPE  */
  YYSYMBOL_SND_PLUGIN_PARAMS = 300,        /* SND_PLUGIN_PARAMS  */
  YYSYMBOL_PCM_HPF = 301,                  /* PCM_HPF  */
  YYSYMBOL_MIDI_FILE = 302,                /* MIDI_FILE  */
  YYSYMBOL_WAV_FILE = 303,                 /* WAV_FILE  */
  YYSYMBOL_CDROM = 304,                    /* CDROM  */
  YYSYMBOL_ASPI = 305,                     /* ASPI  */
  YYSYMBOL_DEVICETYPE = 306,               /* DEVICETYPE  */
  YYSYMBOL_TARGET = 307,                   /* TARGET  */
  YYSYMBOL_FEATURE = 308,                  /* FEATURE  */
  YYSYMBOL_JOYSTICK = 309,                 /* JOYSTICK  */
  YYSYMBOL_JOY_DEVICE = 310,               /* JOY_DEVICE  */
  YYSYMBOL_JOY_DOS_MIN = 311,              /* JOY_DOS_MIN  */
  YYSYMBOL_JOY_DOS_MAX = 312,              /* JOY_DOS_MAX  */
  YYSYMBOL_JOY_GRANULARITY = 313,          /* JOY_GRANULARITY  */
  YYSYMBOL_JOY_LATENCY = 314,              /* JOY_LATENCY  */
  YYSYMBOL_CLI_TIMEOUT = 315,              /* CLI_TIMEOUT  */
  YYSYMBOL_TIMEMODE = 316,                 /* TIMEMODE  */
  YYSYMBOL_UNICODE = 317,                  /* UNICODE  */
  YYSYMBOL_SHIFT_ALT_MAP = 318,            /* SHIFT_ALT_MAP  */
  YYSYMBOL_CTRL_MAP = 319,                 /* CTRL_MAP  */
  YYSYMBOL_CTRL_ALT_MAP = 320,             /* CTRL_ALT_MAP  */
  YYSYMBOL_INTERNAL = 321,                 /* INTERNAL  */
  YYSYMBOL_EXTERNAL = 322,                 /* EXTERNAL  */
  YYSYMBOL_323_ = 323,                     /* ';'  */
  YYSYMBOL_324_ = 324,                     /* '{'  */
  YYSYMBOL_325_ = 325,                     /* '}'  */
  YYSYMBOL_326_ = 326,                     /* '('  */
  YYSYMBOL_327_ = 327,                     /* ')'  */
  YYSYMBOL_328_ = 328,                     /* ','  */
  YYSYMBOL_YYACCEPT = 329,                 /* $accept  */
  YYSYMBOL_lines = 330,                    /* lines  */
  YYSYMBOL_optdelim = 331,                 /* optdelim  */
  YYSYMBOL_line = 332,                     /* line  */
  YYSYMBOL_333_1 = 333,                    /* $@1  */
  YYSYMBOL_334_2 = 334,                    /* $@2  */
  YYSYMBOL_335_3 = 335,                    /* $@3  */
  YYSYMBOL_336_4 = 336,                    /* $@4  */
  YYSYMBOL_337_5 = 337,                    /* $@5  */
  YYSYMBOL_338_6 = 338,                    /* $@6  */
  YYSYMBOL_339_7 = 339,                    /* $@7  */
  YYSYMBOL_340_8 = 340,                    /* $@8  */
  YYSYMBOL_341_9 = 341,                    /* $@9  */
  YYSYMBOL_342_10 = 342,                   /* $@10  */
  YYSYMBOL_343_11 = 343,                   /* $@11  */
  YYSYMBOL_344_12 = 344,                   /* $@12  */
  YYSYMBOL_345_13 = 345,                   /* $@13  */
  YYSYMBOL_expression = 346,               /* expression  */
  YYSYMBOL_real_expression = 347,          /* real_expression  */
  YYSYMBOL_typed_expr = 348,               /* typed_expr  */
  YYSYMBOL_int_expr = 349,                 /* int_expr  */
  YYSYMBOL_bool_expr = 350,                /* bool_expr  */
  YYSYMBOL_real_expr = 351,                /* real_expr  */
  YYSYMBOL_variable_content = 352,         /* variable_content  */
  YYSYMBOL_string_unquoted = 353,          /* string_unquoted  */
  YYSYMBOL_string_expr = 354,              /* string_expr  */
  YYSYMBOL_strarglist = 355,               /* strarglist  */
  YYSYMBOL_strarglist_item = 356,          /* strarglist_item  */
  YYSYMBOL_check_user_var_list = 357,      /* check_user_var_list  */
  YYSYMBOL_x_flags = 358,                  /* x_flags  */
  YYSYMBOL_x_flag = 359,                   /* x_flag  */
  YYSYMBOL_sdl_flags = 360,                /* sdl_flags  */
  YYSYMBOL_sdl_flag = 361,                 /* sdl_flag  */
  YYSYMBOL_sound_flags = 362,              /* sound_flags  */
  YYSYMBOL_sound_flag = 363,               /* sound_flag  */
  YYSYMBOL_joystick_flags = 364,           /* joystick_flags  */
  YYSYMBOL_joystick_flag = 365,            /* joystick_flag  */
  YYSYMBOL_video_flags = 366,              /* video_flags  */
  YYSYMBOL_video_flag = 367,               /* video_flag  */
  YYSYMBOL_term_flags = 368,               /* term_flags  */
  YYSYMBOL_term_flag = 369,                /* term_flag  */
  YYSYMBOL_debug_flags = 370,              /* debug_flags  */
  YYSYMBOL_debug_flag = 371,               /* debug_flag  */
  YYSYMBOL_mouse_flags = 372,              /* mouse_flags  */
  YYSYMBOL_mouse_flag = 373,               /* mouse_flag  */
  YYSYMBOL_keyboard_flags = 374,           /* keyboard_flags  */
  YYSYMBOL_keyboard_flag = 375,            /* keyboard_flag  */
  YYSYMBOL_keyboard_mods = 376,            /* keyboard_mods  */
  YYSYMBOL_keyboard_mod = 377,             /* keyboard_mod  */
  YYSYMBOL_378_14 = 378,                   /* $@14  */
  YYSYMBOL_379_15 = 379,                   /* $@15  */
  YYSYMBOL_380_16 = 380,                   /* $@16  */
  YYSYMBOL_381_17 = 381,                   /* $@17  */
  YYSYMBOL_382_18 = 382,                   /* $@18  */
  YYSYMBOL_383_19 = 383,                   /* $@19  */
  YYSYMBOL_384_20 = 384,                   /* $@20  */
  YYSYMBOL_keyboard_modvals = 385,         /* keyboard_modvals  */
  YYSYMBOL_keyboard_modval = 386,          /* keyboard_modval  */
  YYSYMBOL_ttylocks_flags = 387,           /* ttylocks_flags  */
  YYSYMBOL_ttylocks_flag = 388,            /* ttylocks_flag  */
  YYSYMBOL_serial_flags = 389,             /* serial_flags  */
  YYSYMBOL_serial_flag = 390,              /* serial_flag  */
  YYSYMBOL_printer_flags = 391,            /* printer_flags  */
  YYSYMBOL_printer_flag = 392,             /* printer_flag  */
  YYSYMBOL_floppy_flags = 393,             /* floppy_flags  */
  YYSYMBOL_floppy_flag = 394,              /* floppy_flag  */
  YYSYMBOL_disk_flags = 395,               /* disk_flags  */
  YYSYMBOL_disk_flag = 396,                /* disk_flag  */
  YYSYMBOL_port_flags = 397,               /* port_flags  */
  YYSYMBOL_port_flag = 398,                /* port_flag  */
  YYSYMBOL_trace_port_flags = 399,         /* trace_port_flags  */
  YYSYMBOL_trace_port_flag = 400,          /* trace_port_flag  */
  YYSYMBOL_trace_mmio_flags = 401,         /* trace_mmio_flags  */
  YYSYMBOL_trace_mmio_flag = 402,          /* trace_mmio_flag  */
  YYSYMBOL_sillyint_flags = 403,           /* sillyint_flags  */
  YYSYMBOL_sillyint_flag = 404,            /* sillyint_flag  */
  YYSYMBOL_ems_flags = 405,                /* ems_flags  */
  YYSYMBOL_ems_flag = 406,                 /* ems_flag  */
  YYSYMBOL_hardware_ram_flags = 407,       /* hardware_ram_flags  */
  YYSYMBOL_hardware_ram_flag = 408,        /* hardware_ram_flag  */
  YYSYMBOL_bool = 409,                     /* bool  */
  YYSYMBOL_floppy_bool = 410,              /* floppy_bool  */
  YYSYMBOL_int_bool = 411,                 /* int_bool  */
  YYSYMBOL_irq_bool = 412,                 /* irq_bool  */
  YYSYMBOL_speaker = 413,                  /* speaker  */
  YYSYMBOL_cpu_vm = 414,                   /* cpu_vm  */
  YYSYMBOL_cpu_vm_dpmi = 415,              /* cpu_vm_dpmi  */
  YYSYMBOL_charset_flags = 416,            /* charset_flags  */
  YYSYMBOL_charset_flag = 417              /* charset_flag  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 201 "parser.y"

#include "lexer.h"

#line 682 "parser.c"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2895

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  329
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  89
/* YYNRULES -- Number of rules.  */
#define YYNRULES  521
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  977

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   570


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     326,   327,    35,    33,   328,    34,     2,    36,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   323,
      26,    25,    27,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   324,     2,   325,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      28,    29,    30,    31,    32,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   335,   335,   336,   337,   340,   341,   344,   346,   347,
     348,   349,   371,   374,   378,   383,   394,   395,   405,   409,
     410,   411,   416,   421,   426,   431,   435,   439,   443,   447,
     451,   455,   460,   470,   475,   481,   489,   499,   509,   515,
     520,   532,   536,   555,   562,   573,   585,   589,   596,   597,
     602,   607,   612,   617,   622,   627,   632,   637,   642,   643,
     648,   649,   654,   655,   661,   667,   668,   669,   670,   671,
     672,   673,   688,   687,   691,   693,   694,   697,   702,   701,
     705,   704,   708,   712,   711,   716,   715,   719,   718,   722,
     728,   733,   732,   735,   737,   736,   740,   739,   744,   743,
     747,   760,   772,   771,   775,   776,   777,   778,   779,   780,
     782,   781,   784,   791,   790,   796,   800,   802,   808,   810,
     812,   814,   816,   819,   822,   827,   828,   829,   830,   832,
     834,   836,   840,   842,   844,   848,   852,   864,   867,   868,
     870,   872,   874,   876,   877,   878,   882,   886,   890,   896,
     902,   908,   914,   918,   922,   930,   932,   934,   936,   938,
     940,   942,   944,   946,   948,   950,   951,   952,   953,   954,
     955,   961,   962,   966,   983,   993,   994,   995,  1008,  1020,
    1024,  1027,  1028,  1037,  1038,  1051,  1055,  1063,  1064,  1066,
    1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,
    1077,  1078,  1079,  1080,  1085,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1098,  1099,  1100,  1101,  1105,  1106,  1108,  1109,
    1114,  1115,  1117,  1118,  1119,  1120,  1121,  1122,  1123,  1124,
    1125,  1126,  1127,  1133,  1138,  1146,  1147,  1148,  1149,  1154,
    1155,  1157,  1158,  1159,  1160,  1161,  1166,  1167,  1169,  1170,
    1171,  1172,  1173,  1174,  1179,  1180,  1183,  1186,  1189,  1192,
    1193,  1194,  1197,  1198,  1202,  1206,  1217,  1228,  1229,  1230,
    1231,  1232,  1235,  1240,  1241,  1243,  1244,  1245,  1246,  1249,
    1258,  1259,  1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,
    1269,  1270,  1271,  1272,  1273,  1274,  1275,  1276,  1277,  1278,
    1279,  1280,  1281,  1282,  1283,  1284,  1285,  1286,  1288,  1293,
    1294,  1296,  1297,  1298,  1299,  1300,  1306,  1311,  1316,  1322,
    1327,  1332,  1337,  1342,  1347,  1352,  1357,  1359,  1364,  1365,
    1367,  1368,  1369,  1372,  1375,  1376,  1379,  1379,  1380,  1380,
    1381,  1381,  1382,  1382,  1383,  1383,  1384,  1384,  1385,  1385,
    1388,  1389,  1392,  1393,  1394,  1395,  1396,  1397,  1398,  1399,
    1400,  1401,  1402,  1403,  1404,  1405,  1406,  1407,  1408,  1417,
    1418,  1420,  1421,  1422,  1423,  1425,  1430,  1431,  1433,  1434,
    1446,  1447,  1448,  1449,  1450,  1451,  1452,  1453,  1454,  1456,
    1458,  1463,  1464,  1466,  1467,  1468,  1469,  1470,  1471,  1473,
    1478,  1479,  1481,  1482,  1483,  1484,  1485,  1486,  1487,  1488,
    1510,  1517,  1525,  1527,  1530,  1531,  1533,  1534,  1535,  1536,
    1537,  1538,  1539,  1540,  1541,  1542,  1543,  1550,  1556,  1562,
    1569,  1576,  1578,  1585,  1587,  1592,  1593,  1595,  1602,  1608,
    1618,  1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,  1636,
    1639,  1642,  1643,  1645,  1647,  1649,  1651,  1653,  1654,  1657,
    1662,  1663,  1665,  1668,  1671,  1674,  1677,  1680,  1685,  1686,
    1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1698,  1703,
    1704,  1706,  1711,  1716,  1721,  1735,  1739,  1743,  1746,  1751,
    1752,  1754,  1760,  1766,  1773,  1780,  1783,  1788,  1791,  1794,
    1802,  1811,  1812,  1813,  1814,  1816,  1819,  1820,  1821,  1822,
    1829,  1831,  1834,  1835,  1836,  1837,  1838,  1840,  1842,  1843,
    1846,  1847
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "INTEGER", "L_OFF",
  "L_ON", "L_AUTO", "L_YES", "L_NO", "CHIPSET_TYPE", "REAL", "STRING",
  "VARIABLE", "EXPRTEST", "INTCAST", "REALCAST", "AND_OP", "OR_OP",
  "XOR_OP", "SHR_OP", "SHL_OP", "NOT_OP", "EQ_OP", "GE_OP", "LE_OP", "'='",
  "'<'", "'>'", "NEQ_OP", "STR_EQ_OP", "STR_NEQ_OP", "L_AND_OP", "L_OR_OP",
  "'+'", "'-'", "'*'", "'/'", "UMINUS", "UPLUS", "BIT_NOT_OP", "STRLEN",
  "STRTOL", "STRNCMP", "STRCAT", "STRPBRK", "STRSPLIT", "STRCHR",
  "STRRCHR", "STRSTR", "STRDEL", "STRSPN", "STRCSPN", "SHELL", "DEFINED",
  "DEFINE", "UNDEF", "IFSTATEMENT", "WHILESTATEMENT", "FOREACHSTATEMENT",
  "CHECKUSERVAR", "FASTFLOPPY", "HOGTHRESH", "SPEAKER", "IPXSUPPORT",
  "IPXNETWORK", "NOVELLHACK", "ETHDEV", "TAPDEV", "VDESWITCH", "SLIRPARGS",
  "VNET", "DEBUG", "MOUSE", "SERIAL", "COM", "KEYBOARD", "TERMINAL",
  "VIDEO", "EMURETRACE", "TIMER", "MATHCO", "CPU", "CPUSPEED", "RDTSC",
  "BOOTDRIVE", "SWAP_BOOTDRIVE", "L_XMS", "L_DPMI", "DPMI_LIN_RSV_BASE",
  "DPMI_LIN_RSV_SIZE", "PM_DOS_API", "NO_NULL_CHECKS", "PORTS", "DISK",
  "DOSMEM", "EXT_MEM", "L_EMS", "UMB_A0", "UMB_B0", "UMB_F0", "EMS_SIZE",
  "EMS_FRAME", "EMS_UMA_PAGES", "EMS_CONV_PAGES", "TTYLOCKS", "L_SOUND",
  "L_SND_OSS", "L_JOYSTICK", "FILE_LOCK_LIMIT", "ABORT", "WARN", "ERROR",
  "L_FLOPPY", "EMUSYS", "L_X", "L_SDL", "DOSEMUMAP", "LOGBUFSIZE",
  "LOGFILESIZE", "MAPPINGDRIVER", "LFN_SUPPORT", "FFS_REDIR",
  "SET_INT_HOOKS", "TRACE_IRETS", "FINT_REVECT", "EMULATED", "NATIVE",
  "CPUEMU", "CPU_VM", "CPU_VM_DPMI", "VM86", "KVM", "RAWKEYBOARD",
  "PRESTROKE", "KEYTABLE", "SHIFT_MAP", "ALT_MAP", "NUMPAD_MAP", "DUMP",
  "LAYOUT", "DGRAVE", "DACUTE", "DCIRCUM", "DTILDE", "DBREVE", "DABOVED",
  "DDIARES", "DABOVER", "DDACUTE", "DCEDILLA", "DIOTA", "DOGONEK",
  "DCARON", "NETWORK", "PKTDRIVER", "NE2K", "DIRECTORY", "NAMESTUB",
  "BINARY", "BASE", "IRQ", "DEVICE", "CHARSET", "BAUDRATE", "VIRTUAL",
  "VMODEM", "PSEUDO", "RTSCTS", "LOWLAT", "PCCOM", "MICROSOFT",
  "MS3BUTTON", "LOGITECH", "MMSERIES", "MOUSEMAN", "HITACHI",
  "MOUSESYSTEMS", "BUSMOUSE", "PS2", "IMPS2", "INTERNALDRIVER",
  "EMULATE3BUTTONS", "CLEARDTR", "L_DISPLAY", "L_TITLE",
  "X_TITLE_SHOW_APPNAME", "ICON_NAME", "X_BLINKRATE", "X_SHARECMAP",
  "X_MITSHM", "X_FONT", "X_FIXED_ASPECT", "X_ASPECT_43", "X_LIN_FILT",
  "X_BILIN_FILT", "X_MODE13FACT", "X_WINSIZE", "X_GAMMA", "X_FULLSCREEN",
  "VGAEMU_MEMSIZE", "VESAMODE", "X_LFB", "X_PM_INTERFACE", "X_MGRAB_KEY",
  "X_BACKGROUND_PAUSE", "SDL_HWREND", "SDL_FONTS", "VGA", "MGA", "CGA",
  "EGA", "NONE", "CONSOLE", "GRAPHICS", "CHIPSET", "FULLREST", "PARTREST",
  "MEMSIZE", "VBIOS_SIZE_TOK", "VBIOS_SEG", "VGAEMUBIOS_FILE",
  "VBIOS_FILE", "VBIOS_COPY", "VBIOS_MMAP", "DUALMON", "VBIOS_POST",
  "VGA_FONTS", "FORCE_VT_SWITCH", "PCI", "COLOR", "ESCCHAR", "XTERM_TITLE",
  "SIZE", "IO", "PORT", "CONFIG", "READ", "WRITE", "KEYB", "PRINTER",
  "WARNING", "GENERAL", "HARDWARE", "L_IPC", "SOUND", "TRACE", "CLEAR",
  "TRACE_MMIO", "UEXEC", "LPATHS", "HDRIVES", "LPT", "COMMAND", "TIMEOUT",
  "L_FILE", "L_PARTITION", "WHOLEDISK", "SECTORS", "CYLINDERS", "TRACKS",
  "HEADS", "OFFSET", "HDIMAGE", "HDTYPE1", "HDTYPE2", "HDTYPE9",
  "DISKCYL4096", "THREEINCH", "THREEINCH_720", "THREEINCH_2880",
  "FIVEINCH", "FIVEINCH_360", "READONLY", "BOOT", "DEFAULT_DRIVES",
  "SKIP_DRIVES", "RDONLY", "WRONLY", "RDWR", "ORMASK", "ANDMASK", "RANGE",
  "FAST", "SLOW", "SILLYINT", "USE_SIGIO", "HARDWARE_RAM", "SB_BASE",
  "SB_IRQ", "SB_DMA", "SB_HDMA", "MPU_BASE", "MPU_IRQ", "MPU_IRQ_MT32",
  "MIDI_SYNTH", "SOUND_DRIVER", "MIDI_DRIVER", "MUNT_ROMS", "OPL2LPT_DEV",
  "OPL2LPT_TYPE", "SND_PLUGIN_PARAMS", "PCM_HPF", "MIDI_FILE", "WAV_FILE",
  "CDROM", "ASPI", "DEVICETYPE", "TARGET", "FEATURE", "JOYSTICK",
  "JOY_DEVICE", "JOY_DOS_MIN", "JOY_DOS_MAX", "JOY_GRANULARITY",
  "JOY_LATENCY", "CLI_TIMEOUT", "TIMEMODE", "UNICODE", "SHIFT_ALT_MAP",
  "CTRL_MAP", "CTRL_ALT_MAP", "INTERNAL", "EXTERNAL", "';'", "'{'", "'}'",
  "'('", "')'", "','", "$accept", "lines", "optdelim", "line", "$@1",
  "$@2", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11",
  "$@12", "$@13", "expression", "real_expression", "typed_expr",
  "int_expr", "bool_expr", "real_expr", "variable_content",
  "string_unquoted", "string_expr", "strarglist", "strarglist_item",
  "check_user_var_list", "x_flags", "x_flag", "sdl_flags", "sdl_flag",
  "sound_flags", "sound_flag", "joystick_flags", "joystick_flag",
  "video_flags", "video_flag", "term_flags", "term_flag", "debug_flags",
  "debug_flag", "mouse_flags", "mouse_flag", "keyboard_flags",
  "keyboard_flag", "keyboard_mods", "keyboard_mod", "$@14", "$@15", "$@16",
  "$@17", "$@18", "$@19", "$@20", "keyboard_modvals", "keyboard_modval",
  "ttylocks_flags", "ttylocks_flag", "serial_flags", "serial_flag",
  "printer_flags", "printer_flag", "floppy_flags", "floppy_flag",
  "disk_flags", "disk_flag", "port_flags", "port_flag", "trace_port_flags",
  "trace_port_flag", "trace_mmio_flags", "trace_mmio_flag",
  "sillyint_flags", "sillyint_flag", "ems_flags", "ems_flag",
  "hardware_ram_flags", "hardware_ram_flag", "bool", "floppy_bool",
  "int_bool", "irq_bool", "speaker", "cpu_vm", "cpu_vm_dpmi",
  "charset_flags", "charset_flag", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-365)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-181)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -365,  1620,  -365,  -365,  -365,   -13,  1905,  -309,    13,    13,
    -295,    41,    61,    54,  1905,  1905,   111,  1905,  1905,  1905,
     203,   203,   203,   203,   203,   139,  -365,  -365,  -365,  -256,
    -365,  1905,  1905,  1905,  1905,  1959,  1905,   203,  1905,  1905,
    1905,  1905,  1905,  1905,  -365,  -365,  1905,  1905,   983,  1905,
    1905,  1905,  -254,  -252,  1547,    71,   139,   139,   139,  -365,
     149,  -245,  -243,   203,  1905,  1905,   203,  1905,  1905,  1905,
    1905,  1905,    81,   556,   153,   203,   733,  1905,  1905,  -237,
    1905,  1905,   203,  -365,  1905,    24,  -365,   203,   203,   203,
    1905,  1905,  1905,  -365,  -222,  -205,  -190,  1905,   203,  -365,
    2429,  -365,   139,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
     -11,  -365,  -183,  -177,  1905,  1905,  1905,  1905,  -163,  -152,
    -141,  -139,  -136,  -133,  -131,  -129,  -124,  -122,  -121,  -119,
    -117,  -114,  1905,  1233,  -365,  -365,  -365,    27,  -365,    33,
     139,  -365,  -365,  -365,  1905,  -115,  -112,  -365,   -98,  -365,
    1233,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    1905,   -93,  -365,   -96,  -365,   -90,   -89,   -86,    15,   -85,
    -365,  -365,  -365,  -365,   237,  -365,  1233,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,   -83,   -81,  -365,  -365,    44,
    -365,  -365,  -365,  -365,   155,  2542,   131,  -365,  -365,   -96,
     -96,   -96,   -75,   203,  -365,  2592,  -105,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,   203,  -365,  -365,  -365,  -208,  -365,  -365,  -365,
     -73,  -365,   -71,   -44,  -365,  -365,  -365,  1233,  1267,  1267,
     -43,  -365,  -365,   -42,   203,   203,  1905,  -365,  -365,  -365,
    -365,   -96,  1905,  1905,   459,  -365,  -365,  -365,   203,   203,
     203,   139,   203,   203,   203,   203,   203,   203,   203,   203,
     139,    13,   580,  1905,  1905,  1905,  1905,  1905,  1905,  1905,
    1905,  1905,  1905,  1905,  1905,  1905,  1905,  1905,  1905,  1905,
     203,   203,  -197,   -33,   -31,   284,   285,   626,  2566,   139,
     560,   753,     3,  -365,  -365,  1905,  1905,   203,   164,  -365,
    2387,  -365,    22,  1624,  -365,  -365,  -365,  1905,  1905,  1905,
    1905,  1905,    38,  -365,  -365,  -365,   203,   203,  -365,   175,
    -365,  1905,  1905,  1905,  1905,  1905,  1905,  1905,   203,   203,
     203,   203,   203,   203,   203,  1905,   203,   203,   835,  -365,
     203,  1905,  1905,  1905,  1905,   355,  -365,  1086,   -18,   203,
     203,  1905,   203,  1905,  -365,  1905,   203,  1905,  -365,  -365,
    -365,  1905,  2010,  1905,  1905,  1905,  2075,  1905,  1905,   203,
    1905,  2570,  -365,  1905,   203,  -168,  -365,  -365,   -16,   298,
     304,  -279,  -365,   178,     4,   122,    66,   126,    -9,    18,
     309,   817,   841,    11,    19,    21,  -175,    25,    28,    30,
      39,    62,    74,    76,    80,  -155,    23,  -365,   459,   459,
     459,   459,   459,   764,   764,   764,   764,   764,   764,   134,
     134,   142,   142,  -365,  -365,  -365,  -365,  -365,  -365,  1905,
      26,  -365,  -365,  -365,  -365,  -365,  1905,  1905,  1905,  1905,
    1905,  1905,  1905,  1905,  1905,  1905,  1905,  1905,  1905,  1905,
    1905,  1905,  1905,  1905,  1905,  1905,  1905,  1905,  1905,  1905,
     384,  -365,  -365,  -365,  -365,   203,  1905,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
      47,  -365,  -365,  -365,  -365,  1905,  1905,  1905,   203,  -365,
    -365,  -365,  -365,  -365,  -365,   386,  -365,  -365,  -365,  1905,
     203,    64,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,   351,   362,   360,  -365,  -365,
    1905,  1905,  1905,   203,   203,  -365,  -365,  -365,  -365,  -365,
    -365,    49,  -365,  -365,  -365,  -365,   203,  -365,  -365,  -365,
    1905,  1905,  2126,  -365,  -365,  1905,    10,  -365,  -365,  -365,
     203,   203,   203,   203,   367,  1905,  1905,  1905,  1905,  1905,
     203,  -365,  -365,  -365,  -365,  -365,   375,  -365,  -365,  -365,
    -365,  -365,    55,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,   203,   203,   203,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,    50,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,   406,
      84,  -365,  -365,  -365,   410,    87,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  1487,  -365,  -365,  -365,
    -365,  -365,  -365,  1905,  1905,   203,  1905,   203,   147,  -365,
    -365,  -365,  -365,  -365,  2177,  1905,    29,  -365,  -365,  -365,
    -365,  2229,  1905,    85,  -365,  -365,  -365,  -365,  2298,  1787,
    1905,    92,  -365,  -365,  -365,  -365,  2363,  1905,   125,  -365,
    -365,   203,  1905,  -365,  -365,  -365,  -365,   203,  -365,   203,
    1905,   203,   203,   203,  1905,   203,   203,  -365,  -365,    89,
     203,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,   416,    94,    93,  -365,  -365,  -365,
    -365,  -365,   420,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  1905,
     421,  1905,  1905,  1905,  1905,  1905,  1905,  1905,   401,  1185,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,   425,   105,
     108,  -365,  -365,   433,   121,   112,  -365,  -365,   450,   127,
    2414,  -365,   135,  -365,  -365,   460,   136,   140,  -365,  -365,
     159,   143,   141,   148,   146,   151,   152,   161,   168,   170,
     174,  -365,   202,  -365,  1905,  -365,  -365,  -365,  -365,   204,
     451,   477,   508,   509,   510,   516,  -365,  -365,  -365,  -365,
    1905,  -365,  -365,  1905,  -365,  -365,  1905,   539,   215,  -365,
    -365,  1905,  -365,  1905,  -365,  1905,  -365,  1905,  -365,  -365,
    -365,  1905,  -365,  -365,   139,  -365,  1905,  -365,  -365,  -365,
    -365,  -365,  -365,   443,  -365,  -365,  -365,  -365,  1905,  -365,
     219,   221,   222,   229,  -147,  -365,   443,   443,   443,   443,
     443,   443,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,  1905,  -365,   236,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,   236,   236,   236,
     236,   236,   236,   238,   443,  -365,  -365
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     1,   122,   121,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    78,    80,    83,    85,     0,
      72,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    91,    96,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    98,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   102,     0,     0,    94,     0,     0,     0,
       0,     0,   110,   113,     0,     0,     0,     0,     0,     5,
       0,     3,     0,   138,   169,   168,   143,   166,   167,   171,
     154,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    17,   125,   126,   127,   136,   175,     0,
       0,   174,     9,    10,     0,     0,     0,   185,    16,   498,
     123,    31,     8,   505,   501,   504,   503,   502,    71,   497,
      61,   499,    62,    69,   180,    65,    66,    67,    68,    70,
       0,     0,   183,    77,   181,     0,     0,     0,     0,     0,
      47,    44,    60,    32,   138,    36,   124,    38,    40,    41,
      53,    54,    55,    56,    57,     0,     0,    58,    59,     0,
      49,    50,    51,    52,     0,     0,     0,   108,    25,    18,
      20,    19,     0,     0,    21,     0,     0,    23,    45,    46,
      24,    26,    30,    28,    29,    27,    35,   511,   506,   510,
     509,   507,   508,    33,   517,   512,   516,   515,   513,   514,
      34,    89,     0,    87,    63,    64,     0,    74,    39,    75,
       0,   106,     0,     0,   118,   119,   120,     0,    42,    43,
       0,   500,   112,     0,     0,     0,     0,   116,   117,     6,
       4,    15,     0,     0,   165,   133,   132,   142,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   279,   278,     0,     0,     0,     0,   273,
       0,    37,     0,     0,   488,   481,   487,     0,     0,     0,
       0,     0,     0,   479,   375,   374,     0,     0,   373,     0,
     369,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   220,
       0,     0,     0,     0,     0,     0,   239,     0,     0,     0,
       0,     0,     0,     0,   194,   195,     0,     0,   199,   200,
     201,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   187,     0,     0,     0,   216,    90,     0,     0,
       0,     0,   518,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   137,   139,   140,
     141,   134,   135,   155,   157,   158,   159,   160,   156,   161,
     162,   128,   129,   130,   131,   163,   164,    14,    11,     0,
       0,   186,   184,   308,   283,   307,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   280,   182,   327,   326,     0,     0,   316,   317,   320,
     319,   323,   324,   318,   325,   321,   322,   312,   313,   315,
       0,   309,   390,   389,   388,     0,     0,     0,     0,   379,
     381,   380,   382,   383,   384,     0,   376,   333,   332,     0,
       0,     0,   328,   276,   275,   277,    76,   274,   272,   271,
     248,   249,   250,   251,   252,   257,   255,     0,   259,   260,
       0,     0,     0,     0,     0,   263,   264,   268,   267,   269,
     270,     0,   246,   450,   437,   449,     0,   441,   442,   443,
       0,     0,     0,   446,   447,     0,     0,   435,   434,   433,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   418,   419,   420,   417,   416,     0,   414,   483,   484,
     485,   486,     0,    48,   480,   371,   372,    82,   370,   222,
     225,   223,   224,   226,   228,   229,   227,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   107,   221,   241,   242,
     243,   244,   245,   109,   240,   413,   412,     0,     0,     0,
     403,   405,   404,   406,   407,   402,   408,     0,   400,    22,
     189,   190,   191,   192,   193,   196,   197,   198,   202,   138,
       0,   205,   206,   207,   138,     0,   212,   213,   214,   215,
     104,   188,   218,   219,   105,   217,     0,   520,   521,     7,
     519,   399,   398,     0,     0,     0,     0,     0,     0,   391,
     459,   453,   458,   457,     0,     0,     0,   451,   467,   462,
     466,     0,     0,     0,   460,   478,   470,   477,     0,     0,
       0,     0,   468,   496,   491,   495,     0,     0,     0,   489,
     100,     0,     0,   144,   172,   146,   145,     0,   176,     0,
       0,     0,     0,     0,     0,     0,     0,   179,   170,     0,
       0,   298,   284,   290,   282,   296,   297,   286,   301,   303,
     304,   302,   292,   293,   285,   287,   288,   289,   291,   294,
     295,   299,   300,   305,   306,    79,   281,   311,   314,    81,
     310,   385,   386,   387,   378,    84,   377,   331,   330,    86,
     329,   258,   256,   253,   254,   266,   265,   262,   261,    73,
     247,   448,   444,   445,   138,     0,     0,    92,   436,   432,
     426,   427,   431,   429,   421,   422,   423,   424,   425,   428,
      97,   415,   482,   409,   411,   410,    99,   401,   203,     0,
     208,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     334,   397,   393,   394,   395,   396,   103,   392,   138,     0,
       0,    93,   452,   138,     0,     0,    95,   461,   138,     0,
       0,   472,     0,   111,   469,   138,     0,     0,   114,   490,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    12,     0,   439,     0,   438,   430,   204,   209,   210,
       0,     0,     0,     0,     0,     0,   342,    88,   335,   455,
       0,   454,   464,     0,   463,   473,     0,   138,     0,   471,
     493,     0,   492,     0,   115,     0,   148,     0,   149,   150,
     151,     0,   152,   153,     0,   440,     0,   344,   346,   348,
     338,   336,   340,     0,   456,   465,   474,   475,     0,   494,
       0,     0,     0,     0,     0,   211,     0,     0,     0,     0,
       0,     0,   366,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   352,     0,   368,   343,
     350,   476,   101,   147,   177,   178,    13,   345,   347,   349,
     339,   337,   341,     0,     0,   367,   351
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -365,  -365,  -365,   466,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,   -12,  -365,  2555,
     109,  -365,  -365,   692,    -8,  1083,   -48,   249,  -365,  -365,
     169,  -365,   167,  -365,   210,  -365,   205,  -365,    20,  -365,
     251,  -365,   115,  -365,    72,  -365,    70,  -365,  -220,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -135,  -364,  -365,   302,
    -365,   130,  -365,   -32,  -365,    16,  -365,    77,  -365,    99,
    -365,   -26,  -365,   -27,  -365,   -34,  -365,   336,  -365,   -39,
      40,  -365,    58,  -365,  -365,  -365,  -365,  -365,   273
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,   100,   101,   179,   171,   175,   176,   177,   408,
     195,   253,   196,   212,   250,   260,   263,   159,   185,   150,
     134,   135,   136,   137,   138,   139,   173,   174,   148,   401,
     402,   405,   406,   368,   369,   375,   376,   561,   562,   328,
     329,   490,   491,   510,   511,   531,   532,   829,   830,   940,
     939,   941,   923,   936,   937,   938,   959,   960,   349,   350,
     525,   526,   688,   689,   647,   648,   596,   597,   576,   577,
     696,   697,   703,   704,   711,   712,   342,   343,   718,   719,
     160,   151,   162,   262,   158,   233,   240,   411,   412
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     142,   143,   149,   152,   527,   690,   161,   691,   209,   210,
     211,   563,   102,   564,   528,   692,   323,   140,  -174,  -174,
     181,   565,   183,   563,   141,   564,   324,   161,   161,   161,
     690,   144,   691,   565,   161,   161,   161,   403,   404,   334,
     692,   335,   409,   410,   145,   334,   679,   335,   493,   336,
     538,   635,   218,   219,   271,   336,  -180,  -180,   494,   163,
     539,   636,   310,   311,   146,   527,   147,   705,   178,   706,
     204,   180,   205,   182,   208,   528,   187,   707,   189,   215,
     261,   216,   193,   194,   226,   161,   698,   246,   699,   201,
     202,   203,   312,   705,   207,   706,   700,   190,   191,   192,
     403,   404,   264,   707,   197,   198,   200,   221,   222,   223,
     224,   225,   153,   409,   410,   154,   252,   244,   245,   265,
     247,   248,   155,   698,   251,   699,   713,   713,   714,   714,
     457,   319,   313,   700,   266,   529,   715,   715,   337,   338,
     339,   340,   530,   272,   337,   338,   339,   340,   681,   273,
     141,   111,   728,   319,   234,   267,   344,   674,   682,   235,
     141,   111,   637,   278,   236,   323,   345,   306,   307,   308,
     309,   566,   737,   319,   279,   324,   344,   308,   309,   681,
     966,   319,   121,   566,   123,   280,   345,   281,   127,   682,
     282,   130,   121,   283,   123,   284,   529,   285,   127,   258,
     259,   130,   286,   530,   287,   288,   638,   289,   495,   290,
     496,   639,   291,   314,   141,   111,   315,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     316,   318,   319,   426,   320,   321,   156,   157,   322,   330,
     331,   332,   435,   333,   325,   326,   121,   327,   123,   377,
     693,   413,   127,   414,   420,   130,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   693,   559,   560,   237,   238,
     415,   416,   417,   436,   239,   694,   567,   568,   569,   570,
     571,   572,   573,   574,   458,   459,   460,   461,   567,   568,
     569,   570,   571,   572,   573,   574,   683,   649,   676,   677,
     694,   346,   347,   348,   534,   678,   720,   640,   641,   642,
     643,   644,   645,   646,   721,   598,   599,   600,   601,   602,
     695,   346,   347,   348,   722,   797,   575,   683,   725,   609,
     610,   611,   612,   613,   161,   615,   726,   708,   575,   727,
     738,   709,   740,   729,   841,   695,   730,   781,   731,   629,
     630,   631,   632,   603,   341,   533,   701,   732,   782,   783,
     341,   654,   769,   708,   789,   816,   578,   709,   803,   658,
     660,   661,   812,   663,   665,   463,   579,   512,   464,   779,
     733,   672,   710,   325,   326,   465,   327,   513,   684,   685,
     686,   687,   734,   701,   735,   623,   716,   716,   736,   818,
     846,   702,   819,   820,   614,   821,   871,   853,   710,   873,
     875,   652,   874,   876,   878,   655,   886,   657,   889,   684,
     685,   686,   687,   890,   662,   891,   892,   666,   667,   894,
     669,   370,   371,   372,   373,   374,   942,   739,   702,   893,
     858,   717,   717,   895,   141,   896,   466,   467,   514,   468,
     515,   469,   899,   900,   901,   170,   903,   902,   904,   905,
     470,   471,   836,   213,   907,   906,   917,   472,   908,   909,
     473,   298,   299,   300,   768,   301,   302,   303,   910,   536,
     304,   305,   306,   307,   308,   309,   911,   912,   474,   475,
     607,   913,   918,   771,   772,   773,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     914,   580,   916,   919,   920,   921,   581,   476,   784,   785,
     786,   922,   927,   928,   962,   516,   517,   518,   963,   964,
     519,   520,   521,   522,   523,   524,   965,   227,   792,   793,
     795,   493,   228,   796,   974,   975,   270,   229,   492,   777,
     671,   494,   675,   804,   805,   806,   807,   808,   627,   537,
     634,   790,   770,   943,   944,   945,   946,   947,   948,   949,
     950,   951,   952,   953,   954,   955,   293,   294,   295,   296,
     297,   780,   298,   299,   300,   766,   301,   302,   303,   888,
     976,   304,   305,   306,   307,   308,   309,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   293,   294,   295,   296,   297,   595,   298,   299,
     300,   608,   301,   302,   303,   776,   837,   304,   305,   306,
     307,   308,   309,   817,   828,   370,   371,   372,   373,   374,
     842,   831,   832,   811,   834,   798,   847,   854,   604,   859,
     633,   230,   839,   840,   680,     0,   231,   232,     0,   844,
     845,     0,     0,   489,     0,     0,   849,   851,   852,     0,
     810,     0,     0,     0,   856,   857,     0,     0,     0,   765,
     861,   775,   164,   164,   164,   164,   164,   164,   864,     0,
       0,   495,   868,   496,     0,     0,     0,     0,     0,   164,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,     0,   141,   111,     0,     0,   164,   164,
     164,     0,   164,     0,   512,   164,     0,     0,   164,     0,
     956,     0,     0,     0,   513,     0,     0,   164,   164,   957,
       0,     0,     0,     0,   164,     0,   121,     0,   123,   164,
     164,   164,   127,     0,     0,   130,     0,     0,     0,     0,
     164,     0,     0,     0,   164,   304,   305,   306,   307,   308,
     309,   967,   968,   969,   970,   971,   972,   877,     0,   879,
     880,   881,   882,   883,   884,   885,     0,   828,     0,     0,
       0,     0,     0,     0,     0,   514,     0,   515,     0,     0,
       0,     0,   164,   293,   294,   295,   296,   297,   898,   298,
     299,   300,     0,   301,   302,   303,     0,     0,   304,   305,
     306,   307,   308,   309,     0,     0,     0,   293,   294,   295,
     296,   297,   915,   298,   299,   300,   934,   301,   302,   303,
       0,   242,   304,   305,   306,   307,   308,   309,   924,     0,
       0,   925,     0,     0,   926,     0,     0,     0,     0,   929,
       0,   930,     0,   931,     0,   932,     0,     0,     0,   933,
       0,     0,     0,     0,   935,   164,     0,   437,     0,     0,
       0,     0,   516,   517,   518,   958,   961,   519,   520,   521,
     522,   523,   524,     0,     0,     0,     0,     0,   958,   958,
     958,   958,   958,   958,   164,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   973,     0,     0,     0,     0,
       0,     0,     0,   462,     0,     0,   164,   164,     0,     0,
       0,     0,     0,     0,     0,     0,   958,     0,     0,     0,
     164,   164,   164,   164,   164,   164,   164,   164,   164,   164,
     164,   164,   164,     0,     0,     0,   103,   104,   105,   106,
     107,   108,     0,   109,   110,   111,     0,   112,   113,     0,
       0,     0,   164,   164,   114,     0,     0,     0,     0,     0,
       0,   164,     0,     0,     0,     0,   115,   116,     0,   164,
       0,     0,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,     0,   164,   164,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     164,   164,   164,   164,   164,   164,   164,     0,   164,   164,
       0,     0,   164,     0,     0,     0,     0,     0,     0,     0,
       0,   164,   164,     0,   164,     0,     0,     0,   164,     0,
       0,     0,     0,     0,     0,     0,     0,   635,     0,     0,
       0,   164,     0,     0,     0,     0,   164,   636,     0,     0,
       0,     0,     0,   165,   166,   167,   168,   169,   172,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     188,     0,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   172,
     172,   172,     0,   214,   723,     0,   217,     0,     0,   220,
       0,     0,     0,     0,     0,     0,     0,     0,   241,   243,
     626,     0,     0,     0,     0,   249,     0,     0,   724,     0,
     254,   255,   256,     0,     0,     0,     0,     0,     0,     0,
       0,   268,     0,     0,     0,   172,     0,   164,   103,   104,
     105,   106,   107,   108,     0,   109,   110,   111,   637,   112,
     113,     0,     0,     0,     0,     0,   114,     0,     0,     0,
     164,     0,     0,     0,     0,     0,     0,     0,   115,   116,
       0,     0,   164,   172,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,     0,
       0,     0,   638,     0,     0,   164,   164,   639,     0,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   164,   301,
     302,   303,     0,     0,   304,   305,   306,   307,   308,   309,
       0,     0,   164,   164,   164,   164,     0,     0,     0,     0,
       0,     0,   164,  -125,  -125,  -125,  -125,  -125,     0,  -125,
    -125,  -125,     0,  -125,  -125,  -125,   378,     0,  -125,  -125,
    -125,  -125,  -125,  -125,     0,     0,     0,   199,     0,   132,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     822,   823,   824,     0,     0,   407,     0,     0,     0,   164,
     164,   164,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   418,   419,     0,
       0,     0,     0,   640,   641,   642,   643,   644,   645,   646,
       0,   423,   424,   425,   172,   427,   428,   429,   430,   431,
     432,   433,   434,   172,     0,     0,     0,   164,     0,   164,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   455,   456,     0,     0,     0,     0,     0,
       0,     0,   172,     0,     0,     0,     0,     0,     0,     0,
     535,     0,     0,   164,     0,     0,     0,     0,     0,   164,
       0,   164,     0,   164,   164,   164,     0,   164,   164,   605,
     606,     0,   164,     0,     0,     0,     0,     0,     0,     0,
       0,   616,   617,   618,   619,   620,   621,   622,     0,   624,
     625,     0,     0,   628,     0,     0,     0,     0,     0,     0,
       0,     0,   650,   651,     0,   653,     0,     0,     0,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   668,     0,     0,     0,     0,   673,     0,     0,
     103,   104,   105,   106,   107,   108,     0,   109,   110,   111,
       0,   112,   113,   825,   826,   827,     0,     0,   114,     0,
     887,   132,     0,     0,     0,     0,     0,     0,     0,     0,
     115,   116,     0,     0,     0,     0,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     103,   104,   105,   106,   107,   108,     0,   109,   110,   111,
       0,   112,   113,     0,     0,     0,     0,     0,   114,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   767,     0,
     115,   116,     0,     0,     0,     0,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   774,     0,     0,     0,     0,   164,     0,     0,     0,
       0,     0,     0,   778,     0,     0,     0,     0,     0,     0,
       2,     3,   822,   823,   824,   578,     0,     0,     0,     0,
       0,     4,     5,     6,     0,   579,   787,   788,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   791,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   799,   800,   801,   802,     0,     0,     0,
       0,     0,     7,   809,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,     0,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,     0,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
     813,   814,   815,     0,    52,    53,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,     0,     0,    72,    73,    74,
       0,     0,     0,    75,    76,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   833,     0,
     835,     0,     0,     0,    77,    78,     0,     0,     0,     0,
     580,     0,    79,     0,     0,   581,     0,     0,     0,     0,
     103,   104,   105,   106,   107,   108,     0,   109,   110,   111,
       0,   112,   113,     0,   860,   825,   826,   827,   114,     0,
     862,     0,   863,   132,   865,   866,   867,     0,   869,   870,
     115,   116,     0,   872,     0,     0,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,     0,     0,     0,     0,     0,    80,     0,    81,     0,
       0,    82,     0,     0,     0,     0,     0,     0,     0,    83,
       0,     0,     0,     0,    84,    85,     0,    86,    87,    88,
      89,   206,     0,   132,     0,     0,     0,     0,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,     0,     0,     0,    90,    91,   595,     0,     0,     0,
       0,     0,     0,     0,    92,     0,    93,     0,   103,   104,
     105,   106,   107,   108,     0,   109,   110,   111,     0,   112,
     113,     0,     0,     0,    94,    95,   114,     0,    96,     0,
       0,     0,     0,     0,     0,    97,    98,     0,   115,   116,
       0,     0,     0,    99,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,     0,
       0,     0,   184,   104,   105,   106,   107,   108,     0,   109,
     110,   111,     0,   112,   113,     0,     0,     0,     0,     0,
     114,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   115,   116,     0,     0,     0,   172,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   659,   104,   105,   106,   107,   108,     0,
     109,   110,   111,     0,   112,   113,     0,     0,     0,     0,
       0,   114,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   115,   116,     0,     0,     0,     0,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,     0,     0,     0,     0,   850,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   664,   104,
     105,   106,   107,   108,     0,   109,   110,   111,     0,   112,
     113,     0,     0,     0,     0,     0,   114,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   115,   116,
       0,     0,     0,   132,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   794,
     104,   105,   106,   107,   108,     0,   109,   110,   111,     0,
     112,   113,     0,     0,     0,     0,     0,   114,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   115,
     116,     0,     0,     0,     0,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     838,   104,   105,   106,   107,   108,     0,   109,   110,   111,
       0,   112,   113,     0,     0,     0,     0,     0,   114,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     115,   116,     0,     0,     0,     0,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   843,   104,   105,   106,   107,   108,     0,   109,
     110,   111,     0,   112,   113,     0,     0,     0,     0,     0,
     114,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   115,   116,     0,     0,     0,     0,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,     0,     0,   132,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   848,   104,   105,   106,   107,   108,     0,   109,   110,
     111,     0,   112,   113,     0,     0,     0,     0,     0,   114,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   115,   116,     0,     0,     0,   132,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   855,   104,   105,   106,
     107,   108,     0,   109,   110,   111,     0,   112,   113,     0,
       0,     0,     0,     0,   114,     0,     0,     0,   538,     0,
       0,     0,     0,     0,     0,     0,   115,   116,   539,     0,
       0,   132,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   897,   104,   105,
     106,   107,   108,     0,   109,   110,   111,     0,   112,   113,
       3,     0,     0,     0,     0,   114,     0,     0,     0,     0,
       4,     5,     6,     0,     0,     0,     0,   115,   116,     0,
       0,     0,   132,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     7,     0,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,   132,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,     0,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,     0,
       0,     0,     0,    52,    53,     0,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,     0,   132,    72,    73,    74,     0,
       0,   133,    75,    76,     0,     0,     0,   463,     0,     0,
     464,     0,     0,     0,     0,     0,     0,   465,     0,     0,
       0,     0,     0,    77,    78,     0,     0,     0,     0,     0,
     186,    79,     0,     0,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,     0,   559,   560,     0,     0,     0,     0,
       0,     0,     0,     0,   132,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   466,   467,
       0,   468,     0,   469,     0,   257,   257,     0,     0,     0,
       0,     0,   470,   471,     0,    80,     0,    81,     0,   472,
      82,     0,   473,     0,     0,     0,     0,     0,    83,   274,
     275,   276,   277,    84,    85,     0,    86,    87,    88,    89,
     474,   475,     0,     0,     0,     0,     0,   292,     0,   132,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    90,    91,     0,     0,     0,     0,     0,
       0,     0,     0,    92,     0,    93,     0,     0,     0,   476,
       0,     0,     0,     0,     0,   317,     0,     0,     0,     0,
       0,     0,     0,    94,    95,     0,     0,    96,     0,     0,
     132,     0,     0,     0,    97,    98,     0,     0,     0,     0,
       0,     0,   269,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,     0,     0,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   421,   422,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,     0,     0,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   489,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   670
};

static const yytype_int16 yycheck[] =
{
       8,     9,    14,    15,     1,     1,    18,     3,    56,    57,
      58,     1,    25,     3,    11,    11,     1,   326,    29,    30,
      32,    11,    34,     1,    11,     3,    11,    39,    40,    41,
       1,   326,     3,    11,    46,    47,    48,   205,   206,     1,
      11,     3,   321,   322,     3,     1,   325,     3,     1,    11,
       1,     1,    64,    65,   102,    11,    29,    30,    11,    19,
      11,    11,    29,    30,     3,     1,    12,     1,   324,     3,
     324,    31,   324,    33,     3,    11,    36,    11,    38,   324,
      92,   324,    42,    43,     3,    97,     1,   324,     3,    49,
      50,    51,   140,     1,    54,     3,    11,    39,    40,    41,
     205,   206,   324,    11,    46,    47,    48,    67,    68,    69,
      70,    71,     1,   321,   322,     4,    92,    77,    78,   324,
      80,    81,    11,     1,    84,     3,     1,     1,     3,     3,
     327,   328,   144,    11,   324,   132,    11,    11,   100,   101,
     102,   103,   139,   326,   100,   101,   102,   103,     1,   326,
      11,    12,   327,   328,     1,    97,     1,   325,    11,     6,
      11,    12,   112,   326,    11,     1,    11,    33,    34,    35,
      36,   161,   327,   328,   326,    11,     1,    35,    36,     1,
     327,   328,    43,   161,    45,   326,    11,   326,    49,    11,
     326,    52,    43,   326,    45,   326,   132,   326,    49,    90,
      91,    52,   326,   139,   326,   326,   156,   326,   161,   326,
     163,   161,   326,   328,    11,    12,   328,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     328,   324,   328,   281,   324,   324,   125,   126,   324,   324,
       3,   324,   290,   324,   229,   230,    43,   232,    45,   324,
     246,   324,    49,   324,   266,    52,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   246,   227,   228,   125,   126,
     324,   324,   324,   291,   131,   281,   276,   277,   278,   279,
     280,   281,   282,   283,   327,   326,    12,    12,   276,   277,
     278,   279,   280,   281,   282,   283,   159,   325,   324,    11,
     281,   156,   157,   158,   326,    11,   325,   267,   268,   269,
     270,   271,   272,   273,   306,   337,   338,   339,   340,   341,
     326,   156,   157,   158,    25,   325,   326,   159,   327,   351,
     352,   353,   354,   355,   356,   357,   327,   281,   326,   328,
     327,   285,   326,   328,   325,   326,   328,     6,   328,   371,
     372,   373,   374,   325,   326,   325,   281,   328,     6,     9,
     326,   383,   325,   281,   325,   325,     1,   285,    11,   391,
     392,   393,   327,   395,   396,     1,    11,     1,     4,   325,
     328,   403,   326,   229,   230,    11,   232,    11,   251,   252,
     253,   254,   328,   281,   328,   365,   281,   281,   328,     3,
     325,   326,   328,     3,   356,   328,   327,   325,   326,     3,
     327,   381,   328,     3,     3,   385,    25,   387,     3,   251,
     252,   253,   254,   328,   394,   327,     3,   397,   398,   327,
     400,   310,   311,   312,   313,   314,     3,   459,   326,   328,
     325,   326,   326,     3,    11,   328,    72,    73,    72,    75,
      74,    77,   327,     3,   328,   326,   307,   327,   325,   328,
      86,    87,   325,   324,   328,   327,    25,    93,   327,   327,
      96,    22,    23,    24,   496,    26,    27,    28,   327,   325,
      31,    32,    33,    34,    35,    36,   328,   327,   114,   115,
     325,   327,    25,   515,   516,   517,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     328,   156,   328,    25,    25,    25,   161,   153,   550,   551,
     552,    25,     3,   328,   325,   159,   160,   161,   327,   327,
     164,   165,   166,   167,   168,   169,   327,     1,   570,   571,
     572,     1,     6,   575,   328,   327,   100,    11,   319,   529,
     401,    11,   405,   585,   586,   587,   588,   589,   368,   328,
     375,   561,   510,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,    16,    17,    18,    19,
      20,   531,    22,    23,    24,   490,    26,    27,    28,   829,
     974,    31,    32,    33,    34,    35,    36,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,    16,    17,    18,    19,    20,   272,    22,    23,
      24,   349,    26,    27,    28,   525,   688,    31,    32,    33,
      34,    35,    36,   647,   676,   310,   311,   312,   313,   314,
     696,   683,   684,   596,   686,   576,   703,   711,   342,   718,
     325,   125,   694,   695,   411,    -1,   130,   131,    -1,   701,
     702,    -1,    -1,   309,    -1,    -1,   708,   709,   710,    -1,
     325,    -1,    -1,    -1,   716,   717,    -1,    -1,    -1,   325,
     722,   325,    20,    21,    22,    23,    24,    25,   730,    -1,
      -1,   161,   734,   163,    -1,    -1,    -1,    -1,    -1,    37,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,    -1,    11,    12,    -1,    -1,    56,    57,
      58,    -1,    60,    -1,     1,    63,    -1,    -1,    66,    -1,
     317,    -1,    -1,    -1,    11,    -1,    -1,    75,    76,   326,
      -1,    -1,    -1,    -1,    82,    -1,    43,    -1,    45,    87,
      88,    89,    49,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,   102,    31,    32,    33,    34,    35,
      36,   936,   937,   938,   939,   940,   941,   819,    -1,   821,
     822,   823,   824,   825,   826,   827,    -1,   829,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    72,    -1,    74,    -1,    -1,
      -1,    -1,   140,    16,    17,    18,    19,    20,   850,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    35,    36,    -1,    -1,    -1,    16,    17,    18,
      19,    20,   874,    22,    23,    24,   914,    26,    27,    28,
      -1,   138,    31,    32,    33,    34,    35,    36,   890,    -1,
      -1,   893,    -1,    -1,   896,    -1,    -1,    -1,    -1,   901,
      -1,   903,    -1,   905,    -1,   907,    -1,    -1,    -1,   911,
      -1,    -1,    -1,    -1,   916,   213,    -1,   327,    -1,    -1,
      -1,    -1,   159,   160,   161,   923,   928,   164,   165,   166,
     167,   168,   169,    -1,    -1,    -1,    -1,    -1,   936,   937,
     938,   939,   940,   941,   242,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   957,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   327,    -1,    -1,   264,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   974,    -1,    -1,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,    -1,    10,    11,    12,    -1,    14,    15,    -1,
      -1,    -1,   310,   311,    21,    -1,    -1,    -1,    -1,    -1,
      -1,   319,    -1,    -1,    -1,    -1,    33,    34,    -1,   327,
      -1,    -1,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    -1,   346,   347,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
      -1,    -1,   370,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   379,   380,    -1,   382,    -1,    -1,    -1,   386,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,
      -1,   399,    -1,    -1,    -1,    -1,   404,    11,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    -1,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    56,
      57,    58,    -1,    60,   327,    -1,    63,    -1,    -1,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,    76,
     325,    -1,    -1,    -1,    -1,    82,    -1,    -1,   327,    -1,
      87,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    -1,    -1,    -1,   102,    -1,   495,     3,     4,
       5,     6,     7,     8,    -1,    10,    11,    12,   112,    14,
      15,    -1,    -1,    -1,    -1,    -1,    21,    -1,    -1,    -1,
     518,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    -1,   530,   140,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      -1,    -1,   156,    -1,    -1,   553,   554,   161,    -1,    16,
      17,    18,    19,    20,    -1,    22,    23,    24,   566,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    35,    36,
      -1,    -1,   580,   581,   582,   583,    -1,    -1,    -1,    -1,
      -1,    -1,   590,    16,    17,    18,    19,    20,    -1,    22,
      23,    24,    -1,    26,    27,    28,   213,    -1,    31,    32,
      33,    34,    35,    36,    -1,    -1,    -1,   324,    -1,   326,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,   136,   137,    -1,    -1,   242,    -1,    -1,    -1,   637,
     638,   639,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   264,   265,    -1,
      -1,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,    -1,    -1,    -1,   685,    -1,   687,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   310,   311,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   319,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     327,    -1,    -1,   721,    -1,    -1,    -1,    -1,    -1,   727,
      -1,   729,    -1,   731,   732,   733,    -1,   735,   736,   346,
     347,    -1,   740,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,    -1,    -1,   370,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   379,   380,    -1,   382,    -1,    -1,    -1,   386,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   399,    -1,    -1,    -1,    -1,   404,    -1,    -1,
       3,     4,     5,     6,     7,     8,    -1,    10,    11,    12,
      -1,    14,    15,   318,   319,   320,    -1,    -1,    21,    -1,
     325,   326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    -1,    -1,    -1,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,    -1,    10,    11,    12,
      -1,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   495,    -1,
      33,    34,    -1,    -1,    -1,    -1,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,   518,    -1,    -1,    -1,    -1,   914,    -1,    -1,    -1,
      -1,    -1,    -1,   530,    -1,    -1,    -1,    -1,    -1,    -1,
       0,     1,   135,   136,   137,     1,    -1,    -1,    -1,    -1,
      -1,    11,    12,    13,    -1,    11,   553,   554,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   566,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   580,   581,   582,   583,    -1,    -1,    -1,
      -1,    -1,    52,   590,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     637,   638,   639,    -1,   104,   105,    -1,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,    -1,    -1,   127,   128,   129,
      -1,    -1,    -1,   133,   134,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,    -1,
     687,    -1,    -1,    -1,   154,   155,    -1,    -1,    -1,    -1,
     156,    -1,   162,    -1,    -1,   161,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,    -1,    10,    11,    12,
      -1,    14,    15,    -1,   721,   318,   319,   320,    21,    -1,
     727,    -1,   729,   326,   731,   732,   733,    -1,   735,   736,
      33,    34,    -1,   740,    -1,    -1,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    -1,    -1,    -1,    -1,    -1,   226,    -1,   228,    -1,
      -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,
      -1,    -1,    -1,    -1,   244,   245,    -1,   247,   248,   249,
     250,   324,    -1,   326,    -1,    -1,    -1,    -1,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,    -1,    -1,   274,   275,   272,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   284,    -1,   286,    -1,     3,     4,
       5,     6,     7,     8,    -1,    10,    11,    12,    -1,    14,
      15,    -1,    -1,    -1,   304,   305,    21,    -1,   308,    -1,
      -1,    -1,    -1,    -1,    -1,   315,   316,    -1,    33,    34,
      -1,    -1,    -1,   323,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,    -1,    10,
      11,    12,    -1,    14,    15,    -1,    -1,    -1,    -1,    -1,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    -1,    -1,   914,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,     3,     4,     5,     6,     7,     8,    -1,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    -1,    -1,
      -1,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    -1,    -1,    -1,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    -1,    -1,    -1,    -1,   281,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,    -1,    10,    11,    12,    -1,    14,
      15,    -1,    -1,    -1,    -1,    -1,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    -1,    -1,   326,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,     3,
       4,     5,     6,     7,     8,    -1,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    -1,    -1,    -1,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
       3,     4,     5,     6,     7,     8,    -1,    10,    11,    12,
      -1,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    -1,    -1,    -1,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,   326,     3,     4,     5,     6,     7,     8,    -1,    10,
      11,    12,    -1,    14,    15,    -1,    -1,    -1,    -1,    -1,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    -1,    -1,   326,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,    -1,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    -1,    -1,   326,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,    -1,    10,    11,    12,    -1,    14,    15,    -1,
      -1,    -1,    -1,    -1,    21,    -1,    -1,    -1,     1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    11,    -1,
      -1,   326,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,     3,     4,     5,
       6,     7,     8,    -1,    10,    11,    12,    -1,    14,    15,
       1,    -1,    -1,    -1,    -1,    21,    -1,    -1,    -1,    -1,
      11,    12,    13,    -1,    -1,    -1,    -1,    33,    34,    -1,
      -1,    -1,   326,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,   326,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,    -1,
      -1,    -1,    -1,   104,   105,    -1,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,    -1,   326,   127,   128,   129,    -1,
      -1,     6,   133,   134,    -1,    -1,    -1,     1,    -1,    -1,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    11,    -1,    -1,
      -1,    -1,    -1,   154,   155,    -1,    -1,    -1,    -1,    -1,
      35,   162,    -1,    -1,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,    -1,   227,   228,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    72,    73,
      -1,    75,    -1,    77,    -1,    90,    91,    -1,    -1,    -1,
      -1,    -1,    86,    87,    -1,   226,    -1,   228,    -1,    93,
     231,    -1,    96,    -1,    -1,    -1,    -1,    -1,   239,   114,
     115,   116,   117,   244,   245,    -1,   247,   248,   249,   250,
     114,   115,    -1,    -1,    -1,    -1,    -1,   132,    -1,   326,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   274,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   284,    -1,   286,    -1,    -1,    -1,   153,
      -1,    -1,    -1,    -1,    -1,   170,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   304,   305,    -1,    -1,   308,    -1,    -1,
     326,    -1,    -1,    -1,   315,   316,    -1,    -1,    -1,    -1,
      -1,    -1,   323,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,    -1,    -1,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   272,   273,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   309,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   325
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   330,     0,     1,    11,    12,    13,    52,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   104,   105,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   127,   128,   129,   133,   134,   154,   155,   162,
     226,   228,   231,   239,   244,   245,   247,   248,   249,   250,
     274,   275,   284,   286,   304,   305,   308,   315,   316,   323,
     331,   332,    25,     3,     4,     5,     6,     7,     8,    10,
      11,    12,    14,    15,    21,    33,    34,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,   326,   348,   349,   350,   351,   352,   353,   354,
     326,    11,   353,   353,   326,     3,     3,    12,   357,   346,
     348,   410,   346,     1,     4,    11,   125,   126,   413,   346,
     409,   346,   411,   409,   352,   354,   354,   354,   354,   354,
     326,   334,   354,   355,   356,   335,   336,   337,   324,   333,
     409,   346,   409,   346,     3,   347,   348,   409,   354,   409,
     411,   411,   411,   409,   409,   339,   341,   411,   411,   324,
     411,   409,   409,   409,   324,   324,   324,   409,     3,   355,
     355,   355,   342,   324,   354,   324,   324,   354,   346,   346,
     354,   409,   409,   409,   409,   409,     3,     1,     6,    11,
     125,   130,   131,   414,     1,     6,    11,   125,   126,   131,
     415,   354,   138,   354,   409,   409,   324,   409,   409,   354,
     343,   409,    92,   340,   354,   354,   354,   348,   349,   349,
     344,   346,   412,   345,   324,   324,   324,   411,   354,   323,
     332,   355,   326,   326,   348,   348,   348,   348,   326,   326,
     326,   326,   326,   326,   326,   326,   326,   326,   326,   326,
     326,   326,   348,    16,    17,    18,    19,    20,    22,    23,
      24,    26,    27,    28,    31,    32,    33,    34,    35,    36,
      29,    30,   355,   346,   328,   328,   328,   348,   324,   328,
     324,   324,   324,     1,    11,   229,   230,   232,   368,   369,
     324,     3,   324,   324,     1,     3,    11,   100,   101,   102,
     103,   326,   405,   406,     1,    11,   156,   157,   158,   387,
     388,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   362,   363,
     310,   311,   312,   313,   314,   364,   365,   324,   354,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   358,   359,   205,   206,   360,   361,   354,   338,   321,
     322,   416,   417,   324,   324,   324,   324,   324,   354,   354,
     346,   348,   348,   354,   354,   354,   355,   354,   354,   354,
     354,   354,   354,   354,   354,   355,   353,   327,   348,   348,
     348,   348,   348,   348,   348,   348,   348,   348,   348,   348,
     348,   348,   348,   348,   348,   354,   354,   327,   327,   326,
      12,    12,   327,     1,     4,    11,    72,    73,    75,    77,
      86,    87,    93,    96,   114,   115,   153,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   309,
     370,   371,   356,     1,    11,   161,   163,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     372,   373,     1,    11,    72,    74,   159,   160,   161,   164,
     165,   166,   167,   168,   169,   389,   390,     1,    11,   132,
     139,   374,   375,   409,   346,   354,   325,   369,     1,    11,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   227,
     228,   366,   367,     1,     3,    11,   161,   276,   277,   278,
     279,   280,   281,   282,   283,   326,   397,   398,     1,    11,
     156,   161,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   272,   395,   396,   346,   346,
     346,   346,   346,   325,   406,   354,   354,   325,   388,   346,
     346,   346,   346,   346,   411,   346,   354,   354,   354,   354,
     354,   354,   354,   409,   354,   354,   325,   363,   354,   346,
     346,   346,   346,   325,   365,     1,    11,   112,   156,   161,
     267,   268,   269,   270,   271,   272,   273,   393,   394,   325,
     354,   354,   409,   354,   346,   409,   354,   409,   346,     3,
     346,   346,   409,   346,     3,   346,   409,   409,   354,   409,
     325,   359,   346,   354,   325,   361,   324,    11,    11,   325,
     417,     1,    11,   159,   251,   252,   253,   254,   391,   392,
       1,     3,    11,   246,   281,   326,   399,   400,     1,     3,
      11,   281,   326,   401,   402,     1,     3,    11,   281,   285,
     326,   403,   404,     1,     3,    11,   281,   326,   407,   408,
     325,   306,    25,   327,   327,   327,   327,   328,   327,   328,
     328,   328,   328,   328,   328,   328,   328,   327,   327,   346,
     326,   409,   409,   409,   409,   409,   409,   409,   409,   409,
     409,   409,   409,   409,   409,   409,   409,   409,   409,   409,
     409,   409,   409,   409,   409,   325,   371,   354,   346,   325,
     373,   346,   346,   346,   354,   325,   390,   409,   354,   325,
     375,     6,     6,     9,   346,   346,   346,   354,   354,   325,
     367,   354,   346,   346,     3,   346,   346,   325,   398,   354,
     354,   354,   354,    11,   346,   346,   346,   346,   346,   354,
     325,   396,   327,   354,   354,   354,   325,   394,     3,   328,
       3,   328,   135,   136,   137,   318,   319,   320,   346,   376,
     377,   346,   346,   354,   346,   354,   325,   392,     3,   346,
     346,   325,   400,     3,   346,   346,   325,   402,     3,   346,
     281,   346,   346,   325,   404,     3,   346,   346,   325,   408,
     354,   346,   354,   354,   346,   354,   354,   354,   346,   354,
     354,   327,   354,     3,   328,   327,     3,   346,     3,   346,
     346,   346,   346,   346,   346,   346,    25,   325,   377,     3,
     328,   327,     3,   328,   327,     3,   328,     3,   346,   327,
       3,   328,   327,   307,   325,   328,   327,   328,   327,   327,
     327,   328,   327,   327,   328,   346,   328,    25,    25,    25,
      25,    25,    25,   381,   346,   346,   346,     3,   328,   346,
     346,   346,   346,   346,   355,   346,   382,   383,   384,   379,
     378,   380,     3,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   317,   326,   353,   385,
     386,   346,   325,   327,   327,   327,   327,   385,   385,   385,
     385,   385,   385,   346,   328,   327,   386
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   329,   330,   330,   330,   331,   331,   332,   332,   332,
     332,   332,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   333,   332,   332,   332,   332,   332,   334,   332,
     335,   332,   332,   336,   332,   337,   332,   338,   332,   332,
     332,   339,   332,   332,   340,   332,   341,   332,   342,   332,
     332,   332,   343,   332,   332,   332,   332,   332,   332,   332,
     344,   332,   332,   345,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   346,   347,   348,   348,   348,   348,   348,
     348,   348,   348,   348,   348,   348,   348,   348,   349,   349,
     349,   349,   349,   349,   349,   349,   349,   349,   349,   349,
     349,   349,   349,   349,   349,   350,   350,   350,   350,   350,
     350,   350,   350,   350,   350,   350,   350,   350,   350,   350,
     350,   351,   351,   352,   353,   354,   354,   354,   354,   354,
     354,   355,   355,   356,   356,   357,   357,   358,   358,   359,
     359,   359,   359,   359,   359,   359,   359,   359,   359,   359,
     359,   359,   359,   359,   359,   359,   359,   359,   359,   359,
     359,   359,   359,   359,   359,   359,   360,   360,   361,   361,
     362,   362,   363,   363,   363,   363,   363,   363,   363,   363,
     363,   363,   363,   363,   363,   363,   363,   363,   363,   364,
     364,   365,   365,   365,   365,   365,   366,   366,   367,   367,
     367,   367,   367,   367,   367,   367,   367,   367,   367,   367,
     367,   367,   367,   367,   367,   367,   367,   367,   367,   367,
     367,   367,   367,   368,   368,   369,   369,   369,   369,   369,
     370,   370,   371,   371,   371,   371,   371,   371,   371,   371,
     371,   371,   371,   371,   371,   371,   371,   371,   371,   371,
     371,   371,   371,   371,   371,   371,   371,   371,   371,   372,
     372,   373,   373,   373,   373,   373,   373,   373,   373,   373,
     373,   373,   373,   373,   373,   373,   373,   373,   374,   374,
     375,   375,   375,   375,   376,   376,   378,   377,   379,   377,
     380,   377,   381,   377,   382,   377,   383,   377,   384,   377,
     385,   385,   386,   386,   386,   386,   386,   386,   386,   386,
     386,   386,   386,   386,   386,   386,   386,   386,   386,   387,
     387,   388,   388,   388,   388,   388,   389,   389,   390,   390,
     390,   390,   390,   390,   390,   390,   390,   390,   390,   390,
     390,   391,   391,   392,   392,   392,   392,   392,   392,   392,
     393,   393,   394,   394,   394,   394,   394,   394,   394,   394,
     394,   394,   394,   394,   395,   395,   396,   396,   396,   396,
     396,   396,   396,   396,   396,   396,   396,   396,   396,   396,
     396,   396,   396,   396,   396,   397,   397,   398,   398,   398,
     398,   398,   398,   398,   398,   398,   398,   398,   398,   398,
     398,   399,   399,   400,   400,   400,   400,   400,   400,   400,
     401,   401,   402,   402,   402,   402,   402,   402,   403,   403,
     404,   404,   404,   404,   404,   404,   404,   404,   404,   405,
     405,   406,   406,   406,   406,   406,   406,   406,   406,   407,
     407,   408,   408,   408,   408,   408,   408,   409,   410,   411,
     412,   413,   413,   413,   413,   413,   414,   414,   414,   414,
     414,   414,   415,   415,   415,   415,   415,   415,   416,   416,
     417,   417
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     3,     1,     2,     4,     2,     2,
       2,     4,     6,     9,     4,     3,     2,     2,     2,     2,
       2,     2,     4,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     3,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     4,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     0,     5,     2,     2,     4,     2,     0,     5,
       0,     5,     4,     0,     5,     0,     5,     0,     6,     2,
       3,     0,     5,     5,     0,     5,     0,     5,     0,     5,
       4,     8,     0,     5,     4,     4,     2,     4,     2,     4,
       0,     5,     2,     0,     5,     6,     2,     2,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     2,     2,     3,     3,     1,     3,     1,     3,
       3,     3,     2,     1,     4,     4,     4,     8,     6,     6,
       6,     6,     6,     6,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     1,     1,     1,     1,
       4,     1,     4,     1,     1,     1,     4,     8,     8,     4,
       1,     1,     3,     1,     3,     1,     3,     1,     2,     2,
       2,     2,     2,     2,     1,     1,     2,     2,     2,     1,
       1,     1,     2,     3,     4,     2,     2,     2,     3,     4,
       4,     6,     2,     2,     2,     2,     1,     2,     2,     2,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     1,
       2,     2,     2,     2,     2,     2,     1,     2,     1,     1,
       1,     1,     1,     2,     2,     1,     2,     1,     2,     1,
       1,     2,     2,     1,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     1,     1,
       1,     2,     2,     1,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     1,     1,     1,
       2,     2,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     1,     1,     1,     2,     0,     5,     0,     5,
       0,     5,     0,     4,     0,     5,     0,     5,     0,     5,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     1,
       2,     2,     2,     1,     1,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     1,     1,
       1,     1,     2,     2,     2,     2,     2,     2,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       3,     2,     2,     1,     1,     1,     2,     1,     3,     3,
       4,     1,     1,     1,     2,     2,     1,     1,     2,     1,
       1,     1,     2,     1,     3,     3,     4,     1,     1,     1,
       1,     2,     1,     3,     3,     4,     1,     1,     1,     2,
       1,     3,     2,     3,     4,     4,     5,     1,     1,     1,
       2,     1,     3,     2,     2,     2,     2,     1,     1,     1,
       2,     1,     3,     3,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 7: /* line: CHARSET '{' charset_flags '}'  */
#line 344 "parser.y"
                                              {}
#line 2769 "parser.c"
    break;

  case 8: /* line: HOGTHRESH expression  */
#line 346 "parser.y"
                                        { config.hogthreshold = (yyvsp[0].i_value); }
#line 2775 "parser.c"
    break;

  case 9: /* line: DEFINE string_unquoted  */
#line 347 "parser.y"
                                        { define_config_variable((yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 2781 "parser.c"
    break;

  case 10: /* line: UNDEF string_unquoted  */
#line 348 "parser.y"
                                        { undefine_config_variable((yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 2787 "parser.c"
    break;

  case 11: /* line: IFSTATEMENT '(' expression ')'  */
#line 349 "parser.y"
                                                 {
			/* NOTE:
			 * We _need_ absolutely to return to state stack 0
			 * because we 'backward' modify the input stream for
			 * the parser (in lexer). Hence, _if_ the parser needs
			 * to read one token more than needed, we are lost,
			 * because we can't discard it. So please, don't
			 * play with the grammar without knowing what you do.
			 * The ')' _will_ return to state stack 0, but fiddling
			 * with brackets '()' in the underlaying 'expression'
			 * rules may distroy this.
			 *                          -- Hans 971231
			 */
			tell_lexer_if((yyvsp[-1].i_value));
		}
#line 2807 "parser.c"
    break;

  case 12: /* line: WHILESTATEMENT INTEGER ',' '(' expression ')'  */
#line 371 "parser.y"
                                                                {
			tell_lexer_loop((yyvsp[-4].i_value), (yyvsp[-1].i_value));
		}
#line 2815 "parser.c"
    break;

  case 13: /* line: FOREACHSTATEMENT INTEGER ',' VARIABLE '(' string_expr ',' strarglist ')'  */
#line 374 "parser.y"
                                                                                           {
			tell_lexer_loop((yyvsp[-7].i_value), for_each_handling((yyvsp[-7].i_value),(yyvsp[-5].s_value),(yyvsp[-3].s_value),(yyvsp[-1].s_value)));
			free((yyvsp[-5].s_value)); free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 2824 "parser.c"
    break;

  case 14: /* line: SHELL '(' strarglist ')'  */
#line 378 "parser.y"
                                           {
			char *s = run_shell((yyvsp[-1].s_value));
			if (s) free(s);
			free((yyvsp[-1].s_value));
		}
#line 2834 "parser.c"
    break;

  case 15: /* line: VARIABLE '=' strarglist  */
#line 383 "parser.y"
                                          {
		    if (!parser_version_3_style_used) {
			parser_version_3_style_used = 1;
			define_config_variable(CONFNAME_V3USED);
		    }
		    if ((strpbrk((yyvsp[-2].s_value), "uhc") == (yyvsp[-2].s_value)) && ((yyvsp[-2].s_value)[1] == '_'))
			yyerror("reserved variable %s can't be set\n", (yyvsp[-2].s_value));
		    else
			setenv((yyvsp[-2].s_value), (yyvsp[0].s_value), 1);
		    free((yyvsp[-2].s_value)); free((yyvsp[0].s_value));
		}
#line 2850 "parser.c"
    break;

  case 17: /* line: EXPRTEST typed_expr  */
#line 395 "parser.y"
                                      {
		    if ((yyvsp[0].t_value).type == TYPE_REAL)
			c_printf("CONF TESTING: exprtest real %f\n", (yyvsp[0].t_value).value.r);
		    else
			c_printf("CONF TESTING: exprtest int %d\n", (yyvsp[0].t_value).value.i);
		}
#line 2861 "parser.c"
    break;

  case 18: /* line: ABORT strarglist  */
#line 406 "parser.y"
                    { if ((yyvsp[0].s_value)[0]) fprintf(stderr,"CONF aborted with: %s\n", (yyvsp[0].s_value));
			exit(99);
		    }
#line 2869 "parser.c"
    break;

  case 19: /* line: ERROR strarglist  */
#line 409 "parser.y"
                                   { if ((yyvsp[0].s_value)[0]) fprintf(stderr, "%s\n", (yyvsp[0].s_value)); }
#line 2875 "parser.c"
    break;

  case 20: /* line: WARN strarglist  */
#line 410 "parser.y"
                                        { warn("CONF: %s\n", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 2881 "parser.c"
    break;

  case 21: /* line: EMUSYS string_expr  */
#line 412 "parser.y"
                    {
		    free(config.emusys); config.emusys = (yyvsp[0].s_value);
		    c_printf("CONF: config.emusys = '%s'\n", (yyvsp[0].s_value));
		    }
#line 2890 "parser.c"
    break;

  case 22: /* line: EMUSYS '{' string_expr '}'  */
#line 417 "parser.y"
                    {
		    free(config.emusys); config.emusys = (yyvsp[-1].s_value);
		    c_printf("CONF: config.emusys = '%s'\n", (yyvsp[-1].s_value));
		    }
#line 2899 "parser.c"
    break;

  case 23: /* line: DOSEMUMAP string_expr  */
#line 422 "parser.y"
                    {
		    DOSEMU_MAP_PATH = (yyvsp[0].s_value);
		    c_printf("CONF: dosemu.map path = '%s'\n", (yyvsp[0].s_value));
		    }
#line 2908 "parser.c"
    break;

  case 24: /* line: MAPPINGDRIVER string_expr  */
#line 427 "parser.y"
                    {
		    free(config.mappingdriver); config.mappingdriver = (yyvsp[0].s_value);
		    c_printf("CONF: mapping driver = '%s'\n", (yyvsp[0].s_value));
		    }
#line 2917 "parser.c"
    break;

  case 25: /* line: FILE_LOCK_LIMIT INTEGER  */
#line 432 "parser.y"
                    {
		    config.file_lock_limit = (yyvsp[0].i_value);
		    }
#line 2925 "parser.c"
    break;

  case 26: /* line: LFN_SUPPORT bool  */
#line 436 "parser.y"
                    {
		    config.lfn = ((yyvsp[0].i_value)!=0);
		    }
#line 2933 "parser.c"
    break;

  case 27: /* line: FINT_REVECT bool  */
#line 440 "parser.y"
                    {
		    config.force_revect = ((yyvsp[0].i_value) == -2 ? 1 : (yyvsp[0].i_value));
		    }
#line 2941 "parser.c"
    break;

  case 28: /* line: SET_INT_HOOKS bool  */
#line 444 "parser.y"
                    {
		    config.int_hooks = ((yyvsp[0].i_value) == -2 ? 1 : (yyvsp[0].i_value));
		    }
#line 2949 "parser.c"
    break;

  case 29: /* line: TRACE_IRETS bool  */
#line 448 "parser.y"
                    {
		    config.trace_irets = ((yyvsp[0].i_value) == -2 ? 1 : (yyvsp[0].i_value));
		    }
#line 2957 "parser.c"
    break;

  case 30: /* line: FFS_REDIR bool  */
#line 452 "parser.y"
                    {
		    config.force_redir = ((yyvsp[0].i_value)!=0);
		    }
#line 2965 "parser.c"
    break;

  case 31: /* line: FASTFLOPPY floppy_bool  */
#line 456 "parser.y"
                        {
			config.fastfloppy = ((yyvsp[0].i_value)!=0);
			c_printf("CONF: fastfloppy = %d\n", config.fastfloppy);
			}
#line 2974 "parser.c"
    break;

  case 32: /* line: CPU expression  */
#line 461 "parser.y"
                        {
			int cpu = cpu_override (((yyvsp[0].i_value)%100)==86?((yyvsp[0].i_value)/100)%10:0);
			if (cpu > 0) {
				c_printf("CONF: CPU set to %d86\n",cpu);
				vm86s.cpu_type = cpu;
			}
			else
				yyerror("error in CPU user override\n");
			}
#line 2988 "parser.c"
    break;

  case 33: /* line: CPU_VM cpu_vm  */
#line 471 "parser.y"
                        {
			config.cpu_vm = (yyvsp[0].i_value);
			c_printf("CONF: CPU VM set to %d\n", config.cpu_vm);
			}
#line 2997 "parser.c"
    break;

  case 34: /* line: CPU_VM_DPMI cpu_vm_dpmi  */
#line 476 "parser.y"
                        {
			config.cpu_vm_dpmi = (yyvsp[0].i_value);
			c_printf("CONF: CPU VM set to %d for DPMI\n",
				 config.cpu_vm_dpmi);
			}
#line 3007 "parser.c"
    break;

  case 35: /* line: CPUEMU INTEGER  */
#line 482 "parser.y"
                        {
#ifdef X86_EMULATOR
			config.cpusim = (yyvsp[0].i_value);
			c_printf("CONF: CPUEMU set to %s\n",
				CONFIG_CPUSIM ? "sim" : "jit");
#endif
			}
#line 3019 "parser.c"
    break;

  case 36: /* line: CPUSPEED real_expression  */
#line 490 "parser.y"
                        { 
#if 0 /* no longer used, but left in for dosemu.conf compatibility */
			if (config.realcpu >= CPU_586) {
			  config.cpu_spd = ((double)LLF_US)/(yyvsp[0].r_value);
			  config.cpu_tick_spd = ((double)LLF_TICKS)/(yyvsp[0].r_value);
			  c_printf("CONF: CPU speed = %g\n", ((double)(yyvsp[0].r_value)));
			}
#endif
			}
#line 3033 "parser.c"
    break;

  case 37: /* line: CPUSPEED INTEGER INTEGER  */
#line 500 "parser.y"
                        { 
#if 0 /* no longer used, but left in for dosemu.conf compatibility */
			if (config.realcpu >= CPU_586) {
			  config.cpu_spd = (LLF_US*(yyvsp[0].i_value))/(yyvsp[-1].i_value);
			  config.cpu_tick_spd = (LLF_TICKS*(yyvsp[0].i_value))/(yyvsp[-1].i_value);
			  c_printf("CONF: CPU speed = %d/%d\n", (yyvsp[-1].i_value), (yyvsp[0].i_value));
			}
#endif
			}
#line 3047 "parser.c"
    break;

  case 38: /* line: RDTSC bool  */
#line 510 "parser.y"
                    {
			config.rdtsc = ((yyvsp[0].i_value)!=0);
			c_printf("CONF: %sabling use of pentium timer\n",
				(config.rdtsc?"En":"Dis"));
		    }
#line 3057 "parser.c"
    break;

  case 39: /* line: PCI bool  */
#line 516 "parser.y"
                    {
		      config.pci_video = ((yyvsp[0].i_value)!=0);
		      config.pci = (abs((yyvsp[0].i_value))==2); 
		    }
#line 3066 "parser.c"
    break;

  case 40: /* line: BOOTDRIVE string_expr  */
#line 521 "parser.y"
                    {
                      if ((yyvsp[0].s_value)[0] == 0) {
		        config.hdiskboot = -1;
		      } else if ((yyvsp[0].s_value)[0] >= 'a') {
		        config.hdiskboot = (yyvsp[0].s_value)[0] - 'a';
		      } else {
		        error("wrong value for $_bootdrive\n");
		        config.hdiskboot = -1;
		      }
		      free((yyvsp[0].s_value));
		    }
#line 3082 "parser.c"
    break;

  case 41: /* line: SWAP_BOOTDRIVE bool  */
#line 533 "parser.y"
                    {
		      config.swap_bootdrv = ((yyvsp[0].i_value)!=0);
		    }
#line 3090 "parser.c"
    break;

  case 42: /* line: DEFAULT_DRIVES int_expr  */
#line 537 "parser.y"
                    {
		      c_printf("default_drives %i\n", (yyvsp[0].i_value));
		      switch ((yyvsp[0].i_value)) {
		      case 0:
		        set_drive_c();
		        break;
		      case 1:
		        set_dosemu_drive();
		        set_default_drives();
		        break;
		      case 2:
		        set_dosemu_drive();
		        break;
		      default:
			error("Path group %i not implemented\n", (yyvsp[0].i_value));
			exit(1);
		      }
		    }
#line 3113 "parser.c"
    break;

  case 43: /* line: SKIP_DRIVES int_expr  */
#line 556 "parser.y"
                    {
		      c_printf("skip %i drives from %i\n", (yyvsp[0].i_value), c_hdisks);
		      config.drives_mask |= ((1 << (yyvsp[0].i_value)) - 1) << (c_hdisks +
			 skipped_disks + 2);
		      skipped_disks += (yyvsp[0].i_value);
		    }
#line 3124 "parser.c"
    break;

  case 44: /* line: TIMER expression  */
#line 563 "parser.y"
                    {
		    config.freq = (yyvsp[0].i_value);
		    if ((yyvsp[0].i_value)) {
		        config.update = 1000000 / (yyvsp[0].i_value);
		    } else {
			config.update = 54925;
			config.freq = 18;
		    }
		    c_printf("CONF: timer freq=%d, update=%d\n",config.freq,config.update);
		    }
#line 3139 "parser.c"
    break;

  case 45: /* line: LOGBUFSIZE expression  */
#line 574 "parser.y"
                    {
		      char *b;
		      flush_log();
		      b = malloc((yyvsp[0].i_value)+1024);
		      if (!b) {
			error("cannot get logbuffer\n");
			exit(1);
		      }
		      logptr = logbuf = b;
		      logbuf_size = (yyvsp[0].i_value);
		    }
#line 3155 "parser.c"
    break;

  case 46: /* line: LOGFILESIZE expression  */
#line 586 "parser.y"
                    {
		      logfile_limit = (yyvsp[0].i_value);
		    }
#line 3163 "parser.c"
    break;

  case 47: /* line: EMURETRACE bool  */
#line 590 "parser.y"
                    {
		    if ((yyvsp[0].i_value) && !config.emuretrace && priv_lvl)
		      yyerror("Can not modify video port access in user config file");
		    config.emuretrace = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: emu_retrace %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3174 "parser.c"
    break;

  case 49: /* line: L_EMS int_bool  */
#line 598 "parser.y"
                    {
		    if ((yyvsp[0].i_value) >= 0) config.ems_size = (yyvsp[0].i_value);
		    if ((yyvsp[0].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[0].i_value));
		    }
#line 3183 "parser.c"
    break;

  case 50: /* line: UMB_A0 bool  */
#line 603 "parser.y"
                    {
		    config.umb_a0 = (yyvsp[0].i_value);
		    if ((yyvsp[0].i_value) > 0) c_printf("CONF: umb at 0a0000: %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3192 "parser.c"
    break;

  case 51: /* line: UMB_B0 bool  */
#line 608 "parser.y"
                    {
		    config.umb_b0 = ((yyvsp[0].i_value)!=0);
		    if ((yyvsp[0].i_value) > 0) c_printf("CONF: umb at 0b0000: %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3201 "parser.c"
    break;

  case 52: /* line: UMB_F0 bool  */
#line 613 "parser.y"
                    {
		    config.umb_f0 = ((yyvsp[0].i_value)!=0);
		    if ((yyvsp[0].i_value) > 0) c_printf("CONF: umb at 0f0000: %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3210 "parser.c"
    break;

  case 53: /* line: L_DPMI int_bool  */
#line 618 "parser.y"
                    {
		    if ((yyvsp[0].i_value)>=0) config.dpmi = (yyvsp[0].i_value);
		    c_printf("CONF: DPMI-Server %s (%#x)\n", ((yyvsp[0].i_value)) ? "on" : "off", ((yyvsp[0].i_value)));
		    }
#line 3219 "parser.c"
    break;

  case 54: /* line: DPMI_LIN_RSV_BASE int_bool  */
#line 623 "parser.y"
                    {
		    config.dpmi_lin_rsv_base = (yyvsp[0].i_value);
		    c_printf("CONF: DPMI linear reserve base addr = %#x\n", (yyvsp[0].i_value));
		    }
#line 3228 "parser.c"
    break;

  case 55: /* line: DPMI_LIN_RSV_SIZE int_bool  */
#line 628 "parser.y"
                    {
		    config.dpmi_lin_rsv_size = (yyvsp[0].i_value);
		    c_printf("CONF: DPMI linear reserve size = %#x\n", (yyvsp[0].i_value));
		    }
#line 3237 "parser.c"
    break;

  case 56: /* line: PM_DOS_API bool  */
#line 633 "parser.y"
                    {
		    config.pm_dos_api = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: PM DOS API Translator %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3246 "parser.c"
    break;

  case 57: /* line: NO_NULL_CHECKS bool  */
#line 638 "parser.y"
                    {
		    config.no_null_checks = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: No DJGPP NULL deref checks: %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3255 "parser.c"
    break;

  case 58: /* line: DOSMEM int_bool  */
#line 642 "parser.y"
                                        { if ((yyvsp[0].i_value)>=0) config.mem_size = (yyvsp[0].i_value); }
#line 3261 "parser.c"
    break;

  case 59: /* line: EXT_MEM int_bool  */
#line 644 "parser.y"
                    {
		    if ((yyvsp[0].i_value)>=0) config.ext_mem = (yyvsp[0].i_value);
		    if ((yyvsp[0].i_value) > 0) c_printf("CONF: %dk bytes XMS memory\n", (yyvsp[0].i_value));
		    }
#line 3270 "parser.c"
    break;

  case 60: /* line: MATHCO bool  */
#line 648 "parser.y"
                                        { config.mathco = ((yyvsp[0].i_value)!=0); }
#line 3276 "parser.c"
    break;

  case 61: /* line: IPXSUPPORT bool  */
#line 650 "parser.y"
                    {
		    config.ipxsup = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: IPX support %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3285 "parser.c"
    break;

  case 62: /* line: IPXNETWORK int_bool  */
#line 654 "parser.y"
                                        { config.ipx_net = (yyvsp[0].i_value); }
#line 3291 "parser.c"
    break;

  case 63: /* line: PKTDRIVER bool  */
#line 656 "parser.y"
                    {
			config.pktdrv = ((yyvsp[0].i_value)!=0);
			c_printf("CONF: Packet Driver %s.\n", 
				((yyvsp[0].i_value)) ? "enabled" : "disabled");
		    }
#line 3301 "parser.c"
    break;

  case 64: /* line: NE2K bool  */
#line 662 "parser.y"
                    {
			config.ne2k = ((yyvsp[0].i_value)!=0);
			c_printf("CONF: NE2000 %s.\n", 
				((yyvsp[0].i_value)) ? "enabled" : "disabled");
		    }
#line 3311 "parser.c"
    break;

  case 65: /* line: ETHDEV string_expr  */
#line 667 "parser.y"
                                        { free(config.ethdev); config.ethdev = (yyvsp[0].s_value); }
#line 3317 "parser.c"
    break;

  case 66: /* line: TAPDEV string_expr  */
#line 668 "parser.y"
                                        { free(config.tapdev); config.tapdev = (yyvsp[0].s_value); }
#line 3323 "parser.c"
    break;

  case 67: /* line: VDESWITCH string_expr  */
#line 669 "parser.y"
                                        { free(config.vdeswitch); config.vdeswitch = (yyvsp[0].s_value); }
#line 3329 "parser.c"
    break;

  case 68: /* line: SLIRPARGS string_expr  */
#line 670 "parser.y"
                                        { free(config.slirp_args); config.slirp_args = (yyvsp[0].s_value); }
#line 3335 "parser.c"
    break;

  case 69: /* line: NOVELLHACK bool  */
#line 671 "parser.y"
                                        { config.pktflags = ((yyvsp[0].i_value)!=0); }
#line 3341 "parser.c"
    break;

  case 70: /* line: VNET string_expr  */
#line 672 "parser.y"
                                        { start_vnet((yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 3347 "parser.c"
    break;

  case 71: /* line: SPEAKER speaker  */
#line 674 "parser.y"
                    {
		    if ((yyvsp[0].i_value) == SPKR_NATIVE) {
		      if (can_do_root_stuff) {
                        c_printf("CONF: allowing speaker port access!\n");
		      } else {
                        c_printf("CONF: native speaker not allowed: emulate\n");
			(yyvsp[0].i_value) = SPKR_EMULATED;
		      }
		    }
		    else
                      c_printf("CONF: not allowing speaker port access\n");
		    config.speaker = (yyvsp[0].i_value);
		    }
#line 3365 "parser.c"
    break;

  case 72: /* $@1: %empty  */
#line 688 "parser.y"
                    { start_video(); }
#line 3371 "parser.c"
    break;

  case 73: /* line: VIDEO $@1 '{' video_flags '}'  */
#line 690 "parser.y"
                    { stop_video(); }
#line 3377 "parser.c"
    break;

  case 74: /* line: VGA_FONTS bool  */
#line 692 "parser.y"
                    { config.vga_fonts = ((yyvsp[0].i_value)!=0); }
#line 3383 "parser.c"
    break;

  case 75: /* line: XTERM_TITLE string_expr  */
#line 693 "parser.y"
                                          { free(config.xterm_title); config.xterm_title = (yyvsp[0].s_value); }
#line 3389 "parser.c"
    break;

  case 76: /* line: TERMINAL '{' term_flags '}'  */
#line 696 "parser.y"
                    { stop_terminal(); }
#line 3395 "parser.c"
    break;

  case 77: /* line: DEBUG strarglist  */
#line 697 "parser.y"
                                   {
			parse_debugflags((yyvsp[0].s_value), 1);
			free((yyvsp[0].s_value));
		}
#line 3404 "parser.c"
    break;

  case 78: /* $@2: %empty  */
#line 702 "parser.y"
                    { start_debug(); }
#line 3410 "parser.c"
    break;

  case 80: /* $@3: %empty  */
#line 705 "parser.y"
                    { start_mouse(); }
#line 3416 "parser.c"
    break;

  case 81: /* line: MOUSE $@3 '{' mouse_flags '}'  */
#line 707 "parser.y"
                    { stop_mouse(); }
#line 3422 "parser.c"
    break;

  case 82: /* line: TTYLOCKS '{' ttylocks_flags '}'  */
#line 710 "parser.y"
                    { stop_ttylocks(); }
#line 3428 "parser.c"
    break;

  case 83: /* $@4: %empty  */
#line 712 "parser.y"
                    { start_serial(); }
#line 3434 "parser.c"
    break;

  case 84: /* line: SERIAL $@4 '{' serial_flags '}'  */
#line 714 "parser.y"
                    { stop_serial(); }
#line 3440 "parser.c"
    break;

  case 85: /* $@5: %empty  */
#line 716 "parser.y"
                    { start_keyboard(); }
#line 3446 "parser.c"
    break;

  case 87: /* $@6: %empty  */
#line 719 "parser.y"
                        {keytable_start((yyvsp[0].s_value)); free((yyvsp[0].s_value));}
#line 3452 "parser.c"
    break;

  case 88: /* line: KEYTABLE string_expr $@6 '{' keyboard_mods '}'  */
#line 721 "parser.y"
                        {keytable_stop();}
#line 3458 "parser.c"
    break;

  case 89: /* line: PRESTROKE string_expr  */
#line 723 "parser.y"
                    {
		    append_pre_strokes((yyvsp[0].s_value));
		    c_printf("CONF: appending pre-strokes '%s'\n", (yyvsp[0].s_value));
		    free((yyvsp[0].s_value));
		    }
#line 3468 "parser.c"
    break;

  case 90: /* line: KEYTABLE DUMP string_expr  */
#line 728 "parser.y"
                                            {
			dump_keytables_to_file((yyvsp[0].s_value));
			free((yyvsp[0].s_value));
		    }
#line 3477 "parser.c"
    break;

  case 91: /* $@7: %empty  */
#line 733 "parser.y"
                    { start_ports(); }
#line 3483 "parser.c"
    break;

  case 94: /* $@8: %empty  */
#line 737 "parser.y"
                   { config.mmio_tracing = 1; }
#line 3489 "parser.c"
    break;

  case 96: /* $@9: %empty  */
#line 740 "parser.y"
                    { start_disk(); }
#line 3495 "parser.c"
    break;

  case 97: /* line: DISK $@9 '{' disk_flags '}'  */
#line 742 "parser.y"
                    { stop_disk(DISK); }
#line 3501 "parser.c"
    break;

  case 98: /* $@10: %empty  */
#line 744 "parser.y"
                    { start_floppy(); }
#line 3507 "parser.c"
    break;

  case 99: /* line: L_FLOPPY $@10 '{' floppy_flags '}'  */
#line 746 "parser.y"
                    { stop_disk(L_FLOPPY); }
#line 3513 "parser.c"
    break;

  case 100: /* line: CDROM '{' string_expr '}'  */
#line 748 "parser.y"
                    {
		    static int which = 0;
		    if (which >= 3) {
			c_printf("CONF: too many cdrom drives defined\n");
			free((yyvsp[-1].s_value));
		    }
		    else {
			Path_cdrom[which] = (yyvsp[-1].s_value);
			c_printf("CONF: cdrom MSCD000%d on %s\n", which+1 ,(yyvsp[-1].s_value));
			which++;
		    }
		    }
#line 3530 "parser.c"
    break;

  case 101: /* line: ASPI '{' string_expr DEVICETYPE string_expr TARGET expression '}'  */
#line 761 "parser.y"
                    {
		    char *s = aspi_add_device((yyvsp[-5].s_value), (yyvsp[-3].s_value), (yyvsp[-1].i_value));
		    if (s) {
			c_printf("CONF: aspi available for %s\n", s);
			free(s);
		    }
		    else c_printf("CONF: aspi device %s not available\n", (yyvsp[-5].s_value));
		    free((yyvsp[-5].s_value));
		    free((yyvsp[-3].s_value));
		    }
#line 3545 "parser.c"
    break;

  case 102: /* $@11: %empty  */
#line 772 "parser.y"
                    { start_printer(); }
#line 3551 "parser.c"
    break;

  case 103: /* line: PRINTER $@11 '{' printer_flags '}'  */
#line 774 "parser.y"
                    { stop_printer(); }
#line 3557 "parser.c"
    break;

  case 106: /* line: SOUND bool  */
#line 777 "parser.y"
                                { config.sound = ((yyvsp[0].i_value)!=0); }
#line 3563 "parser.c"
    break;

  case 108: /* line: L_JOYSTICK bool  */
#line 779 "parser.y"
                                  { if (! (yyvsp[0].i_value)) { config.joy_device[0] = config.joy_device[1] = NULL; } }
#line 3569 "parser.c"
    break;

  case 110: /* $@12: %empty  */
#line 782 "parser.y"
                    { config.sillyint=0; }
#line 3575 "parser.c"
    break;

  case 112: /* line: SILLYINT irq_bool  */
#line 785 "parser.y"
                    { if ((yyvsp[0].i_value)) {
		        config.sillyint = 1 << (yyvsp[0].i_value);
		        c_printf("CONF: IRQ %d for irqpassing\n", (yyvsp[0].i_value));
		      }
		    }
#line 3585 "parser.c"
    break;

  case 113: /* $@13: %empty  */
#line 791 "parser.y"
                    {
		    if (priv_lvl)
		      yyerror("Can not change hardware ram access settings in user config file");
		    }
#line 3594 "parser.c"
    break;

  case 115: /* line: FEATURE '{' expression '=' expression '}'  */
#line 797 "parser.y"
                    {
			handle_features((yyvsp[-3].i_value), (yyvsp[-1].i_value));
		    }
#line 3602 "parser.c"
    break;

  case 116: /* line: CLI_TIMEOUT int_bool  */
#line 801 "parser.y"
                    { config.cli_timeout = (yyvsp[0].i_value); }
#line 3608 "parser.c"
    break;

  case 117: /* line: TIMEMODE string_expr  */
#line 803 "parser.y"
                    {
		    config.timemode = parse_timemode((yyvsp[0].s_value));
		    c_printf("CONF: time mode = '%s'\n", (yyvsp[0].s_value));
		    free((yyvsp[0].s_value));
		    }
#line 3618 "parser.c"
    break;

  case 118: /* line: UEXEC string_expr  */
#line 809 "parser.y"
                    { free(config.unix_exec); config.unix_exec = (yyvsp[0].s_value); }
#line 3624 "parser.c"
    break;

  case 119: /* line: LPATHS string_expr  */
#line 811 "parser.y"
                    { free(config.lredir_paths); config.lredir_paths = (yyvsp[0].s_value); }
#line 3630 "parser.c"
    break;

  case 120: /* line: HDRIVES string_expr  */
#line 813 "parser.y"
                    { set_hostfs_drives((yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 3636 "parser.c"
    break;

  case 121: /* line: STRING  */
#line 815 "parser.y"
                    { yyerror("unrecognized command '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 3642 "parser.c"
    break;

  case 123: /* expression: typed_expr  */
#line 819 "parser.y"
                           { (yyval.i_value) = TOF((yyvsp[0].t_value)); }
#line 3648 "parser.c"
    break;

  case 124: /* real_expression: typed_expr  */
#line 822 "parser.y"
                           { (yyval.r_value) = TOF((yyvsp[0].t_value)); }
#line 3654 "parser.c"
    break;

  case 125: /* typed_expr: int_expr  */
#line 827 "parser.y"
                           {(yyval.t_value).type = TYPE_INTEGER; (yyval.t_value).value.i=(yyvsp[0].i_value);}
#line 3660 "parser.c"
    break;

  case 126: /* typed_expr: bool_expr  */
#line 828 "parser.y"
                            {(yyval.t_value).type = TYPE_BOOLEAN; (yyval.t_value).value.i=(yyvsp[0].i_value);}
#line 3666 "parser.c"
    break;

  case 127: /* typed_expr: real_expr  */
#line 829 "parser.y"
                            {(yyval.t_value).type = TYPE_REAL; (yyval.t_value).value.r=(yyvsp[0].r_value);}
#line 3672 "parser.c"
    break;

  case 128: /* typed_expr: typed_expr '+' typed_expr  */
#line 831 "parser.y"
                        {V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[-2].t_value)) + TOF((yyvsp[0].t_value))); }
#line 3678 "parser.c"
    break;

  case 129: /* typed_expr: typed_expr '-' typed_expr  */
#line 833 "parser.y"
                        {V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[-2].t_value)) - TOF((yyvsp[0].t_value))); }
#line 3684 "parser.c"
    break;

  case 130: /* typed_expr: typed_expr '*' typed_expr  */
#line 835 "parser.y"
                        {V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[-2].t_value)) * TOF((yyvsp[0].t_value))); }
#line 3690 "parser.c"
    break;

  case 131: /* typed_expr: typed_expr '/' typed_expr  */
#line 836 "parser.y"
                                            {
			if (TOF((yyvsp[0].t_value)))	V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[-2].t_value)) / TOF((yyvsp[0].t_value)));
			else V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[0].t_value)));
		}
#line 3699 "parser.c"
    break;

  case 132: /* typed_expr: '-' typed_expr  */
#line 841 "parser.y"
                        {V_VAL((yyval.t_value),(yyvsp[0].t_value),-TOF((yyvsp[0].t_value))); }
#line 3705 "parser.c"
    break;

  case 133: /* typed_expr: '+' typed_expr  */
#line 843 "parser.y"
                        {V_VAL((yyval.t_value),(yyvsp[0].t_value),TOF((yyvsp[0].t_value))); }
#line 3711 "parser.c"
    break;

  case 134: /* typed_expr: typed_expr SHR_OP typed_expr  */
#line 845 "parser.y"
                        { unsigned int shift = (1 << (int)TOF((yyvsp[0].t_value)));
			if (!shift) (yyval.t_value) = (yyvsp[-2].t_value);
			else V_VAL((yyval.t_value), (yyvsp[-2].t_value), TOF((yyvsp[-2].t_value)) / shift);}
#line 3719 "parser.c"
    break;

  case 135: /* typed_expr: typed_expr SHL_OP typed_expr  */
#line 849 "parser.y"
                        { unsigned int shift = (1 << (int)TOF((yyvsp[0].t_value)));
			if (!shift) (yyval.t_value) = (yyvsp[-2].t_value);
			else V_VAL((yyval.t_value), (yyvsp[-2].t_value), TOF((yyvsp[-2].t_value)) * shift);}
#line 3727 "parser.c"
    break;

  case 136: /* typed_expr: variable_content  */
#line 852 "parser.y"
                                   {
			char *s;
			(yyval.t_value).type = TYPE_INTEGER;
			(yyval.t_value).value.i = strtoul((yyvsp[0].s_value),&s,0);
			switch (*s) {
				case '.':  case 'e':  case 'E':
				/* we assume a real number */
				(yyval.t_value).type = TYPE_REAL;
				(yyval.t_value).value.r = strtod((yyvsp[0].s_value),0);
			}
			free((yyvsp[0].s_value));
		}
#line 3744 "parser.c"
    break;

  case 137: /* typed_expr: '(' typed_expr ')'  */
#line 864 "parser.y"
                                     {(yyval.t_value) = (yyvsp[-1].t_value);}
#line 3750 "parser.c"
    break;

  case 139: /* int_expr: typed_expr AND_OP typed_expr  */
#line 869 "parser.y"
                        {(yyval.i_value) = (int)TOF((yyvsp[-2].t_value)) & (int)TOF((yyvsp[0].t_value)); }
#line 3756 "parser.c"
    break;

  case 140: /* int_expr: typed_expr OR_OP typed_expr  */
#line 871 "parser.y"
                        {(yyval.i_value) = (int)TOF((yyvsp[-2].t_value)) | (int)TOF((yyvsp[0].t_value)); }
#line 3762 "parser.c"
    break;

  case 141: /* int_expr: typed_expr XOR_OP typed_expr  */
#line 873 "parser.y"
                        {(yyval.i_value) = (int)TOF((yyvsp[-2].t_value)) ^ (int)TOF((yyvsp[0].t_value)); }
#line 3768 "parser.c"
    break;

  case 142: /* int_expr: BIT_NOT_OP typed_expr  */
#line 875 "parser.y"
                        {(yyval.i_value) = (int)TOF((yyvsp[0].t_value)) ^ (-1); }
#line 3774 "parser.c"
    break;

  case 143: /* int_expr: L_AUTO  */
#line 876 "parser.y"
                                {(yyval.i_value) = -1; }
#line 3780 "parser.c"
    break;

  case 144: /* int_expr: INTCAST '(' typed_expr ')'  */
#line 877 "parser.y"
                                             {(yyval.i_value) = TOF((yyvsp[-1].t_value));}
#line 3786 "parser.c"
    break;

  case 145: /* int_expr: STRTOL '(' string_expr ')'  */
#line 878 "parser.y"
                                             {
			(yyval.i_value) = strtol((yyvsp[-1].s_value),0,0);
			free((yyvsp[-1].s_value));
		}
#line 3795 "parser.c"
    break;

  case 146: /* int_expr: STRLEN '(' string_expr ')'  */
#line 882 "parser.y"
                                             {
			(yyval.i_value) = strlen((yyvsp[-1].s_value));
			free((yyvsp[-1].s_value));
		}
#line 3804 "parser.c"
    break;

  case 147: /* int_expr: STRNCMP '(' string_expr ',' string_expr ',' expression ')'  */
#line 886 "parser.y"
                                                                             {
			(yyval.i_value) = strncmp((yyvsp[-5].s_value),(yyvsp[-3].s_value),(yyvsp[-1].i_value));
			free((yyvsp[-5].s_value)); free((yyvsp[-3].s_value));
		}
#line 3813 "parser.c"
    break;

  case 148: /* int_expr: STRPBRK '(' string_expr ',' string_expr ')'  */
#line 890 "parser.y"
                                                              {
			char *s = strpbrk((yyvsp[-3].s_value),(yyvsp[-1].s_value));
			if (s) (yyval.i_value) = s - (yyvsp[-3].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 3824 "parser.c"
    break;

  case 149: /* int_expr: STRCHR '(' string_expr ',' string_expr ')'  */
#line 896 "parser.y"
                                                             {
			char *s = strchr((yyvsp[-3].s_value),(yyvsp[-1].s_value)[0]);
			if (s) (yyval.i_value) = s - (yyvsp[-3].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 3835 "parser.c"
    break;

  case 150: /* int_expr: STRRCHR '(' string_expr ',' string_expr ')'  */
#line 902 "parser.y"
                                                              {
			char *s = strrchr((yyvsp[-3].s_value),(yyvsp[-1].s_value)[0]);
			if (s) (yyval.i_value) = s - (yyvsp[-3].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 3846 "parser.c"
    break;

  case 151: /* int_expr: STRSTR '(' string_expr ',' string_expr ')'  */
#line 908 "parser.y"
                                                             {
			char *s = strstr((yyvsp[-3].s_value),(yyvsp[-1].s_value));
			if (s) (yyval.i_value) = s - (yyvsp[-3].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 3857 "parser.c"
    break;

  case 152: /* int_expr: STRSPN '(' string_expr ',' string_expr ')'  */
#line 914 "parser.y"
                                                             {
			(yyval.i_value) = strspn((yyvsp[-3].s_value),(yyvsp[-1].s_value));
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 3866 "parser.c"
    break;

  case 153: /* int_expr: STRCSPN '(' string_expr ',' string_expr ')'  */
#line 918 "parser.y"
                                                              {
			(yyval.i_value) = strcspn((yyvsp[-3].s_value),(yyvsp[-1].s_value));
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 3875 "parser.c"
    break;

  case 154: /* int_expr: STRING  */
#line 922 "parser.y"
                         {
			if ( (yyvsp[0].s_value)[0] == '\'' && (yyvsp[0].s_value)[1] && (yyvsp[0].s_value)[2] == '\'' && !(yyvsp[0].s_value)[3] )
				(yyval.i_value) = (yyvsp[0].s_value)[1];
			else	yyerror("unrecognized expression '%s'", (yyvsp[0].s_value));
			free((yyvsp[0].s_value));
		}
#line 3886 "parser.c"
    break;

  case 155: /* bool_expr: typed_expr EQ_OP typed_expr  */
#line 931 "parser.y"
                        {(yyval.i_value) = TOF((yyvsp[-2].t_value)) == TOF((yyvsp[0].t_value)); }
#line 3892 "parser.c"
    break;

  case 156: /* bool_expr: typed_expr NEQ_OP typed_expr  */
#line 933 "parser.y"
                        {(yyval.i_value) = TOF((yyvsp[-2].t_value)) != TOF((yyvsp[0].t_value)); }
#line 3898 "parser.c"
    break;

  case 157: /* bool_expr: typed_expr GE_OP typed_expr  */
#line 935 "parser.y"
                        {(yyval.i_value) = TOF((yyvsp[-2].t_value)) >= TOF((yyvsp[0].t_value)); }
#line 3904 "parser.c"
    break;

  case 158: /* bool_expr: typed_expr LE_OP typed_expr  */
#line 937 "parser.y"
                        {(yyval.i_value) = TOF((yyvsp[-2].t_value)) <= TOF((yyvsp[0].t_value)); }
#line 3910 "parser.c"
    break;

  case 159: /* bool_expr: typed_expr '<' typed_expr  */
#line 939 "parser.y"
                        {(yyval.i_value) = TOF((yyvsp[-2].t_value)) < TOF((yyvsp[0].t_value)); }
#line 3916 "parser.c"
    break;

  case 160: /* bool_expr: typed_expr '>' typed_expr  */
#line 941 "parser.y"
                        {(yyval.i_value) = TOF((yyvsp[-2].t_value)) > TOF((yyvsp[0].t_value)); }
#line 3922 "parser.c"
    break;

  case 161: /* bool_expr: typed_expr L_AND_OP typed_expr  */
#line 943 "parser.y"
                        {(yyval.i_value) = TOF((yyvsp[-2].t_value)) && TOF((yyvsp[0].t_value)); }
#line 3928 "parser.c"
    break;

  case 162: /* bool_expr: typed_expr L_OR_OP typed_expr  */
#line 945 "parser.y"
                        {(yyval.i_value) = TOF((yyvsp[-2].t_value)) || TOF((yyvsp[0].t_value)); }
#line 3934 "parser.c"
    break;

  case 163: /* bool_expr: string_expr STR_EQ_OP string_expr  */
#line 947 "parser.y"
                        {(yyval.i_value) = strcmp((yyvsp[-2].s_value),(yyvsp[0].s_value)) == 0; free((yyvsp[-2].s_value)); free((yyvsp[0].s_value)); }
#line 3940 "parser.c"
    break;

  case 164: /* bool_expr: string_expr STR_NEQ_OP string_expr  */
#line 949 "parser.y"
                        {(yyval.i_value) = strcmp((yyvsp[-2].s_value),(yyvsp[0].s_value)) != 0; free((yyvsp[-2].s_value)); free((yyvsp[0].s_value)); }
#line 3946 "parser.c"
    break;

  case 165: /* bool_expr: NOT_OP typed_expr  */
#line 950 "parser.y"
                                    {(yyval.i_value) = (TOF((yyvsp[0].t_value)) ? 0:1); }
#line 3952 "parser.c"
    break;

  case 166: /* bool_expr: L_YES  */
#line 951 "parser.y"
                                {(yyval.i_value) = -2; }
#line 3958 "parser.c"
    break;

  case 167: /* bool_expr: L_NO  */
#line 952 "parser.y"
                                {(yyval.i_value) = 0; }
#line 3964 "parser.c"
    break;

  case 168: /* bool_expr: L_ON  */
#line 953 "parser.y"
                                {(yyval.i_value) = -2; }
#line 3970 "parser.c"
    break;

  case 169: /* bool_expr: L_OFF  */
#line 954 "parser.y"
                                {(yyval.i_value) = 0; }
#line 3976 "parser.c"
    break;

  case 170: /* bool_expr: DEFINED '(' string_unquoted ')'  */
#line 955 "parser.y"
                                                  {
			(yyval.i_value) = get_config_variable((yyvsp[-1].s_value)) !=0;
			free((yyvsp[-1].s_value));
		}
#line 3985 "parser.c"
    break;

  case 172: /* real_expr: REALCAST '(' typed_expr ')'  */
#line 962 "parser.y"
                                              {(yyval.r_value) = TOF((yyvsp[-1].t_value));}
#line 3991 "parser.c"
    break;

  case 173: /* variable_content: VARIABLE  */
#line 966 "parser.y"
                         {
			const char *s = (yyvsp[0].s_value);
			if (get_config_variable(s))
				s = "1";
			else if (strncmp("c_",s,2)
					&& strncmp("u_",s,2)
					&& strncmp("h_",s,2) ) {
				s = checked_getenv(s);
				if (!s) s = "";
			}
			else
				s = "0";
			(yyval.s_value) = strdup(s);
			free((yyvsp[0].s_value));
		}
#line 4011 "parser.c"
    break;

  case 174: /* string_unquoted: STRING  */
#line 983 "parser.y"
                       {
			(yyval.s_value) = (yyvsp[0].s_value);
			if ((yyval.s_value)[0] == '\'' || (yyval.s_value)[0] == '\"') {
				size_t len = strlen((yyvsp[0].s_value)) - 2;
				memmove((yyval.s_value), (yyval.s_value)+1, len);
				(yyval.s_value)[len] = '\0';
			}
		}
#line 4024 "parser.c"
    break;

  case 176: /* string_expr: STRCAT '(' strarglist ')'  */
#line 994 "parser.y"
                                            {(yyval.s_value) = (yyvsp[-1].s_value); }
#line 4030 "parser.c"
    break;

  case 177: /* string_expr: STRSPLIT '(' string_expr ',' expression ',' expression ')'  */
#line 995 "parser.y"
                                                                             {
			int i = (yyvsp[-3].i_value);
			int len = (yyvsp[-1].i_value);
			int slen = strlen((yyvsp[-5].s_value));
			if ((i >=0) && (i < slen) && (len > 0)) {
				if ((i+len) > slen) len = slen - i;
				(yyvsp[-5].s_value)[i+len] = 0;
				(yyval.s_value) = strdup((yyvsp[-5].s_value) + i);
			}
			else
				(yyval.s_value) = strdup("");
			free((yyvsp[-5].s_value));
		}
#line 4048 "parser.c"
    break;

  case 178: /* string_expr: STRDEL '(' string_expr ',' expression ',' expression ')'  */
#line 1008 "parser.y"
                                                                           {
			int i = (yyvsp[-3].i_value);
			int len = (yyvsp[-1].i_value);
			int slen = strlen((yyvsp[-5].s_value));
			char *s = strdup((yyvsp[-5].s_value));
			if ((i >=0) && (i < slen) && (len > 0)) {
				if ((i+len) > slen) s[i] = 0;
				else memmove(s+i, s+i+len, slen-i-len+1);
			}
			free((yyvsp[-5].s_value));
			(yyval.s_value) = s;
		}
#line 4065 "parser.c"
    break;

  case 179: /* string_expr: SHELL '(' strarglist ')'  */
#line 1020 "parser.y"
                                           {
			(yyval.s_value) = run_shell((yyvsp[-1].s_value));
			free((yyvsp[-1].s_value));
		}
#line 4074 "parser.c"
    break;

  case 180: /* string_expr: variable_content  */
#line 1024 "parser.y"
                                   {(yyval.s_value) = (yyvsp[0].s_value);}
#line 4080 "parser.c"
    break;

  case 182: /* strarglist: strarglist ',' strarglist_item  */
#line 1028 "parser.y"
                                                 {
			char *s = malloc(strlen((yyvsp[-2].s_value))+strlen((yyvsp[0].s_value))+1);
			strcpy(s, (yyvsp[-2].s_value));
			strcat(s, (yyvsp[0].s_value));
			(yyval.s_value) = s;
			free((yyvsp[-2].s_value)); free((yyvsp[0].s_value));
		}
#line 4092 "parser.c"
    break;

  case 184: /* strarglist_item: '(' typed_expr ')'  */
#line 1038 "parser.y"
                                     {
			int ret;
			if ((yyvsp[-1].t_value).type == TYPE_REAL) {
				ret = asprintf(&(yyval.s_value), "%g", (yyvsp[-1].t_value).value.r);
				assert(ret != -1);
			} else {
				ret = asprintf(&(yyval.s_value), "%d", (yyvsp[-1].t_value).value.i);
				assert(ret != -1);
			}
		}
#line 4107 "parser.c"
    break;

  case 185: /* check_user_var_list: VARIABLE  */
#line 1051 "parser.y"
                         {
			check_user_var((yyvsp[0].s_value));
			free((yyvsp[0].s_value));
		}
#line 4116 "parser.c"
    break;

  case 186: /* check_user_var_list: check_user_var_list ',' VARIABLE  */
#line 1055 "parser.y"
                                                   {
			check_user_var((yyvsp[0].s_value));
			free((yyvsp[0].s_value));
		}
#line 4125 "parser.c"
    break;

  case 189: /* x_flag: L_DISPLAY string_expr  */
#line 1066 "parser.y"
                                        { free(config.X_display); config.X_display = (yyvsp[0].s_value); }
#line 4131 "parser.c"
    break;

  case 190: /* x_flag: L_TITLE string_expr  */
#line 1067 "parser.y"
                                        { free(config.X_title); config.X_title = (yyvsp[0].s_value); }
#line 4137 "parser.c"
    break;

  case 191: /* x_flag: X_TITLE_SHOW_APPNAME bool  */
#line 1068 "parser.y"
                                                { config.X_title_show_appname = ((yyvsp[0].i_value)!=0); }
#line 4143 "parser.c"
    break;

  case 192: /* x_flag: ICON_NAME string_expr  */
#line 1069 "parser.y"
                                        { free(config.X_icon_name); config.X_icon_name = (yyvsp[0].s_value); }
#line 4149 "parser.c"
    break;

  case 193: /* x_flag: X_BLINKRATE expression  */
#line 1070 "parser.y"
                                                { config.X_blinkrate = (yyvsp[0].i_value); }
#line 4155 "parser.c"
    break;

  case 194: /* x_flag: X_SHARECMAP  */
#line 1071 "parser.y"
                                        { config.X_sharecmap = 1; }
#line 4161 "parser.c"
    break;

  case 195: /* x_flag: X_MITSHM  */
#line 1072 "parser.y"
                                        { config.X_mitshm = 1; }
#line 4167 "parser.c"
    break;

  case 196: /* x_flag: X_MITSHM bool  */
#line 1073 "parser.y"
                                        { config.X_mitshm = ((yyvsp[0].i_value)!=0); }
#line 4173 "parser.c"
    break;

  case 197: /* x_flag: X_FONT string_expr  */
#line 1074 "parser.y"
                                                { free(config.X_font); config.X_font = (yyvsp[0].s_value); }
#line 4179 "parser.c"
    break;

  case 198: /* x_flag: X_FIXED_ASPECT bool  */
#line 1075 "parser.y"
                                        { config.X_fixed_aspect = ((yyvsp[0].i_value)!=0); }
#line 4185 "parser.c"
    break;

  case 199: /* x_flag: X_ASPECT_43  */
#line 1076 "parser.y"
                                        { config.X_aspect_43 = 1; }
#line 4191 "parser.c"
    break;

  case 200: /* x_flag: X_LIN_FILT  */
#line 1077 "parser.y"
                                        { config.X_lin_filt = 1; }
#line 4197 "parser.c"
    break;

  case 201: /* x_flag: X_BILIN_FILT  */
#line 1078 "parser.y"
                                        { config.X_bilin_filt = 1; }
#line 4203 "parser.c"
    break;

  case 202: /* x_flag: X_MODE13FACT expression  */
#line 1079 "parser.y"
                                           { config.X_mode13fact = (yyvsp[0].i_value); }
#line 4209 "parser.c"
    break;

  case 203: /* x_flag: X_WINSIZE INTEGER INTEGER  */
#line 1081 "parser.y"
                   {
                     config.X_winsize_x = (yyvsp[-1].i_value);
                     config.X_winsize_y = (yyvsp[0].i_value);
                   }
#line 4218 "parser.c"
    break;

  case 204: /* x_flag: X_WINSIZE expression ',' expression  */
#line 1086 "parser.y"
                   {
                     config.X_winsize_x = (yyvsp[-2].i_value);
                     config.X_winsize_y = (yyvsp[0].i_value);
                   }
#line 4227 "parser.c"
    break;

  case 205: /* x_flag: X_GAMMA expression  */
#line 1090 "parser.y"
                                      { config.X_gamma = (yyvsp[0].i_value); }
#line 4233 "parser.c"
    break;

  case 206: /* x_flag: X_FULLSCREEN bool  */
#line 1091 "parser.y"
                                      { config.X_fullscreen = (yyvsp[0].i_value); }
#line 4239 "parser.c"
    break;

  case 207: /* x_flag: VGAEMU_MEMSIZE expression  */
#line 1092 "parser.y"
                                                { config.vgaemu_memsize = (yyvsp[0].i_value); }
#line 4245 "parser.c"
    break;

  case 208: /* x_flag: VESAMODE INTEGER INTEGER  */
#line 1093 "parser.y"
                                           { set_vesamodes((yyvsp[-1].i_value),(yyvsp[0].i_value),0);}
#line 4251 "parser.c"
    break;

  case 209: /* x_flag: VESAMODE INTEGER INTEGER INTEGER  */
#line 1094 "parser.y"
                                                   { set_vesamodes((yyvsp[-2].i_value),(yyvsp[-1].i_value),(yyvsp[0].i_value));}
#line 4257 "parser.c"
    break;

  case 210: /* x_flag: VESAMODE expression ',' expression  */
#line 1095 "parser.y"
                                                     { set_vesamodes((yyvsp[-2].i_value),(yyvsp[0].i_value),0);}
#line 4263 "parser.c"
    break;

  case 211: /* x_flag: VESAMODE expression ',' expression ',' expression  */
#line 1097 "parser.y"
                        { set_vesamodes((yyvsp[-4].i_value),(yyvsp[-2].i_value),(yyvsp[0].i_value));}
#line 4269 "parser.c"
    break;

  case 212: /* x_flag: X_LFB bool  */
#line 1098 "parser.y"
                                        { config.X_lfb = ((yyvsp[0].i_value)!=0); }
#line 4275 "parser.c"
    break;

  case 213: /* x_flag: X_PM_INTERFACE bool  */
#line 1099 "parser.y"
                                        { config.X_pm_interface = ((yyvsp[0].i_value)!=0); }
#line 4281 "parser.c"
    break;

  case 214: /* x_flag: X_MGRAB_KEY string_expr  */
#line 1100 "parser.y"
                                          { free(config.X_mgrab_key); config.X_mgrab_key = (yyvsp[0].s_value); }
#line 4287 "parser.c"
    break;

  case 215: /* x_flag: X_BACKGROUND_PAUSE bool  */
#line 1101 "parser.y"
                                                { config.X_background_pause = ((yyvsp[0].i_value)!=0); }
#line 4293 "parser.c"
    break;

  case 218: /* sdl_flag: SDL_HWREND expression  */
#line 1108 "parser.y"
                                        { config.sdl_hwrend = ((yyvsp[0].i_value)!=0); }
#line 4299 "parser.c"
    break;

  case 219: /* sdl_flag: SDL_FONTS string_expr  */
#line 1109 "parser.y"
                                        { free(config.sdl_fonts); config.sdl_fonts = (yyvsp[0].s_value); }
#line 4305 "parser.c"
    break;

  case 222: /* sound_flag: SB_BASE expression  */
#line 1117 "parser.y"
                                        { config.sb_base = (yyvsp[0].i_value); }
#line 4311 "parser.c"
    break;

  case 223: /* sound_flag: SB_DMA expression  */
#line 1118 "parser.y"
                                        { config.sb_dma = (yyvsp[0].i_value); }
#line 4317 "parser.c"
    break;

  case 224: /* sound_flag: SB_HDMA expression  */
#line 1119 "parser.y"
                                     { config.sb_hdma = (yyvsp[0].i_value); }
#line 4323 "parser.c"
    break;

  case 225: /* sound_flag: SB_IRQ expression  */
#line 1120 "parser.y"
                                        { config.sb_irq = (yyvsp[0].i_value); }
#line 4329 "parser.c"
    break;

  case 226: /* sound_flag: MPU_BASE expression  */
#line 1121 "parser.y"
                                        { config.mpu401_base = (yyvsp[0].i_value); }
#line 4335 "parser.c"
    break;

  case 227: /* sound_flag: MIDI_SYNTH string_expr  */
#line 1122 "parser.y"
                                                { free(config.midi_synth); config.midi_synth = (yyvsp[0].s_value); }
#line 4341 "parser.c"
    break;

  case 228: /* sound_flag: MPU_IRQ int_bool  */
#line 1123 "parser.y"
                                        { config.mpu401_irq = (yyvsp[0].i_value); }
#line 4347 "parser.c"
    break;

  case 229: /* sound_flag: MPU_IRQ_MT32 expression  */
#line 1124 "parser.y"
                                                { config.mpu401_irq_mt32 = (yyvsp[0].i_value); }
#line 4353 "parser.c"
    break;

  case 230: /* sound_flag: SOUND_DRIVER string_expr  */
#line 1125 "parser.y"
                                                { free(config.sound_driver); config.sound_driver = (yyvsp[0].s_value); }
#line 4359 "parser.c"
    break;

  case 231: /* sound_flag: MIDI_DRIVER string_expr  */
#line 1126 "parser.y"
                                                { free(config.midi_driver); config.midi_driver = (yyvsp[0].s_value); }
#line 4365 "parser.c"
    break;

  case 232: /* sound_flag: MUNT_ROMS string_expr  */
#line 1128 "parser.y"
                        {
				free(config.munt_roms_dir);
				config.munt_roms_dir = concat_dir(LOCALDIR, (yyvsp[0].s_value));
				free((yyvsp[0].s_value));
			}
#line 4375 "parser.c"
    break;

  case 233: /* sound_flag: OPL2LPT_DEV string_expr  */
#line 1134 "parser.y"
                        {
				free(config.opl2lpt_device);
				config.opl2lpt_device = strlen((yyvsp[0].s_value)) ? (yyvsp[0].s_value) : NULL;
			}
#line 4384 "parser.c"
    break;

  case 234: /* sound_flag: OPL2LPT_TYPE string_expr  */
#line 1139 "parser.y"
                        {
				if (strlen((yyvsp[0].s_value)) == 4 && isdigit((yyvsp[0].s_value)[3]))
					config.opl2lpt_type = atoi((yyvsp[0].s_value) + 3) - 2;
				else
					yyerror("invalid value %s\n", (yyvsp[0].s_value));
				free((yyvsp[0].s_value));
			}
#line 4396 "parser.c"
    break;

  case 235: /* sound_flag: SND_PLUGIN_PARAMS string_expr  */
#line 1146 "parser.y"
                                                { free(config.snd_plugin_params); config.snd_plugin_params = (yyvsp[0].s_value); }
#line 4402 "parser.c"
    break;

  case 236: /* sound_flag: PCM_HPF bool  */
#line 1147 "parser.y"
                                        { config.pcm_hpf = ((yyvsp[0].i_value)!=0); }
#line 4408 "parser.c"
    break;

  case 237: /* sound_flag: MIDI_FILE string_expr  */
#line 1148 "parser.y"
                                        { free(config.midi_file); config.midi_file = (yyvsp[0].s_value); }
#line 4414 "parser.c"
    break;

  case 238: /* sound_flag: WAV_FILE string_expr  */
#line 1149 "parser.y"
                                        { free(config.wav_file); config.wav_file = (yyvsp[0].s_value); }
#line 4420 "parser.c"
    break;

  case 241: /* joystick_flag: JOY_DEVICE string_expr  */
#line 1157 "parser.y"
                                                { set_joy_device((yyvsp[0].s_value)); }
#line 4426 "parser.c"
    break;

  case 242: /* joystick_flag: JOY_DOS_MIN expression  */
#line 1158 "parser.y"
                                                { config.joy_dos_min = (yyvsp[0].i_value); }
#line 4432 "parser.c"
    break;

  case 243: /* joystick_flag: JOY_DOS_MAX expression  */
#line 1159 "parser.y"
                                                { config.joy_dos_max = (yyvsp[0].i_value); }
#line 4438 "parser.c"
    break;

  case 244: /* joystick_flag: JOY_GRANULARITY expression  */
#line 1160 "parser.y"
                                                { config.joy_granularity = (yyvsp[0].i_value); }
#line 4444 "parser.c"
    break;

  case 245: /* joystick_flag: JOY_LATENCY expression  */
#line 1161 "parser.y"
                                                { config.joy_latency = (yyvsp[0].i_value); }
#line 4450 "parser.c"
    break;

  case 248: /* video_flag: VGA  */
#line 1169 "parser.y"
                                        { config.cardtype = CARD_VGA; }
#line 4456 "parser.c"
    break;

  case 249: /* video_flag: MGA  */
#line 1170 "parser.y"
                                        { config.cardtype = CARD_MDA; }
#line 4462 "parser.c"
    break;

  case 250: /* video_flag: CGA  */
#line 1171 "parser.y"
                                        { config.cardtype = CARD_CGA; }
#line 4468 "parser.c"
    break;

  case 251: /* video_flag: EGA  */
#line 1172 "parser.y"
                                        { config.cardtype = CARD_EGA; }
#line 4474 "parser.c"
    break;

  case 252: /* video_flag: NONE  */
#line 1173 "parser.y"
                                        { config.cardtype = CARD_NONE; }
#line 4480 "parser.c"
    break;

  case 253: /* video_flag: CHIPSET CHIPSET_TYPE  */
#line 1175 "parser.y"
                    {
		    config.chipset = (yyvsp[0].i_value);
                    c_printf("CHIPSET: %d\n", (yyvsp[0].i_value));
		    }
#line 4489 "parser.c"
    break;

  case 254: /* video_flag: MEMSIZE expression  */
#line 1179 "parser.y"
                                        { config.gfxmemsize = (yyvsp[0].i_value); }
#line 4495 "parser.c"
    break;

  case 255: /* video_flag: GRAPHICS  */
#line 1181 "parser.y"
                    { config.vga = 1;
		    }
#line 4502 "parser.c"
    break;

  case 256: /* video_flag: GRAPHICS L_AUTO  */
#line 1184 "parser.y"
                    { config.vga = -1;
		    }
#line 4509 "parser.c"
    break;

  case 257: /* video_flag: CONSOLE  */
#line 1187 "parser.y"
                    { config.console_video = 1;
		    }
#line 4516 "parser.c"
    break;

  case 258: /* video_flag: CONSOLE L_AUTO  */
#line 1190 "parser.y"
                    { config.console_video = -1;
		    }
#line 4523 "parser.c"
    break;

  case 259: /* video_flag: FULLREST  */
#line 1192 "parser.y"
                                        { config.fullrestore = 1; }
#line 4529 "parser.c"
    break;

  case 260: /* video_flag: PARTREST  */
#line 1193 "parser.y"
                                        { config.fullrestore = 0; }
#line 4535 "parser.c"
    break;

  case 261: /* video_flag: VBIOS_FILE string_expr  */
#line 1194 "parser.y"
                                                { free(config.vbios_file); config.vbios_file = (yyvsp[0].s_value);
					  config.mapped_bios = 1;
					  config.vbios_copy = 0; }
#line 4543 "parser.c"
    break;

  case 262: /* video_flag: VGAEMUBIOS_FILE string_expr  */
#line 1197 "parser.y"
                                                { free(config.vgaemubios_file); config.vgaemubios_file = (yyvsp[0].s_value); }
#line 4549 "parser.c"
    break;

  case 263: /* video_flag: VBIOS_COPY  */
#line 1198 "parser.y"
                                        { free(config.vbios_file);
					  config.vbios_file = NULL;
					  config.mapped_bios = 1;
					  config.vbios_copy = 1; }
#line 4558 "parser.c"
    break;

  case 264: /* video_flag: VBIOS_MMAP  */
#line 1202 "parser.y"
                                        { free(config.vbios_file);
					  config.vbios_file = NULL;
					  config.mapped_bios = 1;
					  config.vbios_copy = 1; }
#line 4567 "parser.c"
    break;

  case 265: /* video_flag: VBIOS_SEG expression  */
#line 1207 "parser.y"
                   {
		   config.vbios_seg = (yyvsp[0].i_value);
		   c_printf("CONF: VGA-BIOS-Segment %x\n", (yyvsp[0].i_value));
		   if (((yyvsp[0].i_value) != 0xe000) && ((yyvsp[0].i_value) != 0xc000))
		      {
		      config.vbios_seg = detect_vbios_seg();
		      if (config.vbios_seg == -1) config.vbios_seg = 0xc000;
		      c_printf("CONF: VGA-BIOS-Segment set to 0x%x\n", config.vbios_seg);
		      }
		   }
#line 4582 "parser.c"
    break;

  case 266: /* video_flag: VBIOS_SIZE_TOK expression  */
#line 1218 "parser.y"
                   {
		   config.vbios_size = (yyvsp[0].i_value);
		   c_printf("CONF: VGA-BIOS-Size %x\n", (yyvsp[0].i_value));
		   if (((yyvsp[0].i_value) != 0x8000) && ((yyvsp[0].i_value) != 0x10000))
		      {
		      config.vbios_size = detect_vbios_size();
		      if (config.vbios_size == -1) config.vbios_size = 0x10000;
		      c_printf("CONF: VGA-BIOS-Size set to 0x%x\n", config.vbios_size);
		      }
		   }
#line 4597 "parser.c"
    break;

  case 267: /* video_flag: VBIOS_POST  */
#line 1228 "parser.y"
                                        { config.vbios_post = 1; }
#line 4603 "parser.c"
    break;

  case 268: /* video_flag: DUALMON  */
#line 1229 "parser.y"
                                        { config.dualmon = 1; }
#line 4609 "parser.c"
    break;

  case 269: /* video_flag: FORCE_VT_SWITCH  */
#line 1230 "parser.y"
                                        { config.force_vt_switch = 1; }
#line 4615 "parser.c"
    break;

  case 270: /* video_flag: PCI  */
#line 1231 "parser.y"
                                        { config.pci_video = 1; }
#line 4621 "parser.c"
    break;

  case 271: /* video_flag: STRING  */
#line 1233 "parser.y"
                    { yyerror("unrecognized video option '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 4628 "parser.c"
    break;

  case 275: /* term_flag: ESCCHAR expression  */
#line 1243 "parser.y"
                                           { config.term_esc_char = (yyvsp[0].i_value); }
#line 4634 "parser.c"
    break;

  case 276: /* term_flag: COLOR bool  */
#line 1244 "parser.y"
                                        { config.term_color = ((yyvsp[0].i_value)!=0); }
#line 4640 "parser.c"
    break;

  case 277: /* term_flag: SIZE string_expr  */
#line 1245 "parser.y"
                                           { free(config.term_size); config.term_size = (yyvsp[0].s_value); }
#line 4646 "parser.c"
    break;

  case 278: /* term_flag: STRING  */
#line 1247 "parser.y"
                    { yyerror("unrecognized terminal option '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 4653 "parser.c"
    break;

  case 282: /* debug_flag: VIDEO bool  */
#line 1261 "parser.y"
                                        { set_debug_level('v', ((yyvsp[0].i_value)!=0)); }
#line 4659 "parser.c"
    break;

  case 283: /* debug_flag: L_OFF  */
#line 1262 "parser.y"
                                        { set_debug_level('a', 0); }
#line 4665 "parser.c"
    break;

  case 284: /* debug_flag: SERIAL bool  */
#line 1263 "parser.y"
                                        { set_debug_level('s', ((yyvsp[0].i_value)!=0)); }
#line 4671 "parser.c"
    break;

  case 285: /* debug_flag: CONFIG bool  */
#line 1264 "parser.y"
                                        { set_debug_level('c', ((yyvsp[0].i_value)!=0)); }
#line 4677 "parser.c"
    break;

  case 286: /* debug_flag: DISK bool  */
#line 1265 "parser.y"
                                        { set_debug_level('d', ((yyvsp[0].i_value)!=0)); }
#line 4683 "parser.c"
    break;

  case 287: /* debug_flag: READ bool  */
#line 1266 "parser.y"
                                        { set_debug_level('R', ((yyvsp[0].i_value)!=0)); }
#line 4689 "parser.c"
    break;

  case 288: /* debug_flag: WRITE bool  */
#line 1267 "parser.y"
                                        { set_debug_level('W', ((yyvsp[0].i_value)!=0)); }
#line 4695 "parser.c"
    break;

  case 289: /* debug_flag: KEYB bool  */
#line 1268 "parser.y"
                                        { set_debug_level('k', ((yyvsp[0].i_value)!=0)); }
#line 4701 "parser.c"
    break;

  case 290: /* debug_flag: KEYBOARD bool  */
#line 1269 "parser.y"
                                        { set_debug_level('k', ((yyvsp[0].i_value)!=0)); }
#line 4707 "parser.c"
    break;

  case 291: /* debug_flag: PRINTER bool  */
#line 1270 "parser.y"
                                        { set_debug_level('p', ((yyvsp[0].i_value)!=0)); }
#line 4713 "parser.c"
    break;

  case 292: /* debug_flag: IO bool  */
#line 1271 "parser.y"
                                        { set_debug_level('i', ((yyvsp[0].i_value)!=0)); }
#line 4719 "parser.c"
    break;

  case 293: /* debug_flag: PORT bool  */
#line 1272 "parser.y"
                                        { set_debug_level('i', ((yyvsp[0].i_value)!=0)); }
#line 4725 "parser.c"
    break;

  case 294: /* debug_flag: WARNING bool  */
#line 1273 "parser.y"
                                        { set_debug_level('w', ((yyvsp[0].i_value)!=0)); }
#line 4731 "parser.c"
    break;

  case 295: /* debug_flag: GENERAL bool  */
#line 1274 "parser.y"
                                        { set_debug_level('g', ((yyvsp[0].i_value)!=0)); }
#line 4737 "parser.c"
    break;

  case 296: /* debug_flag: L_XMS bool  */
#line 1275 "parser.y"
                                        { set_debug_level('X', ((yyvsp[0].i_value)!=0)); }
#line 4743 "parser.c"
    break;

  case 297: /* debug_flag: L_DPMI bool  */
#line 1276 "parser.y"
                                        { set_debug_level('M', ((yyvsp[0].i_value)!=0)); }
#line 4749 "parser.c"
    break;

  case 298: /* debug_flag: MOUSE bool  */
#line 1277 "parser.y"
                                        { set_debug_level('m', ((yyvsp[0].i_value)!=0)); }
#line 4755 "parser.c"
    break;

  case 299: /* debug_flag: HARDWARE bool  */
#line 1278 "parser.y"
                                        { set_debug_level('h', ((yyvsp[0].i_value)!=0)); }
#line 4761 "parser.c"
    break;

  case 300: /* debug_flag: L_IPC bool  */
#line 1279 "parser.y"
                                        { set_debug_level('I', ((yyvsp[0].i_value)!=0)); }
#line 4767 "parser.c"
    break;

  case 301: /* debug_flag: L_EMS bool  */
#line 1280 "parser.y"
                                        { set_debug_level('E', ((yyvsp[0].i_value)!=0)); }
#line 4773 "parser.c"
    break;

  case 302: /* debug_flag: NETWORK bool  */
#line 1281 "parser.y"
                                        { set_debug_level('n', ((yyvsp[0].i_value)!=0)); }
#line 4779 "parser.c"
    break;

  case 303: /* debug_flag: L_X bool  */
#line 1282 "parser.y"
                                        { set_debug_level('X', ((yyvsp[0].i_value)!=0)); }
#line 4785 "parser.c"
    break;

  case 304: /* debug_flag: L_SDL bool  */
#line 1283 "parser.y"
                                        { set_debug_level('v', ((yyvsp[0].i_value)!=0)); }
#line 4791 "parser.c"
    break;

  case 305: /* debug_flag: SOUND bool  */
#line 1284 "parser.y"
                                        { set_debug_level('S', ((yyvsp[0].i_value)!=0)); }
#line 4797 "parser.c"
    break;

  case 306: /* debug_flag: JOYSTICK bool  */
#line 1285 "parser.y"
                                        { set_debug_level('j', ((yyvsp[0].i_value)!=0)); }
#line 4803 "parser.c"
    break;

  case 307: /* debug_flag: STRING  */
#line 1287 "parser.y"
                    { yyerror("unrecognized debug flag '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 4809 "parser.c"
    break;

  case 311: /* mouse_flag: DEVICE string_expr  */
#line 1296 "parser.y"
                                        { free(mptr->dev); mptr->dev = (yyvsp[0].s_value); }
#line 4815 "parser.c"
    break;

  case 312: /* mouse_flag: INTERNALDRIVER  */
#line 1297 "parser.y"
                                        { mptr->intdrv = TRUE; }
#line 4821 "parser.c"
    break;

  case 313: /* mouse_flag: EMULATE3BUTTONS  */
#line 1298 "parser.y"
                                        { mptr->emulate3buttons = TRUE; }
#line 4827 "parser.c"
    break;

  case 314: /* mouse_flag: BAUDRATE expression  */
#line 1299 "parser.y"
                                        { mptr->baudRate = (yyvsp[0].i_value); }
#line 4833 "parser.c"
    break;

  case 315: /* mouse_flag: CLEARDTR  */
#line 1301 "parser.y"
                    { if (mptr->dev_type == MOUSE_MOUSESYSTEMS)
			 mptr->cleardtr = TRUE;
		      else
			 yyerror("option CLEARDTR is only valid for MicroSystems-mice");
		    }
#line 4843 "parser.c"
    break;

  case 316: /* mouse_flag: MICROSOFT  */
#line 1307 "parser.y"
                  {
		  mptr->dev_type = MOUSE_MICROSOFT;
		  mptr->flags = CS7 | CREAD | CLOCAL | HUPCL;
		  }
#line 4852 "parser.c"
    break;

  case 317: /* mouse_flag: MS3BUTTON  */
#line 1312 "parser.y"
                  {
		  mptr->dev_type = MOUSE_MS3BUTTON;
		  mptr->flags = CS7 | CREAD | CLOCAL | HUPCL;
		  }
#line 4861 "parser.c"
    break;

  case 318: /* mouse_flag: MOUSESYSTEMS  */
#line 1317 "parser.y"
                  {
		  mptr->dev_type = MOUSE_MOUSESYSTEMS;
		  mptr->flags = CS8 | CREAD | CLOCAL | HUPCL;
/* is cstopb needed?  mptr->flags = CS8 | CSTOPB | CREAD | CLOCAL | HUPCL; */
		  }
#line 4871 "parser.c"
    break;

  case 319: /* mouse_flag: MMSERIES  */
#line 1323 "parser.y"
                  {
		  mptr->dev_type = MOUSE_MMSERIES;
		  mptr->flags = CS8 | PARENB | PARODD | CREAD | CLOCAL | HUPCL;
		  }
#line 4880 "parser.c"
    break;

  case 320: /* mouse_flag: LOGITECH  */
#line 1328 "parser.y"
                  {
		  mptr->dev_type = MOUSE_LOGITECH;
		  mptr->flags = CS8 | CSTOPB | CREAD | CLOCAL | HUPCL;
		  }
#line 4889 "parser.c"
    break;

  case 321: /* mouse_flag: PS2  */
#line 1333 "parser.y"
                  {
		  mptr->dev_type = MOUSE_PS2;
		  mptr->flags = 0;
		  }
#line 4898 "parser.c"
    break;

  case 322: /* mouse_flag: IMPS2  */
#line 1338 "parser.y"
                  {
		  mptr->dev_type = MOUSE_IMPS2;
		  mptr->flags = 0;
		  }
#line 4907 "parser.c"
    break;

  case 323: /* mouse_flag: MOUSEMAN  */
#line 1343 "parser.y"
                  {
		  mptr->dev_type = MOUSE_MOUSEMAN;
		  mptr->flags = CS7 | CREAD | CLOCAL | HUPCL;
		  }
#line 4916 "parser.c"
    break;

  case 324: /* mouse_flag: HITACHI  */
#line 1348 "parser.y"
                  {
		  mptr->dev_type = MOUSE_HITACHI;
		  mptr->flags = CS8 | CREAD | CLOCAL | HUPCL;
		  }
#line 4925 "parser.c"
    break;

  case 325: /* mouse_flag: BUSMOUSE  */
#line 1353 "parser.y"
                  {
		  mptr->dev_type = MOUSE_BUSMOUSE;
		  mptr->flags = 0;
		  }
#line 4934 "parser.c"
    break;

  case 326: /* mouse_flag: STRING  */
#line 1358 "parser.y"
                    { yyerror("unrecognized mouse flag '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 4940 "parser.c"
    break;

  case 330: /* keyboard_flag: LAYOUT string_expr  */
#line 1367 "parser.y"
                                        { keyb_layout((yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 4946 "parser.c"
    break;

  case 331: /* keyboard_flag: RAWKEYBOARD bool  */
#line 1368 "parser.y"
                                        { config.console_keyb = (yyvsp[0].i_value); }
#line 4952 "parser.c"
    break;

  case 332: /* keyboard_flag: STRING  */
#line 1370 "parser.y"
                    { yyerror("unrecognized keyboard flag '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value));}
#line 4959 "parser.c"
    break;

  case 336: /* $@14: %empty  */
#line 1379 "parser.y"
                                          { keyb_mod('C', (yyvsp[-1].i_value), 0); }
#line 4965 "parser.c"
    break;

  case 338: /* $@15: %empty  */
#line 1380 "parser.y"
                                               { keyb_mod('a', (yyvsp[-1].i_value), 0); }
#line 4971 "parser.c"
    break;

  case 340: /* $@16: %empty  */
#line 1381 "parser.y"
                                              { keyb_mod('c', (yyvsp[-1].i_value), 0); }
#line 4977 "parser.c"
    break;

  case 342: /* $@17: %empty  */
#line 1382 "parser.y"
                                 { keyb_mod(' ', (yyvsp[-1].i_value), 0); }
#line 4983 "parser.c"
    break;

  case 344: /* $@18: %empty  */
#line 1383 "parser.y"
                                           { keyb_mod('S', (yyvsp[-1].i_value), 0); }
#line 4989 "parser.c"
    break;

  case 346: /* $@19: %empty  */
#line 1384 "parser.y"
                                         { keyb_mod('A', (yyvsp[-1].i_value), 0); }
#line 4995 "parser.c"
    break;

  case 348: /* $@20: %empty  */
#line 1385 "parser.y"
                                            { keyb_mod('N', (yyvsp[-1].i_value), 0); }
#line 5001 "parser.c"
    break;

  case 352: /* keyboard_modval: UNICODE  */
#line 1392 "parser.y"
                          { keyb_mod(0, (yyvsp[0].i_value), 1); }
#line 5007 "parser.c"
    break;

  case 353: /* keyboard_modval: DGRAVE  */
#line 1393 "parser.y"
                         { keyb_mod(0, DKY_DEAD_GRAVE, 1); }
#line 5013 "parser.c"
    break;

  case 354: /* keyboard_modval: DACUTE  */
#line 1394 "parser.y"
                         { keyb_mod(0, DKY_DEAD_ACUTE, 1); }
#line 5019 "parser.c"
    break;

  case 355: /* keyboard_modval: DCIRCUM  */
#line 1395 "parser.y"
                          { keyb_mod(0, DKY_DEAD_CIRCUMFLEX, 1); }
#line 5025 "parser.c"
    break;

  case 356: /* keyboard_modval: DTILDE  */
#line 1396 "parser.y"
                         { keyb_mod(0, DKY_DEAD_TILDE, 1); }
#line 5031 "parser.c"
    break;

  case 357: /* keyboard_modval: DBREVE  */
#line 1397 "parser.y"
                         { keyb_mod(0, DKY_DEAD_BREVE, 1); }
#line 5037 "parser.c"
    break;

  case 358: /* keyboard_modval: DABOVED  */
#line 1398 "parser.y"
                          { keyb_mod(0, DKY_DEAD_ABOVEDOT, 1); }
#line 5043 "parser.c"
    break;

  case 359: /* keyboard_modval: DDIARES  */
#line 1399 "parser.y"
                          { keyb_mod(0, DKY_DEAD_DIAERESIS, 1); }
#line 5049 "parser.c"
    break;

  case 360: /* keyboard_modval: DABOVER  */
#line 1400 "parser.y"
                          { keyb_mod(0, DKY_DEAD_ABOVERING, 1); }
#line 5055 "parser.c"
    break;

  case 361: /* keyboard_modval: DDACUTE  */
#line 1401 "parser.y"
                          { keyb_mod(0, DKY_DEAD_DOUBLEACUTE, 1); }
#line 5061 "parser.c"
    break;

  case 362: /* keyboard_modval: DCEDILLA  */
#line 1402 "parser.y"
                           { keyb_mod(0, DKY_DEAD_CEDILLA, 1); }
#line 5067 "parser.c"
    break;

  case 363: /* keyboard_modval: DIOTA  */
#line 1403 "parser.y"
                        { keyb_mod(0, DKY_VOID, 1); }
#line 5073 "parser.c"
    break;

  case 364: /* keyboard_modval: DOGONEK  */
#line 1404 "parser.y"
                          { keyb_mod(0,DKY_DEAD_OGONEK, 1); }
#line 5079 "parser.c"
    break;

  case 365: /* keyboard_modval: DCARON  */
#line 1405 "parser.y"
                         { keyb_mod(0, DKY_DEAD_CARON, 1); }
#line 5085 "parser.c"
    break;

  case 366: /* keyboard_modval: INTEGER  */
#line 1406 "parser.y"
                          { keyb_mod(0, (yyvsp[0].i_value), 0); }
#line 5091 "parser.c"
    break;

  case 367: /* keyboard_modval: '(' expression ')'  */
#line 1407 "parser.y"
                                     { keyb_mod(0, (yyvsp[-1].i_value), 0); }
#line 5097 "parser.c"
    break;

  case 368: /* keyboard_modval: string_unquoted  */
#line 1408 "parser.y"
                                  {
			char *p = (yyvsp[0].s_value);
			while (*p) keyb_mod(0, *p++, 0);
			free((yyvsp[0].s_value));
		}
#line 5107 "parser.c"
    break;

  case 371: /* ttylocks_flag: DIRECTORY string_expr  */
#line 1420 "parser.y"
                                        { free(config.tty_lockdir); config.tty_lockdir = (yyvsp[0].s_value); }
#line 5113 "parser.c"
    break;

  case 372: /* ttylocks_flag: NAMESTUB string_expr  */
#line 1421 "parser.y"
                                        { free(config.tty_lockfile); config.tty_lockfile = (yyvsp[0].s_value); }
#line 5119 "parser.c"
    break;

  case 373: /* ttylocks_flag: BINARY  */
#line 1422 "parser.y"
                                        { config.tty_lockbinary = TRUE; }
#line 5125 "parser.c"
    break;

  case 374: /* ttylocks_flag: STRING  */
#line 1424 "parser.y"
                    { yyerror("unrecognized ttylocks flag '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5131 "parser.c"
    break;

  case 378: /* serial_flag: DEVICE string_expr  */
#line 1433 "parser.y"
                                                { free(sptr->dev); sptr->dev = (yyvsp[0].s_value); }
#line 5137 "parser.c"
    break;

  case 379: /* serial_flag: VIRTUAL  */
#line 1434 "parser.y"
                                          {
					   if (isatty(0)) {
					     sptr->virt = TRUE;
					     sptr->pseudo = TRUE;
					     no_local_video = 1;
					     sptr->dev = strdup(ttyname(0));
					   } else {
					     error("FD 0 is not a tty, can't "
					           "use a virtual com port\n");
					     exit(1);
					   }
					  }
#line 5154 "parser.c"
    break;

  case 380: /* serial_flag: PSEUDO  */
#line 1446 "parser.y"
                                          { sptr->pseudo = TRUE; }
#line 5160 "parser.c"
    break;

  case 381: /* serial_flag: VMODEM  */
#line 1447 "parser.y"
                                          { sptr->vmodem = TRUE; }
#line 5166 "parser.c"
    break;

  case 382: /* serial_flag: RTSCTS  */
#line 1448 "parser.y"
                                          { sptr->system_rtscts = TRUE; }
#line 5172 "parser.c"
    break;

  case 383: /* serial_flag: LOWLAT  */
#line 1449 "parser.y"
                                          { sptr->low_latency = TRUE; }
#line 5178 "parser.c"
    break;

  case 384: /* serial_flag: PCCOM  */
#line 1450 "parser.y"
                                          { sptr->custom = SER_CUSTOM_PCCOM; }
#line 5184 "parser.c"
    break;

  case 385: /* serial_flag: COM expression  */
#line 1451 "parser.y"
                                          { sptr->real_comport = (yyvsp[0].i_value); }
#line 5190 "parser.c"
    break;

  case 386: /* serial_flag: BASE expression  */
#line 1452 "parser.y"
                                                { sptr->base_port = (yyvsp[0].i_value); }
#line 5196 "parser.c"
    break;

  case 387: /* serial_flag: IRQ expression  */
#line 1453 "parser.y"
                                                { sptr->irq = (yyvsp[0].i_value); }
#line 5202 "parser.c"
    break;

  case 388: /* serial_flag: MOUSE  */
#line 1454 "parser.y"
                                        { sptr->mouse = 1;
					  config.num_serial_mices++; }
#line 5209 "parser.c"
    break;

  case 389: /* serial_flag: STRING  */
#line 1457 "parser.y"
                    { yyerror("unrecognized serial flag '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5215 "parser.c"
    break;

  case 393: /* printer_flag: LPT expression  */
#line 1466 "parser.y"
                                        { c_printers = (yyvsp[0].i_value) - 1; }
#line 5221 "parser.c"
    break;

  case 394: /* printer_flag: COMMAND string_expr  */
#line 1467 "parser.y"
                                        { free(pptr->prtcmd); pptr->prtcmd = (yyvsp[0].s_value); }
#line 5227 "parser.c"
    break;

  case 395: /* printer_flag: TIMEOUT expression  */
#line 1468 "parser.y"
                                        { pptr->delay = (yyvsp[0].i_value); }
#line 5233 "parser.c"
    break;

  case 396: /* printer_flag: L_FILE string_expr  */
#line 1469 "parser.y"
                                                { free(pptr->dev); pptr->dev = (yyvsp[0].s_value); }
#line 5239 "parser.c"
    break;

  case 397: /* printer_flag: BASE expression  */
#line 1470 "parser.y"
                                                { pptr->base_port = (yyvsp[0].i_value); }
#line 5245 "parser.c"
    break;

  case 398: /* printer_flag: STRING  */
#line 1472 "parser.y"
                    { yyerror("unrecognized printer flag %s", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5251 "parser.c"
    break;

  case 402: /* floppy_flag: READONLY  */
#line 1481 "parser.y"
                                        { dptr->rdonly = 1; }
#line 5257 "parser.c"
    break;

  case 403: /* floppy_flag: THREEINCH  */
#line 1482 "parser.y"
                                { dptr->default_cmos = THREE_INCH_FLOPPY; }
#line 5263 "parser.c"
    break;

  case 404: /* floppy_flag: THREEINCH_2880  */
#line 1483 "parser.y"
                                        { dptr->default_cmos = THREE_INCH_2880KFLOP; }
#line 5269 "parser.c"
    break;

  case 405: /* floppy_flag: THREEINCH_720  */
#line 1484 "parser.y"
                                { dptr->default_cmos = THREE_INCH_720KFLOP; }
#line 5275 "parser.c"
    break;

  case 406: /* floppy_flag: FIVEINCH  */
#line 1485 "parser.y"
                                { dptr->default_cmos = FIVE_INCH_FLOPPY; }
#line 5281 "parser.c"
    break;

  case 407: /* floppy_flag: FIVEINCH_360  */
#line 1486 "parser.y"
                                { dptr->default_cmos = FIVE_INCH_360KFLOP; }
#line 5287 "parser.c"
    break;

  case 408: /* floppy_flag: BOOT  */
#line 1487 "parser.y"
                                { dptr->boot = 1; }
#line 5293 "parser.c"
    break;

  case 409: /* floppy_flag: L_FLOPPY string_expr  */
#line 1489 "parser.y"
                  {
		  struct stat st;

		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a floppy-device given.");
		  if (stat((yyvsp[0].s_value), &st) < 0) {
		    yyerror("Could not stat floppy device.");
		  }
		  if (S_ISREG(st.st_mode)) {
		    dptr->type = IMAGE;
		  } else if (S_ISBLK(st.st_mode)) {
		    dptr->type = FLOPPY;
		  } else if (S_ISDIR(st.st_mode)) {
		    dptr->type = DIR_TYPE;
		  } else {
		    yyerror("Floppy device/file %s is wrong type", (yyvsp[0].s_value));
		  }
		  free(dptr->dev_name);
		  dptr->dev_name = (yyvsp[0].s_value);
		  dptr->floppy = 1;  // tell IMAGE and DIR we are a floppy
		  }
#line 5319 "parser.c"
    break;

  case 410: /* floppy_flag: DEVICE string_expr  */
#line 1511 "parser.y"
                  {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a disk-image file or device given.");
		  free(dptr->dev_name);
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5330 "parser.c"
    break;

  case 411: /* floppy_flag: DIRECTORY string_expr  */
#line 1518 "parser.y"
                  {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a directory given.");
		  dptr->type = DIR_TYPE;
		  free(dptr->dev_name);
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5342 "parser.c"
    break;

  case 412: /* floppy_flag: STRING  */
#line 1526 "parser.y"
                    { yyerror("unrecognized floppy disk flag '%s'\n", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5348 "parser.c"
    break;

  case 416: /* disk_flag: READONLY  */
#line 1533 "parser.y"
                                        { dptr->rdonly = 1; }
#line 5354 "parser.c"
    break;

  case 417: /* disk_flag: DISKCYL4096  */
#line 1534 "parser.y"
                                { dptr->diskcyl4096 = 1; }
#line 5360 "parser.c"
    break;

  case 418: /* disk_flag: HDTYPE1  */
#line 1535 "parser.y"
                                { dptr->hdtype = 1; }
#line 5366 "parser.c"
    break;

  case 419: /* disk_flag: HDTYPE2  */
#line 1536 "parser.y"
                                { dptr->hdtype = 2; }
#line 5372 "parser.c"
    break;

  case 420: /* disk_flag: HDTYPE9  */
#line 1537 "parser.y"
                                { dptr->hdtype = 9; }
#line 5378 "parser.c"
    break;

  case 421: /* disk_flag: SECTORS expression  */
#line 1538 "parser.y"
                                        { dptr->sectors = (yyvsp[0].i_value); }
#line 5384 "parser.c"
    break;

  case 422: /* disk_flag: CYLINDERS expression  */
#line 1539 "parser.y"
                                        { dptr->tracks = (yyvsp[0].i_value); }
#line 5390 "parser.c"
    break;

  case 423: /* disk_flag: TRACKS expression  */
#line 1540 "parser.y"
                                        { dptr->tracks = (yyvsp[0].i_value); }
#line 5396 "parser.c"
    break;

  case 424: /* disk_flag: HEADS expression  */
#line 1541 "parser.y"
                                                { dptr->heads = (yyvsp[0].i_value); }
#line 5402 "parser.c"
    break;

  case 425: /* disk_flag: OFFSET expression  */
#line 1542 "parser.y"
                                        { dptr->header = (yyvsp[0].i_value); }
#line 5408 "parser.c"
    break;

  case 426: /* disk_flag: DEVICE string_expr  */
#line 1544 "parser.y"
                  {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a disk-image file or device given.");
		  free(dptr->dev_name);
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5419 "parser.c"
    break;

  case 427: /* disk_flag: L_FILE string_expr  */
#line 1551 "parser.y"
                  {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a disk-image file or device given.");
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5429 "parser.c"
    break;

  case 428: /* disk_flag: HDIMAGE string_expr  */
#line 1557 "parser.y"
                  {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a harddisk-image file given.");
		  set_hdimage(dptr, (yyvsp[0].s_value));
		  }
#line 5439 "parser.c"
    break;

  case 429: /* disk_flag: WHOLEDISK STRING  */
#line 1563 "parser.y"
                  {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a harddisk given.");
		  dptr->type = HDISK;
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5450 "parser.c"
    break;

  case 430: /* disk_flag: L_PARTITION string_expr INTEGER  */
#line 1570 "parser.y"
                  {
                  yywarn("{ partition \"%s\" %d } the"
			 " token '%d' is ignored and can be removed.",
			 (yyvsp[-1].s_value),(yyvsp[0].i_value),(yyvsp[0].i_value));
		  do_part((yyvsp[-1].s_value));
		  }
#line 5461 "parser.c"
    break;

  case 431: /* disk_flag: L_PARTITION string_expr  */
#line 1577 "parser.y"
                  { do_part((yyvsp[0].s_value)); }
#line 5467 "parser.c"
    break;

  case 432: /* disk_flag: DIRECTORY string_expr  */
#line 1579 "parser.y"
                  {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a directory given.");
		  dptr->type = DIR_TYPE;
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5478 "parser.c"
    break;

  case 433: /* disk_flag: STRING  */
#line 1586 "parser.y"
                    { yyerror("unrecognized disk flag '%s'\n", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5484 "parser.c"
    break;

  case 437: /* port_flag: INTEGER  */
#line 1596 "parser.y"
                   {
		   c_printf("CONF: I/O port 0x%04x\n", (unsigned short)(yyvsp[0].i_value));
	           allow_io((yyvsp[0].i_value), 1, ports_permission, ports_ormask,
	                    ports_andmask, portspeed, (char*)dev_name);
		   if (portspeed) portspeed += ((portspeed>0) ? 1 : -1);
	           }
#line 5495 "parser.c"
    break;

  case 438: /* port_flag: '(' expression ')'  */
#line 1603 "parser.y"
                   {
	           allow_io((yyvsp[-1].i_value), 1, ports_permission, ports_ormask,
	                    ports_andmask, portspeed, (char*)dev_name);
		   if (portspeed) portspeed += ((portspeed>0) ? 1 : -1);
	           }
#line 5505 "parser.c"
    break;

  case 439: /* port_flag: RANGE INTEGER INTEGER  */
#line 1609 "parser.y"
                   {
		   if (portspeed > 1) portspeed = 0;
		   c_printf("CONF: range of I/O ports 0x%04x-0x%04x\n",
			    (unsigned short)(yyvsp[-1].i_value), (unsigned short)(yyvsp[0].i_value));
		   allow_io((yyvsp[-1].i_value), (yyvsp[0].i_value) - (yyvsp[-1].i_value) + 1, ports_permission, ports_ormask,
			    ports_andmask, portspeed, (char*)dev_name);
		   portspeed=0;
		   strcpy(dev_name,"");
		   }
#line 5519 "parser.c"
    break;

  case 440: /* port_flag: RANGE expression ',' expression  */
#line 1619 "parser.y"
                   {
		   if (portspeed > 1) portspeed = 0;
		   c_printf("CONF: range of I/O ports 0x%04x-0x%04x\n",
			    (unsigned short)(yyvsp[-2].i_value), (unsigned short)(yyvsp[0].i_value));
		   allow_io((yyvsp[-2].i_value), (yyvsp[0].i_value) - (yyvsp[-2].i_value) + 1, ports_permission, ports_ormask,
			    ports_andmask, portspeed, (char*)dev_name);
		   portspeed=0;
		   strcpy(dev_name,"");
		   }
#line 5533 "parser.c"
    break;

  case 441: /* port_flag: RDONLY  */
#line 1628 "parser.y"
                                        { ports_permission = IO_READ; }
#line 5539 "parser.c"
    break;

  case 442: /* port_flag: WRONLY  */
#line 1629 "parser.y"
                                        { ports_permission = IO_WRITE; }
#line 5545 "parser.c"
    break;

  case 443: /* port_flag: RDWR  */
#line 1630 "parser.y"
                                        { ports_permission = IO_RDWR; }
#line 5551 "parser.c"
    break;

  case 444: /* port_flag: ORMASK expression  */
#line 1631 "parser.y"
                                        { ports_ormask = (yyvsp[0].i_value); }
#line 5557 "parser.c"
    break;

  case 445: /* port_flag: ANDMASK expression  */
#line 1632 "parser.y"
                                        { ports_andmask = (yyvsp[0].i_value); }
#line 5563 "parser.c"
    break;

  case 446: /* port_flag: FAST  */
#line 1633 "parser.y"
                                        { portspeed = 1; }
#line 5569 "parser.c"
    break;

  case 447: /* port_flag: SLOW  */
#line 1634 "parser.y"
                                        { portspeed = -1; }
#line 5575 "parser.c"
    break;

  case 448: /* port_flag: DEVICE string_expr  */
#line 1635 "parser.y"
                                             { strcpy(dev_name,(yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5581 "parser.c"
    break;

  case 449: /* port_flag: STRING  */
#line 1637 "parser.y"
                    { yyerror("unrecognized port command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 5588 "parser.c"
    break;

  case 453: /* trace_port_flag: INTEGER  */
#line 1646 "parser.y"
                        { register_port_traceing((yyvsp[0].i_value), (yyvsp[0].i_value)); }
#line 5594 "parser.c"
    break;

  case 454: /* trace_port_flag: '(' expression ')'  */
#line 1648 "parser.y"
                        { register_port_traceing((yyvsp[-1].i_value), (yyvsp[-1].i_value)); }
#line 5600 "parser.c"
    break;

  case 455: /* trace_port_flag: RANGE INTEGER INTEGER  */
#line 1650 "parser.y"
                        { register_port_traceing((yyvsp[-1].i_value), (yyvsp[0].i_value)); }
#line 5606 "parser.c"
    break;

  case 456: /* trace_port_flag: RANGE expression ',' expression  */
#line 1652 "parser.y"
                        { register_port_traceing((yyvsp[-2].i_value), (yyvsp[0].i_value)); }
#line 5612 "parser.c"
    break;

  case 457: /* trace_port_flag: CLEAR  */
#line 1653 "parser.y"
                        { clear_port_traceing(); }
#line 5618 "parser.c"
    break;

  case 458: /* trace_port_flag: STRING  */
#line 1655 "parser.y"
                    { yyerror("unrecognized port trace command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 5625 "parser.c"
    break;

  case 462: /* trace_mmio_flag: INTEGER  */
#line 1666 "parser.y"
      { register_mmio_tracing((yyvsp[0].i_value), (yyvsp[0].i_value));
        c_printf("CONF: MMIO tracing registered for 0x%x\n", (yyvsp[0].i_value)); }
#line 5632 "parser.c"
    break;

  case 463: /* trace_mmio_flag: '(' expression ')'  */
#line 1669 "parser.y"
      { register_mmio_tracing((yyvsp[-1].i_value), (yyvsp[-1].i_value));
        c_printf("CONF: MMIO tracing registered for 0x%x\n", (yyvsp[-1].i_value)); }
#line 5639 "parser.c"
    break;

  case 464: /* trace_mmio_flag: RANGE INTEGER INTEGER  */
#line 1672 "parser.y"
      { register_mmio_tracing((yyvsp[-1].i_value), (yyvsp[0].i_value));
        c_printf("CONF: MMIO tracing registered for 0x%x-0x%x\n", (yyvsp[-1].i_value), (yyvsp[0].i_value)); }
#line 5646 "parser.c"
    break;

  case 465: /* trace_mmio_flag: RANGE expression ',' expression  */
#line 1675 "parser.y"
      { register_mmio_tracing((yyvsp[-2].i_value), (yyvsp[0].i_value));
        c_printf("CONF: MMIO tracing registered for 0x%x-0x%x\n", (yyvsp[-2].i_value), (yyvsp[0].i_value)); }
#line 5653 "parser.c"
    break;

  case 466: /* trace_mmio_flag: STRING  */
#line 1678 "parser.y"
       { yyerror("unrecognized mmio trace command '%s'", (yyvsp[0].s_value));
         free((yyvsp[0].s_value)); }
#line 5660 "parser.c"
    break;

  case 470: /* sillyint_flag: INTEGER  */
#line 1688 "parser.y"
                          { set_irq_value(1, (yyvsp[0].i_value)); }
#line 5666 "parser.c"
    break;

  case 471: /* sillyint_flag: '(' expression ')'  */
#line 1689 "parser.y"
                                     { set_irq_value(1, (yyvsp[-1].i_value)); }
#line 5672 "parser.c"
    break;

  case 472: /* sillyint_flag: USE_SIGIO expression  */
#line 1690 "parser.y"
                                       { set_irq_value(0x10001, (yyvsp[0].i_value)); }
#line 5678 "parser.c"
    break;

  case 473: /* sillyint_flag: RANGE INTEGER INTEGER  */
#line 1691 "parser.y"
                                        { set_irq_range(1, (yyvsp[-1].i_value), (yyvsp[0].i_value)); }
#line 5684 "parser.c"
    break;

  case 474: /* sillyint_flag: RANGE expression ',' expression  */
#line 1692 "parser.y"
                                                  { set_irq_range(1, (yyvsp[-2].i_value), (yyvsp[0].i_value)); }
#line 5690 "parser.c"
    break;

  case 475: /* sillyint_flag: USE_SIGIO RANGE INTEGER INTEGER  */
#line 1693 "parser.y"
                                                  { set_irq_range(0x10001, (yyvsp[-1].i_value), (yyvsp[0].i_value)); }
#line 5696 "parser.c"
    break;

  case 476: /* sillyint_flag: USE_SIGIO RANGE expression ',' expression  */
#line 1694 "parser.y"
                                                            { set_irq_range(0x10001, (yyvsp[-2].i_value), (yyvsp[0].i_value)); }
#line 5702 "parser.c"
    break;

  case 477: /* sillyint_flag: STRING  */
#line 1696 "parser.y"
                    { yyerror("unrecognized irqpassing command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 5709 "parser.c"
    break;

  case 481: /* ems_flag: INTEGER  */
#line 1707 "parser.y"
                   {
		     config.ems_size = (yyvsp[0].i_value);
		     if ((yyvsp[0].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[0].i_value));
	           }
#line 5718 "parser.c"
    break;

  case 482: /* ems_flag: '(' expression ')'  */
#line 1712 "parser.y"
                   {
		     config.ems_size = (yyvsp[-1].i_value);
		     if ((yyvsp[-1].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[-1].i_value));
	           }
#line 5727 "parser.c"
    break;

  case 483: /* ems_flag: EMS_SIZE expression  */
#line 1717 "parser.y"
                   {
		     config.ems_size = (yyvsp[0].i_value);
		     if ((yyvsp[0].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[0].i_value));
		   }
#line 5736 "parser.c"
    break;

  case 484: /* ems_flag: EMS_FRAME expression  */
#line 1722 "parser.y"
                   {
/* is there a technical reason why the EMS frame can't be at 0xC0000 or
   0xA0000 if there's space? */
#if 0
		     if ( (((yyvsp[0].i_value) & 0xfc00)>=0xc800) && (((yyvsp[0].i_value) & 0xfc00)<=0xe000) ) {
		       config.ems_frame = (yyvsp[0].i_value) & 0xfc00;
		       c_printf("CONF: EMS-frame = 0x%04x\n", config.ems_frame);
		     }
		     else yyerror("wrong EMS-frame: 0x%04x", (yyvsp[0].i_value));
#endif
	             config.ems_frame = (yyvsp[0].i_value) & 0xfc00;
		     c_printf("CONF: EMS-frame = 0x%04x\n", config.ems_frame);
		   }
#line 5754 "parser.c"
    break;

  case 485: /* ems_flag: EMS_UMA_PAGES expression  */
#line 1736 "parser.y"
                   {
		     config.ems_uma_pages = (yyvsp[0].i_value);
		   }
#line 5762 "parser.c"
    break;

  case 486: /* ems_flag: EMS_CONV_PAGES expression  */
#line 1740 "parser.y"
                   {
		     config.ems_cnv_pages = (yyvsp[0].i_value);
		   }
#line 5770 "parser.c"
    break;

  case 487: /* ems_flag: STRING  */
#line 1744 "parser.y"
                    { yyerror("unrecognized ems command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 5777 "parser.c"
    break;

  case 491: /* hardware_ram_flag: INTEGER  */
#line 1755 "parser.y"
                   {
                     if (!register_hardware_ram('h', (yyvsp[0].i_value), PAGE_SIZE)) {
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[0].i_value));
                     }
	           }
#line 5787 "parser.c"
    break;

  case 492: /* hardware_ram_flag: '(' expression ')'  */
#line 1761 "parser.y"
                   {
                     if (!register_hardware_ram('h', (yyvsp[-1].i_value), PAGE_SIZE)) {
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[-1].i_value));
                     }
	           }
#line 5797 "parser.c"
    break;

  case 493: /* hardware_ram_flag: RANGE INTEGER INTEGER  */
#line 1767 "parser.y"
                   {
                     if (register_hardware_ram('h', (yyvsp[-1].i_value), (yyvsp[0].i_value) - (yyvsp[-1].i_value)))
	               c_printf("CONF: hardware ram pages at 0x%08x-%08x\n", (yyvsp[-1].i_value), (yyvsp[0].i_value));
                     else
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[-1].i_value));
		   }
#line 5808 "parser.c"
    break;

  case 494: /* hardware_ram_flag: RANGE expression ',' expression  */
#line 1774 "parser.y"
                   {
                     if (register_hardware_ram('h', (yyvsp[-2].i_value), (yyvsp[0].i_value) - (yyvsp[-2].i_value)))
	               c_printf("CONF: hardware ram pages at 0x%08x-%08x\n", (yyvsp[-2].i_value), (yyvsp[0].i_value));
                     else
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[-2].i_value));
		   }
#line 5819 "parser.c"
    break;

  case 495: /* hardware_ram_flag: STRING  */
#line 1781 "parser.y"
                    { yyerror("unrecognized hardware ram command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 5826 "parser.c"
    break;

  case 499: /* int_bool: expression  */
#line 1795 "parser.y"
                {
			if ((yyvsp[0].i_value) == -2) {
				yyerror("got 'on', expected 'off' or an integer");
			}
		}
#line 5836 "parser.c"
    break;

  case 500: /* irq_bool: expression  */
#line 1802 "parser.y"
                           {
			if ( (yyvsp[0].i_value) && (((yyvsp[0].i_value) < 2) || ((yyvsp[0].i_value) > 15)) ) {
				yyerror("got '%d', expected 'off' or an integer 2..15", (yyvsp[0].i_value));
			} 
		}
#line 5846 "parser.c"
    break;

  case 501: /* speaker: L_OFF  */
#line 1811 "parser.y"
                                { (yyval.i_value) = SPKR_OFF; }
#line 5852 "parser.c"
    break;

  case 502: /* speaker: NATIVE  */
#line 1812 "parser.y"
                                { (yyval.i_value) = SPKR_NATIVE; }
#line 5858 "parser.c"
    break;

  case 503: /* speaker: EMULATED  */
#line 1813 "parser.y"
                                { (yyval.i_value) = SPKR_EMULATED; }
#line 5864 "parser.c"
    break;

  case 504: /* speaker: STRING  */
#line 1814 "parser.y"
                                { yyerror("got '%s', expected 'emulated' or 'native'", (yyvsp[0].s_value));
				  free((yyvsp[0].s_value)); }
#line 5871 "parser.c"
    break;

  case 505: /* speaker: error  */
#line 1816 "parser.y"
                                { yyerror("expected 'emulated' or 'native'"); }
#line 5877 "parser.c"
    break;

  case 506: /* cpu_vm: L_AUTO  */
#line 1819 "parser.y"
                                { (yyval.i_value) = -1; }
#line 5883 "parser.c"
    break;

  case 507: /* cpu_vm: VM86  */
#line 1820 "parser.y"
                                { (yyval.i_value) = CPUVM_VM86; }
#line 5889 "parser.c"
    break;

  case 508: /* cpu_vm: KVM  */
#line 1821 "parser.y"
                                { (yyval.i_value) = CPUVM_KVM; }
#line 5895 "parser.c"
    break;

  case 509: /* cpu_vm: EMULATED  */
#line 1822 "parser.y"
                                {
#ifdef X86_EMULATOR
				 (yyval.i_value) = CPUVM_EMU;
#else
				 yyerror("CPU emulator not compiled in");
#endif
				}
#line 5907 "parser.c"
    break;

  case 510: /* cpu_vm: STRING  */
#line 1829 "parser.y"
                                { yyerror("got '%s' for cpu_vm", (yyvsp[0].s_value));
				  free((yyvsp[0].s_value)); }
#line 5914 "parser.c"
    break;

  case 511: /* cpu_vm: error  */
#line 1831 "parser.y"
                                { yyerror("bad value for cpu_vm"); }
#line 5920 "parser.c"
    break;

  case 512: /* cpu_vm_dpmi: L_AUTO  */
#line 1834 "parser.y"
                                { (yyval.i_value) = -1; }
#line 5926 "parser.c"
    break;

  case 513: /* cpu_vm_dpmi: NATIVE  */
#line 1835 "parser.y"
                                { (yyval.i_value) = CPUVM_NATIVE; }
#line 5932 "parser.c"
    break;

  case 514: /* cpu_vm_dpmi: KVM  */
#line 1836 "parser.y"
                                { (yyval.i_value) = CPUVM_KVM; }
#line 5938 "parser.c"
    break;

  case 515: /* cpu_vm_dpmi: EMULATED  */
#line 1837 "parser.y"
                                { (yyval.i_value) = CPUVM_EMU; }
#line 5944 "parser.c"
    break;

  case 516: /* cpu_vm_dpmi: STRING  */
#line 1838 "parser.y"
                                { yyerror("got '%s' for cpu_vm_dpmi", (yyvsp[0].s_value));
				  free((yyvsp[0].s_value)); }
#line 5951 "parser.c"
    break;

  case 517: /* cpu_vm_dpmi: error  */
#line 1840 "parser.y"
                                { yyerror("bad value for cpu_vm_dpmi"); }
#line 5957 "parser.c"
    break;

  case 520: /* charset_flag: INTERNAL STRING  */
#line 1846 "parser.y"
                                  { set_internal_charset ((yyvsp[0].s_value)); }
#line 5963 "parser.c"
    break;

  case 521: /* charset_flag: EXTERNAL STRING  */
#line 1847 "parser.y"
                                  { set_external_charset ((yyvsp[0].s_value)); }
#line 5969 "parser.c"
    break;


#line 5973 "parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1850 "parser.y"


	/* features */

static void handle_features(int which, int value)
{
  if ((which < 0)
	|| (which >= (sizeof(config.features) / sizeof(config.features[0])))) {
    c_printf("CONF: wrong feature number %d\n", which);
    return;
  }
  config.features[which] = value;
  c_printf("CONF: feature %d set to %d\n", which, value);
}

	/* joystick */

static void set_joy_device(char *devstring)
{
  char *spacepos;

  free(config.joy_device[0]);
  config.joy_device[0] = devstring;
  config.joy_device[1] = NULL;
  spacepos = strchr(devstring, ' ');
  if (spacepos != NULL) {
    *spacepos = '\0';
    config.joy_device[1] = spacepos + 1;
  }
}

	/* mouse */

static void start_mouse(void)
{
  mptr = &config.mouse;
  mptr->fd = -1;
  mptr->com = -1;
  mptr->com_num = -1;
  mptr->has3buttons = 1;	// drivers can disable this
}

static void stop_mouse(void)
{
  char *p, *p1;
  if (mptr->dev && (p = strstr(mptr->dev, "com")) && strlen(p) > 3) {
    /* parse comX setting */
    if (!isdigit(p[3]) || isdigit(p[4])) {
      yyerror("wrong $_mouse_dev setting");
      return;
    }
    mptr->com_num = atoi(p + 3);
    /* see if something else is specified and remove comX */
    if (p > mptr->dev) {
      p[-1] = 0;
    } else if ((p1 = strchr(p, ','))) {
      int l;
      p1++;
      l = strlen(p1);
      memmove(mptr->dev, p1, l + 1);
    } else {
      free(mptr->dev);
      mptr->dev = NULL;
    }
    c_printf("MOUSE: using COM%i\n", mptr->com);
  }

  mptr->type = mptr->dev_type;
  c_printf("MOUSE: %s, type %x using internaldriver: %s, emulate3buttons: %s baudrate: %d\n", 
        mptr->dev && mptr->dev[0] ? mptr->dev : "no device specified",
        mptr->type, mptr->intdrv ? "yes" : "no", 
        mptr->emulate3buttons ? "yes" : "no", mptr->baudRate);
}

	/* debug */

static void start_ports(void)
{
  if (priv_lvl)
    yyerror("Can not change port privileges in user config file");
  ports_permission = IO_RDWR;
  ports_ormask = 0;
  ports_andmask = 0xFFFF;
}

	/* debug */

static void start_debug(void)
{
  set_debug_level('a', 0);	      /* Default is no debugging output at all */
}

	/* video */

static void start_video(void)
{
  free(config.vbios_file);
  config.vbios_file = NULL;
  config.vbios_copy = 0;
  config.vbios_seg  = 0xc000;
  config.vbios_size = 0x10000;
  config.console_video = 0;
  config.cardtype = CARD_NONE;
  config.chipset = PLAINVGA;
  config.mapped_bios = 0;
  config.vga = 0;
  config.gfxmemsize = 256;
  config.fullrestore = 0;
  config.dualmon = 0;
  config.force_vt_switch = 0;
}

static void stop_video(void)
{
  if (priv_lvl)
    config.console_video = 0;

  if ((config.cardtype != CARD_VGA) || !config.console_video) {
    config.vga = 0;
  }
}

	/* vesa modes */
static void set_vesamodes(int width, int height, int color_bits)
{
  vesamode_type *vmt = malloc(sizeof *vmt);
  if(vmt != NULL) {
    vmt->width = width;
    vmt->height = height;
    vmt->color_bits = color_bits;
    vmt->next = config.vesamode_list;
    config.vesamode_list = vmt;
  }
}

	/* vbios detection */
static int auto_vbios_seg = -1;
static int auto_vbios_size = -1;

static void detect_vbios(void)
{
  unsigned char c[0x21];
  int foffset;

  if (auto_vbios_seg != -1) return;
  if (!can_do_root_stuff || config.vbios_file) return;
  for (foffset = 0xc0000; foffset < 0xf0000; foffset += 0x800) {
    load_file("/dev/mem", foffset, c, sizeof(c));
    if (c[0]==0x55 && c[1]==0xaa
        && c[0x1e]=='I' && c[0x1f]=='B' && c[0x20]=='M') {
      auto_vbios_seg = foffset >> 4;
      auto_vbios_size = c[2]*0x200;
      break;
    }
  }
}

static int detect_vbios_seg(void)
{
  detect_vbios();
  return auto_vbios_seg;
}

static int detect_vbios_size(void)
{
  detect_vbios();
  return auto_vbios_size;
}

static void stop_ttylocks(void)
{
  c_printf("SER: directory %s namestub %s binary %s\n", config.tty_lockdir,
	   config.tty_lockfile,(config.tty_lockbinary?"Yes":"No"));
}

	/* serial */

static void start_serial(void)
{
  if (c_ser >= MAX_SER)
    sptr = &nullser;
  else {
    /* The defaults for interrupt, base_port, real_comport and dev are 
    ** automatically filled in inside the do_ser_init routine of serial.c
    */
    sptr = &com_cfg[c_ser];
    sptr->dev = NULL;
    sptr->irq = 0; 
    sptr->base_port = 0;
    sptr->end_port = 0;
    sptr->real_comport = 0;
    sptr->mouse = 0;
    sptr->virt = FALSE;
    sptr->pseudo = FALSE;
    sptr->system_rtscts = FALSE;
    sptr->low_latency = FALSE;
    sptr->dmx_port = 0;
    sptr->custom = SER_CUSTOM_NONE;
  }
}


static void stop_serial(void)
{
  if (c_ser >= MAX_SER) {
    c_printf("SER: too many ports, ignoring %s\n", sptr->dev);
    return;
  }
  c_printf("SER%d: %s", c_ser, sptr->dev ?: "none");
  if (sptr->base_port)
    c_printf(" port %x", sptr->base_port);
  if (sptr->irq)
    c_printf(" irq %x", sptr->irq);
  c_printf("\n");
  c_ser++;
  config.num_ser = c_ser;
}

	/* keyboard */

static int keyboard_statement_already = 0;

static void start_keyboard(void)
{
  if (!keyboard_statement_already)
    config.layout_auto = 1;
  config.console_keyb = 0;
  keyboard_statement_already = 1;
}

static void stop_terminal(void)
{
}

	/* printer */

static void start_printer(void)
{
  pptr->prtcmd = NULL;
  pptr->dev = NULL;
  pptr->remaining = -1;
  pptr->delay = 10;
}

static void stop_printer(void)
{
  printer_config(c_printers, pptr);
  c_printf("CONF(LPT%d) f: %s   c: %s  t: %d  port: %x\n",
           c_printers, pptr->dev, pptr->prtcmd,
           pptr->delay, pptr->base_port);
  c_printers++;
  if (c_printers > config.num_lpt)
    config.num_lpt = c_printers;
}

	/* disk */

static void start_floppy(void)
{
  if (c_fdisks >= MAX_FDISKS)
    {
    yyerror("There are too many floppy disks defined");
    dptr = &nulldisk;          /* Dummy-Entry to avoid core-dumps */
    }
  else
    dptr = &disktab[c_fdisks];

  dptr->sectors = 0;             /* setup default values */
  dptr->heads   = 0;
  dptr->tracks  = 0;
  dptr->type    = FLOPPY;
  dptr->default_cmos = THREE_INCH_FLOPPY;
  dptr->timeout = 0;
  dptr->dev_name = NULL;              /* default-values */
  dptr->rdonly = 0;
  dptr->header = 0;
}

static void dp_init(struct disk *dptr)
{
  dptr->type    =  NODISK;
  dptr->sectors = -1;
  dptr->heads   = -1;
  dptr->tracks  = -1;
  dptr->fdesc   = -1;
  dptr->hdtype = 0;
  dptr->timeout = 0;
  dptr->dev_name = NULL;              /* default-values */
  dptr->rdonly = 0;
  dptr->header = 0;
}

static void start_disk(void)
{
  if (c_hdisks >= MAX_HDISKS)
    {
    yyerror("There are too many hard disks defined");
    dptr = &nulldisk;          /* Dummy-Entry to avoid core-dumps */
    }
  else
    dptr = &hdisktab[c_hdisks];

  dp_init(dptr);
}

static void start_vnet(char *mode)
{
  if (strcmp(mode, "off") == 0) {
    config.vnet = VNET_TYPE_NONE;
    return;
  }
  if (strcmp(mode, "") == 0) {
    config.vnet = VNET_TYPE_AUTO;
    return;
  }
  if (strcmp(mode, "tap") == 0) {
    config.vnet = VNET_TYPE_TAP;
    return;
  }
  if (strcmp(mode, "vde") == 0) {
    config.vnet = VNET_TYPE_VDE;
    return;
  }
  if (strcmp(mode, "slirp") == 0) {
    config.vnet = VNET_TYPE_SLIRP;
    return;
  }
  if (strcmp(mode, "eth") == 0)
    config.vnet = VNET_TYPE_ETH;
  else {
    error("Unknown vnet mode \"%s\"\n", mode);
    config.exitearly = 1;
  }
}

static void do_part(char *dev)
{
  if (dptr->dev_name != NULL)
    yyerror("Two names for a partition given.");
  dptr->type = PARTITION;
  free(dptr->dev_name);
  dptr->dev_name = dev;
#ifdef __linux__
  dptr->part_info.number = atoi(dptr->dev_name+8);
#endif
  if (dptr->part_info.number == 0)
    yyerror("%s must be a PARTITION, can't find number suffix!\n",
	    dptr->dev_name);
}

static void stop_disk(int token)
{
#ifdef __linux__
  FILE   *f;
  struct mntent *mtab;
  int    mounted_rw;
#endif

  if (dptr == &nulldisk)              /* is there any disk? */
    return;                           /* no, nothing to do */

  if (!dptr->dev_name) {               /* Is there a file/device-name? */
    if (token == L_FLOPPY)
      error("floppy %c: no device/file-name given!\n", 'A'+c_fdisks);
    else
      error("drive %c: no device/file-name given!\n", 'C'+c_hdisks);
    return;
  } else {                               /* check the file/device for existance */
      struct stat st;

      if (stat(dptr->dev_name, &st) != 0) { /* Does this file exist? */
        yyerror("disk: device/file %s doesn't exist.", dptr->dev_name);
      }
    }

  if (dptr->type == NODISK)    /* Is it one of image, floppy, harddisk ? */
    yyerror("disk: no device/file-name given!"); /* No, error */
  else
    c_printf("CONF: disk type '%s'", disk_t_str(dptr->type));

  if (dptr->type == PARTITION) {
    c_printf(" partition# %d", dptr->part_info.number);
#ifdef __linux__
    mtab = NULL;
    if ((f = setmntent(MOUNTED, "r")) != NULL) {
      while ((mtab = getmntent(f)))
        if (!strcmp(dptr->dev_name, mtab->mnt_fsname)) break;
      endmntent(f);
    }
    if (mtab) {
      mounted_rw = ( hasmntopt(mtab, MNTOPT_RW) != NULL );
      if (mounted_rw && !dptr->rdonly) 
        yyerror("\n\nYou specified '%s' for read-write Direct Partition Access,"
                "\nit is currently mounted read-write on '%s' !!!\n",
                dptr->dev_name, mtab->mnt_dir);
      else if (mounted_rw) 
        yywarn("You specified '%s' for read-only Direct Partition Access,"
               "\n         it is currently mounted read-write on '%s'.\n",
               dptr->dev_name, mtab->mnt_dir);
      else if (!dptr->rdonly) 
        yywarn("You specified '%s' for read-write Direct Partition Access,"
               "\n         it is currently mounted read-only on '%s'.\n",
               dptr->dev_name, mtab->mnt_dir);
    }
#endif
  }

  if (dptr->type == IMAGE) {
    char buf[HEADER_SIZE];
    struct image_header *header = (struct image_header *)&buf;
    int fd;

    dptr->header = 0;

    fd = open(dptr->dev_name, O_RDONLY);
    if (fd != -1) {
      if (read(fd, &buf, sizeof buf) == HEADER_SIZE) {
        if (memcmp(header->sig, IMAGE_MAGIC, IMAGE_MAGIC_SIZE) == 0)
          dptr->header = header->header_end;
        c_printf(" header_size: %ld", (long)dptr->header);
      }
      close(fd);
    }
  }

  if (dptr->type == DIR_TYPE)
    dptr->mfs_idx = mfs_define_drive(dptr->dev_name);
  else
    dptr->mfs_idx = 0;

  if (token == L_FLOPPY) {
    c_printf(" floppy %c:\n", 'A'+c_fdisks);
    disktab[c_fdisks].drive_num = c_fdisks;
    c_fdisks++;
  }
  else {
    c_printf(" drive %c:\n", 'C'+c_hdisks);
    hdisktab[c_hdisks].drive_num = (c_hdisks | 0x80);
    hdisktab[c_hdisks].log_offs = skipped_disks;
    c_hdisks++;
  }
}

	/* keyboard */

static void do_keyb_layout(const char *layout, int alt)
{
  struct keytable_entry *kt = keytable_list;

  while (kt->name) {
    if (strcmp(kt->name, layout) == 0) {
      if (alt) {
        c_printf("CONF: Alternate keyboard-layout %s\n", kt->name);
        config.altkeytable = kt;
      } else {
        c_printf("CONF: Keyboard-layout %s\n", kt->name);
        config.keytable = kt;
      }
      config.layout_auto = 0;
      return;
    }
    kt++;
  }
  yyerror("CONF: ERROR -- Keyboard has incorrect layout %s\n", layout);
}

static void keyb_layout(char *layout)
{
  char *p = layout;
  char *p1;

  if (strcmp(p, "auto") == 0) {
    /* auto: do it later */
    config.keytable = NULL;
    config.layout_auto = 1;
    return;
  }
  while ((p1 = strsep(&p, ",")))
    do_keyb_layout(p1, p1 != layout);
}

static void keytable_start(char *layout)
{
  keyboard_statement_already = 1;
  /* switch to builtin layout, then apply mods */
  keyb_layout(layout);
}

static void keytable_stop(void)
{
}

static void dump_keytables_to_file(char *name)
{
  FILE * f;
  struct keytable_entry *kt = keytable_list;

  f = fopen(name, "w");
  if (!f) {
    error("cannot create keytable file %s\n", name);
    exit(1);
  }
  
  while (kt->name) {
    dump_keytable(f, kt);
    kt++;
  }
  fclose(f);
  exit(0);
}

static void set_irq_value(int bits, int i1)
{
  if ((i1>2) && (i1<=15)) {
    config.sillyint |= (bits << i1);
    c_printf("CONF: IRQ %d for irqpassing", i1);
    if (bits & 0x10000)  c_printf(" uses SIGIO\n");
    else c_printf("\n");
  }
  else yyerror("wrong IRQ for irqpassing command: %d", i1);
}

static void set_irq_range(int bits, int i1, int i2) {
  int i;
  if ( (i1<3) || (i1>15) || (i2<3) || (i2>15) || (i1 > i2 ) ) {
    yyerror("wrong IRQ range for irqpassing command: %d .. %d", i1, i2);
  }
  else {
    for (i=i1; i<=i2; i++) config.sillyint |= (bits << i);
    c_printf("CONF: range of IRQs for irqpassing %d .. %d", i1, i2);
    if (bits & 0x10000)  c_printf(" uses SIGIO\n");
    else c_printf("\n");
  }
}


	/* errors & warnings */

void yywarn(const char *string, ...)
{
  va_list vars;
  error("@Warning: ");
  va_start(vars, string);
  vprint(string, vars);
  va_end(vars);
  error("@\n");
  warnings++;
}

void yyerror(const char *string, ...)
{
  va_list vars;
  va_start(vars, string);
  if (include_stack_ptr != 0 && !last_include) {
	  int i;
	  error("@In file included from %s:%d\n",
		  include_fnames[0], include_lines[0]);
	  for(i = 1; i < include_stack_ptr; i++) {
		  error("@                 from %s:%d\n",
			  include_fnames[i], include_lines[i]);
	  }
	  last_include = 1;
  }
  error("@Error in %s: (line %.3d) ", 
	  include_fnames[include_stack_ptr], line_count);
  vprint(string, vars);
  error("@\n");
  va_end(vars);
  errors++;
}


/*
 * open_file - opens the configuration-file named *filename and returns
 *             a file-pointer. The error/warning-counters are reset to zero.
 */

static FILE *open_file(const char *filename)
{
  errors   = 0;                  /* Reset error counter */
  warnings = 0;                  /* Reset counter for warnings */

  if (!filename) return 0;
  return fopen(filename, "re"); /* Open config-file */
}

/*
 * close_file - Close the configuration file and issue a message about
 *              errors/warnings that occured. If there were errors, the
 *              flag early-exit is that, so dosemu won't really.
 */

static void close_file(FILE * file)
{
  if (file) fclose(file);                  /* Close the config-file */

  if(errors)
    error("@%d error(s) detected while parsing the configuration-file\n",
	    errors);
  if(warnings)
    error("@%d warning(s) detected while parsing the configuration-file\n",
	    warnings);

  if (errors != 0)               /* Exit dosemu on errors */
    {
      config.exitearly = TRUE;
    }
  errors = 0;
  warnings = 0;
}

static void set_hdimage(struct disk *dptr, char *name)
{
  char *l = strstr(name, ".lnk");

  c_printf("Setting up hdimage %s\n", name);
  if (l && strlen(l) == 4) {
    const char *tmpl = "eval echo -n `cat %s`";
    char *cmd, path[1024], *rname;
    FILE *f;
    size_t ret;

    asprintf(&cmd, tmpl, name);
    free(name);
    f = popen(cmd, "r");
    free(cmd);
    ret = fread(path, 1, sizeof(path), f);
    pclose(f);
    if (ret == 0)
      return;
    path[ret] = '\0';
    c_printf("Link resolved to %s\n", path);
    rname = expand_path(path);
    if (access(rname, R_OK) != 0) {
      warn("hdimage: %s does not exist\n", rname);
      free(rname);
      return;
    }
    free(dptr->dev_name);
    dptr->dev_name = rname;
    dptr->type = DIR_TYPE;
    c_printf("Set up as a directory\n");
    return;
  }
  dptr->type = IMAGE;
  free(dptr->dev_name);
  dptr->dev_name = name;
  c_printf("Set up as an image\n");
}

static int add_drive(const char *name, int rdonly)
{
  struct disk *dptr = &hdisktab[c_hdisks];
  char *rname = expand_path(name);
  if (access(rname, R_OK) != 0) {
    free(rname);
    return -1;
  }
  dp_init(dptr);
  dptr->dev_name = rname;
  dptr->type = DIR_TYPE;
  dptr->rdonly = rdonly;
  dptr->drive_num = (c_hdisks | 0x80);
  dptr->log_offs = skipped_disks;
  dptr->mfs_idx = mfs_define_drive(rname);
  c_printf("Added drive %i (%x): %s\n", c_hdisks, dptr->drive_num, name);
  c_hdisks++;
  return 0;
}

static void set_drive_c(void)
{
  int err;

  c_printf("Setting up drive C, %s\n", dosemu_drive_c_path);
  if (!config.alt_drv_c && !exists_dir(dosemu_drive_c_path)) {
    char *system_str;
    c_printf("Creating default drive C\n");
    err = asprintf(&system_str, "mkdir -p %s/tmp", dosemu_drive_c_path);
    assert(err != -1);
    err = system(system_str);
    free(system_str);
    if (err) {
      error("unable to create %s\n", dosemu_drive_c_path);
      return;
    }
  }
  if (config.alt_drv_c && c_hdisks) {
    error("wrong mapping of Group 0 to %c\n", 'C' + c_hdisks);
    dosemu_drive_c_path = DRIVE_C_DEFAULT;
    config.alt_drv_c = 0;
  }
  config.drive_c_num = c_hdisks | 0x80;
  err = add_drive(dosemu_drive_c_path, 0);
  assert(!err);
}

static void set_dosemu_drive(void)
{
  if (!commands_path) {
    error("can't map utility drive, dosemu2 installation incomplete\n");
    leavedos(3);
    return;
  }
  add_drive(commands_path, 1);
}

static void set_default_drives(void)
{
#define AD(p) do { \
    if (p) \
      add_drive(p, 1); \
} while (0)
  c_printf("Setting up default drives from %c\n", 'C' + c_hdisks);
  if (config.try_freedos) {
    AD(fddir_boot);
    AD(fddir_default);
  } else {
    AD(comcom_dir);
    AD(xbat_dir);
  }
}

static void set_hostfs_drives(char *drivespec)
{
  char *p;
  int err;

  while ((p = strsep(&drivespec, " "))) {
    int ro = 0;
    int cd = 0;
    int grp = 0;
    char *d = strchr(p, ':');
    if (d) {
      switch (d[1]) {
	case 'r':
	    ro++;
	    break;
	case 'c':
	    cd++;
	    break;
	case 'g':
	    grp++;
	    break;
      }
      *d = '\0';
    }
    err = add_extra_drive(p, ro, cd, grp);
    if (err)
	config.exitearly = 1;
  }
}

/* Parse TimeMode, Paul Crawford and Andrew Brooks 2004-08-01 */
/* Accepts "bios", "pit", "linux", default is "bios". Use with TIMEMODE token */
int parse_timemode(const char *timemodestr)
{
   if (timemodestr == NULL || timemodestr[0] == '\0')
     return(TM_BIOS); /* default */
   if (strcmp(timemodestr, "linux")==0)
     return(TM_LINUX);
   if (strcmp(timemodestr, "pit")==0)
     return(TM_PIT);
   if (strcmp(timemodestr, "bios")==0)
     return(TM_BIOS);
   yyerror("Unrecognised time mode (not bios, pit or linux)");
   return(TM_BIOS);
}

char *commandline_statements;

static void do_parse(FILE *fp, const char *confname, const char *errtx)
{
  yyin = fp;
  line_count = 1;
  include_stack_ptr = 0;
  c_printf("CONF: Parsing %s file.\n", confname);
  file_being_parsed = strdup(confname);
  include_fnames[include_stack_ptr] = file_being_parsed;
  yyrestart(fp);
  if (yyparse())
    yyerror(errtx, confname);
  close_file(fp);
  include_stack_ptr = 0;
  include_fnames[include_stack_ptr] = 0;
  free(file_being_parsed);
}

int parse_config(const char *confname, const char *dosrcname)
{
  FILE *fd;
#if YYDEBUG != 0
  yydebug  = 1;
#endif

  define_config_variable(PARSER_VERSION_STRING);

  /* privileged options allowed? */
  priv_lvl = !under_root_login && can_do_root_stuff;

  define_config_variable("c_system");

  yy_vbuffer = dosemu_conf;
  do_parse(NULL, "built-in dosemu.conf", "error in built-in dosemu.conf");
  if (confname) {
    yy_vbuffer = NULL;
    fd = open_file(confname);
    if (!fd) {
      fprintf(stderr, "Cannot open base config file %s, Aborting DOSEMU.\n", confname);
      exit(1);
    }
    do_parse(fd, confname, "error in configuration file %s");
  }
  if (dosrcname) {
    define_config_variable("c_user");
    yy_vbuffer = NULL;
    fd = open_file(dosrcname);
    if (!fd) {
      fprintf(stderr, "Cannot open base config file %s, Aborting DOSEMU.\n", dosrcname);
      exit(1);
    }
    do_parse(fd, dosrcname, "error in configuration file %s");
  }
  yy_vbuffer = global_conf;
  do_parse(NULL, "built-in global.conf", "error in built-in global.conf");

  undefine_config_variable("c_system");

  /* Now we parse any commandline statements from option '-I'
   * We do this under priv_lvl set above, so we have the same secure level
   * as with .dosrc
   */

  if (commandline_statements) {
      #define XX_NAME "commandline"

      open_file(0);
      define_config_variable("c_comline");
      c_printf("Parsing " XX_NAME  " statements.\n");
      yyin=0;				 /* say: we have no input file */
      yy_vbuffer=commandline_statements; /* this is the input to scan */
      do_parse(0, XX_NAME, "error in user's %s statement");
      undefine_config_variable("c_comline");
  }

#ifdef TESTING
  error("TESTING: parser is terminating program\n");
  exit(0);
#endif
  return 1;
}

#define MAX_CONFIGVARIABLES 128
char *config_variables[MAX_CONFIGVARIABLES+1] = {0};
static int config_variables_count = 0;
static int config_variables_last = 0;


char *get_config_variable(const char *name)
{
  int i;
  for (i=0; i< config_variables_count; i++) {
    if (!strcmp(name, config_variables[i])) {
      config_variables_last = i;
      return config_variables[i];
    }
  }
  return 0;
}

int define_config_variable(const char *name)
{
  if (priv_lvl) {
    if (strcmp(name, CONFNAME_V3USED) && strncmp(name, "u_", 2)) {
      c_printf("CONF: not enough privilege to define config variable %s\n", name);
      return 0;
    }
  }
  if (!get_config_variable(name)) {
    if (config_variables_count < MAX_CONFIGVARIABLES) {
      config_variables[config_variables_count++] = strdup(name);
    }
    else {
      c_printf("CONF: overflow on config variable list\n");
      return 0;
    }
  }
  c_printf("CONF: config variable %s set\n", name);
  return 1;
}

static int undefine_config_variable(const char *name)
{
  if (priv_lvl) {
    if (strncmp(name, "u_", 2)) {
      c_printf("CONF: not enough privilege to undefine config variable %s\n", name);
      return 0;
    }
  }
  if (get_config_variable(name)) {
    int i;
    if (!strcmp(name, CONFNAME_V3USED)) parser_version_3_style_used = 0;
    free(config_variables[config_variables_last]);
    for (i=config_variables_last; i<(config_variables_count-1); i++) {
      config_variables[i] = config_variables[i+1];
    }
    config_variables_count--;
    c_printf("CONF: config variable %s unset\n", name);
    return 1;
  }
  return 0;
}

char *checked_getenv(const char *name)
{
  return getenv(name);
}

static void check_user_var(char *name)
{
	char *name_;
	char *s;

	name_ = malloc(strlen(name)+sizeof(USERVAR_PREF));
	strcpy(name_, USERVAR_PREF);
	strcat(name_, name);
	s = getenv(name_);
	if (s) {
		if (getenv(name))
			c_printf("CONF: variable %s replaced by user\n", name);
		setenv(name, s, 1);
		unsetenv(name_);
	}
	free(name_);
}


static char *run_shell(char *command)
{
	int pipefds[2];
	pid_t pid;
	char excode[16] = "1";

	setenv("DOSEMU_SHELL_RETURN", excode, 1);
	if (pipe(pipefds)) return strdup("");
	pid = fork();
	if (pid == -1) return strdup("");
	if (!pid) {
		/* child */
		int ret;
		close(pipefds[0]);	/* we won't read from the pipe */
		dup2(pipefds[1], 1);	/* make the pipe child's stdout */
		priv_drop();	/* drop any priviledges */
		ret = system(command);
			/* tell the parent: "we have finished",
			 * this way we need not to play games with select()
			 */
		if (ret == -1) ret = errno;
		else ret >>=8;
		write(pipefds[1],"\0\0\0",4);
		close(pipefds[1]);
		_exit(ret);
	}
	else {
		/* parent */
		char *buf = 0;
		int recsize = 128;
		int bufsize = 0;
		int ptr =0;
		int ret;
		int status;

		close(pipefds[1]);	/* we won't write to the pipe */
		do {
			bufsize = ptr + recsize;
			if (!buf) buf = malloc(bufsize);
			else buf = realloc(buf, bufsize);
			ret = read(pipefds[0], buf+ptr, recsize -1);
			if (ret > 0) {
				ptr += ret;
			}
		} while (ret >0 && (ret < 4 || memcmp(buf+ptr-4,"\0\0\0",4)));
		close(pipefds[0]);
		waitpid(pid, &status, 0);
		buf[ptr] = 0;
		if (!buf[0]) {
			free(buf);
			buf = strdup("");
		}
		sprintf(excode, "%d", WEXITSTATUS(status));
		setenv("DOSEMU_SHELL_RETURN", excode, 1);
		return buf;
	}
}


struct for_each_entry {
	char *list;
	char *ptr;
	int skip_restart;
};

#define FOR_EACH_DEPTH	16
static struct for_each_entry *for_each_list = 0;

static int for_each_handling(int loopid, char *varname, char *delim, char *list)
{
	struct for_each_entry *fe;
	char * _new;
	char saved;
	if (!for_each_list) {
		int size = FOR_EACH_DEPTH * sizeof(struct for_each_entry);
		for_each_list = malloc(size);
		memset(for_each_list, 0, size);
	}
	if (loopid > FOR_EACH_DEPTH) {
		yyerror("too deeply nested foreach\n");
		return 0;
	}
	fe = for_each_list + loopid;
	if (!fe->list) {
		/* starting the loop */
		fe->ptr = fe->list = strdup(list);
		fe->skip_restart = 0;
		if (loopid) {
			/* in inner loops we need to skip the restart */
			fe->skip_restart = 1;
		}
	}
	else {
		if (fe->skip_restart) {
			fe->skip_restart = 0;
			return 1;
		}
	}
	while (fe->ptr[0] && strchr(delim,fe->ptr[0])) fe->ptr++;
	/* subsequent call */
	if (!fe->ptr[0]) {
		/* loop end */
		free(fe->list);
		fe->list = 0;
		return (0);
	}
	_new = strpbrk(fe->ptr, delim);
	if (!_new) _new = strchr(fe->ptr,0);
	saved = *_new;
	*_new = 0;
	setenv(varname,fe->ptr,1);
	if (saved) _new++;
	fe->ptr = _new;
	return (1);
}

#ifdef TESTING_MAIN

static void die(char *reason)
{
  error("par dead: %s\n", reason);
  exit(0);
}

int
main(int argc, char **argv)
{
  if (argc != 2)
    die("no filename!");

  if (!parse_config(argv[1], argv[2] /* will be NULL if not given */))
    die("parse failed!\n");
}

#endif

/* for keyboard plugin */



static void keyb_mod(int wich, t_keysym keynum, int unicode)
{
	static t_keysym *table = 0;
	static int count = 0;

	if (wich == ' ') {
		switch (keynum & 0xFF00) {
		case 0x000: wich = ' '; break;
		case 0x100: wich = 'S'; break;
		case 0x200: wich = 'A'; break;
		case 0x300: wich = 'N'; break;
		case 0x400: wich = 'C'; break;
		case 0x500: wich = 'a'; break;
		case 0x600: wich = 'c'; break;
		default: 
			/* It's a bad value ditch it */
			wich ='X'; table = 0; count = 0; break;
		}
		keynum &= 0xFF;
	}

	switch (wich) {
	case ' ': table = config.keytable->key_map;
		count=config.keytable->sizemap;
		break;
	case 'S': table = config.keytable->shift_map;
		count=config.keytable->sizemap;
		break;
	case 'A': table = config.keytable->alt_map;
		count=config.keytable->sizemap;
		break;
	case 'C': table = config.keytable->ctrl_map;
		count=config.keytable->sizemap;
		break;
	case 'a': table = config.keytable->shift_alt_map;
		count=config.keytable->sizemap;
		break;
	case 'c': table = config.keytable->ctrl_alt_map;
		count=config.keytable->sizemap;
		break;
	case 'N': table = config.keytable->num_table;
		count=config.keytable->sizepad;
		break;
	}


	if (!table || (count == 0) || (wich != 0 && keynum >= count)) {
		count = 0;
		table = 0;
		return;
	}
	if (wich != 0) {
		table += keynum;
		count -= keynum;
		return;
	}
	if (!unicode) {
		if (keynum == 0) {
			keynum = DKY_VOID;
		} else {
			keynum = keynum + 0xEF00;
		}
	}
	if (count > 0) {
		*table++ = keynum;
		count--;
	}
}


static const char *get_key_name(t_keysym key)
{
	struct key_names {
		t_keysym key;
		const char *name;
	};
	static struct key_names names[] =
	{
		{ DKY_DEAD_GRAVE,	"dgrave"},
		{ DKY_DEAD_ACUTE,	"dacute"},
		{ DKY_DEAD_CIRCUMFLEX,	"dcircum"},
		{ DKY_DEAD_TILDE,	"dtilde"},
		{ DKY_DEAD_BREVE,	"dbreve"},
		{ DKY_DEAD_ABOVEDOT,	"daboved"},
		{ DKY_DEAD_DIAERESIS,	"ddiares"},
		{ DKY_DEAD_ABOVERING,	"dabover"},
		{ DKY_DEAD_DOUBLEACUTE,	"ddacute"},
		{ DKY_DEAD_CEDILLA,	"dcedilla"},
		{ DKY_DEAD_OGONEK,	"dogonek"},
		{ DKY_DEAD_CARON,	"dcaron"},
	};
	int i;
	for(i = 0; i < sizeof(names)/sizeof(names[0]); i++) {
		if (names[i].key == key) {
			return names[i].name;
		}
	}
	return 0;
}

static void dump_keytable_part(FILE *f, t_keysym *map, int size)
{
  int i, in_string=0;
  t_keysym c;
  const char *cc; 
  char comma=' ', buf[16];

  /* Note: This code assumes every font is a superset of ascii */
  if (!map) {
	  return;
  }
  size--;
  for (i=0; i<=size; i++) {
    c = map[i];
    if (!(i & 15)) fprintf(f,"    ");
    cc = get_key_name(c);
    if (!cc && (c < 128) && isprint(c) && !strchr("\\\"\'`", c)) {
      if (in_string) fputc(c,f);
      else {
        fprintf(f, "%c\"%c", comma, c);
        in_string = 1;
      }
    }
    else {
      if (!cc) {
	if (((c > 0) && (c < 128)) || ((c >= 0xEF00) && (c <= 0xEFFF))) {
	  sprintf(buf, "%d", c & 0xFF);
	} else if (c == DKY_VOID) {
	  strcpy(buf, "0");
	} else {
	  sprintf(buf, "\\u%04x", c);
	}
	cc = buf;
      }
      if (!in_string) fprintf(f, "%c%s", comma, cc);
      else {
        fprintf(f, "\",%s", cc);
        in_string = 0;
      }
    }
    if ((i & 15) == 15) {
      if (in_string) fputc('"', f);
      if (i < size) fputc(',', f);
      fputc('\n', f);
      in_string = 0;
      comma = ' ';
    }
    else comma = ',';
  }
  if (in_string) fputc('"', f);
  fputc('\n', f);
}


void dump_keytable(FILE *f, struct keytable_entry *kt)
{
    fprintf(f, "keytable %s {\n", kt->name);
    fprintf(f, "  0=\n");
    dump_keytable_part(f, kt->key_map, kt->sizemap);
    fprintf(f, "  shift 0=\n");
    dump_keytable_part(f, kt->shift_map, kt->sizemap);
    fprintf(f, "  alt 0=\n");
    dump_keytable_part(f, kt->alt_map, kt->sizemap);
    fprintf(f, "  numpad 0=\n");
    dump_keytable_part(f, kt->num_table, kt->sizepad-1);
    fprintf(f, "  ctrl 0=\n");
    dump_keytable_part(f, kt->ctrl_map, kt->sizemap);
    fprintf(f, "  shift-alt 0=\n");
    dump_keytable_part(f, kt->shift_alt_map, kt->sizemap);
    fprintf(f, "  ctrl-alt 0=\n");
    dump_keytable_part(f, kt->ctrl_alt_map, kt->sizemap);
    fprintf(f, "}\n\n\n");
}
